package io.spine.users;

import com.google.errorprone.annotations.CanIgnoreReturnValue;
import com.google.protobuf.Descriptors;
import io.spine.base.ConversionException;
import io.spine.net.EmailAddress;
import io.spine.net.Url;
import io.spine.people.PersonName;
import io.spine.validate.AbstractValidatingBuilder;
import io.spine.validate.ValidationException;
import java.util.Map;
import javax.annotation.Generated;

@Generated("by Spine Model Compiler")
public final class PersonProfileVBuilder extends AbstractValidatingBuilder<PersonProfile, PersonProfile.Builder> {
    private PersonProfileVBuilder() {
    }

    public static PersonProfileVBuilder newBuilder() {
        return new PersonProfileVBuilder();
    }

    @CanIgnoreReturnValue
    public PersonProfileVBuilder setEmail(EmailAddress email) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.PersonProfile.getDescriptor().getFields().get(0);
        validateSetOnce(fieldDescriptor, email);
        validate(fieldDescriptor, email, "email");
        getMessageBuilder().setEmail(email);
        return this;
    }

    @CanIgnoreReturnValue
    public PersonProfileVBuilder setRawEmail(String email) throws ValidationException,
            ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.PersonProfile.getDescriptor().getFields().get(0);
        io.spine.net.EmailAddress convertedEmail = convert(email, io.spine.net.EmailAddress.class);
        validateSetOnce(fieldDescriptor, convertedEmail);
        validate(fieldDescriptor, convertedEmail, "email");
        getMessageBuilder().setEmail(convertedEmail);
        return this;
    }

    public EmailAddress getEmail() {
        return getMessageBuilder().getEmail();
    }

    @CanIgnoreReturnValue
    public PersonProfileVBuilder clearEmail() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.PersonProfile.getDescriptor().getFields().get(0);
        validateSetOnce(fieldDescriptor, io.spine.users.PersonProfile.getDefaultInstance().getEmail());
        getMessageBuilder().clearEmail();
        return this;
    }

    @CanIgnoreReturnValue
    public PersonProfileVBuilder setName(PersonName name) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.PersonProfile.getDescriptor().getFields().get(1);
        validateSetOnce(fieldDescriptor, name);
        validate(fieldDescriptor, name, "name");
        getMessageBuilder().setName(name);
        return this;
    }

    @CanIgnoreReturnValue
    public PersonProfileVBuilder setRawName(String name) throws ValidationException,
            ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.PersonProfile.getDescriptor().getFields().get(1);
        io.spine.people.PersonName convertedName = convert(name, io.spine.people.PersonName.class);
        validateSetOnce(fieldDescriptor, convertedName);
        validate(fieldDescriptor, convertedName, "name");
        getMessageBuilder().setName(convertedName);
        return this;
    }

    public PersonName getName() {
        return getMessageBuilder().getName();
    }

    @CanIgnoreReturnValue
    public PersonProfileVBuilder clearName() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.PersonProfile.getDescriptor().getFields().get(1);
        validateSetOnce(fieldDescriptor, io.spine.users.PersonProfile.getDefaultInstance().getName());
        getMessageBuilder().clearName();
        return this;
    }

    @CanIgnoreReturnValue
    public PersonProfileVBuilder setAvatar(Url avatar) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.PersonProfile.getDescriptor().getFields().get(2);
        validateSetOnce(fieldDescriptor, avatar);
        validate(fieldDescriptor, avatar, "avatar");
        getMessageBuilder().setAvatar(avatar);
        return this;
    }

    @CanIgnoreReturnValue
    public PersonProfileVBuilder setRawAvatar(String avatar) throws ValidationException,
            ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.PersonProfile.getDescriptor().getFields().get(2);
        io.spine.net.Url convertedAvatar = convert(avatar, io.spine.net.Url.class);
        validateSetOnce(fieldDescriptor, convertedAvatar);
        validate(fieldDescriptor, convertedAvatar, "avatar");
        getMessageBuilder().setAvatar(convertedAvatar);
        return this;
    }

    public Url getAvatar() {
        return getMessageBuilder().getAvatar();
    }

    @CanIgnoreReturnValue
    public PersonProfileVBuilder clearAvatar() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.PersonProfile.getDescriptor().getFields().get(2);
        validateSetOnce(fieldDescriptor, io.spine.users.PersonProfile.getDefaultInstance().getAvatar());
        getMessageBuilder().clearAvatar();
        return this;
    }

    @Override
    @CanIgnoreReturnValue
    public PersonProfileVBuilder mergeFrom(PersonProfile message) {
        Map<Descriptors.FieldDescriptor, Object> fieldsMap = message.getAllFields();
        for (Map.Entry<Descriptors.FieldDescriptor, Object> entry : fieldsMap.entrySet()) {
            validateSetOnce(entry.getKey(), entry.getValue());
        }
        super.mergeFrom(message);
        return this;
    }
}
