package io.spine.users.google.group.event;

import com.google.errorprone.annotations.CanIgnoreReturnValue;
import com.google.protobuf.Descriptors;
import io.spine.base.ConversionException;
import io.spine.net.EmailAddress;
import io.spine.net.InternetDomain;
import io.spine.users.GoogleGroupId;
import io.spine.users.GroupId;
import io.spine.validate.AbstractValidatingBuilder;
import io.spine.validate.ValidationException;
import java.util.List;
import java.util.Map;
import javax.annotation.Generated;

@Generated("by Spine Model Compiler")
public final class GoogleGroupCreatedVBuilder extends AbstractValidatingBuilder<GoogleGroupCreated, GoogleGroupCreated.Builder> {
    private GoogleGroupCreatedVBuilder() {
    }

    public static GoogleGroupCreatedVBuilder newBuilder() {
        return new GoogleGroupCreatedVBuilder();
    }

    @CanIgnoreReturnValue
    public GoogleGroupCreatedVBuilder setId(GroupId id) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.google.group.event.GoogleGroupCreated.getDescriptor().getFields().get(0);
        validateSetOnce(fieldDescriptor, id);
        validate(fieldDescriptor, id, "id");
        getMessageBuilder().setId(id);
        return this;
    }

    @CanIgnoreReturnValue
    public GoogleGroupCreatedVBuilder setRawId(String id) throws ValidationException,
            ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.google.group.event.GoogleGroupCreated.getDescriptor().getFields().get(0);
        io.spine.users.GroupId convertedId = convert(id, io.spine.users.GroupId.class);
        validateSetOnce(fieldDescriptor, convertedId);
        validate(fieldDescriptor, convertedId, "id");
        getMessageBuilder().setId(convertedId);
        return this;
    }

    public GroupId getId() {
        return getMessageBuilder().getId();
    }

    @CanIgnoreReturnValue
    public GoogleGroupCreatedVBuilder clearId() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.google.group.event.GoogleGroupCreated.getDescriptor().getFields().get(0);
        validateSetOnce(fieldDescriptor, io.spine.users.google.group.event.GoogleGroupCreated.getDefaultInstance().getId());
        getMessageBuilder().clearId();
        return this;
    }

    @CanIgnoreReturnValue
    public GoogleGroupCreatedVBuilder setGoogleId(GoogleGroupId googleId) throws
            ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.google.group.event.GoogleGroupCreated.getDescriptor().getFields().get(1);
        validateSetOnce(fieldDescriptor, googleId);
        validate(fieldDescriptor, googleId, "googleId");
        getMessageBuilder().setGoogleId(googleId);
        return this;
    }

    @CanIgnoreReturnValue
    public GoogleGroupCreatedVBuilder setRawGoogleId(String googleId) throws ValidationException,
            ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.google.group.event.GoogleGroupCreated.getDescriptor().getFields().get(1);
        io.spine.users.GoogleGroupId convertedGoogleId = convert(googleId, io.spine.users.GoogleGroupId.class);
        validateSetOnce(fieldDescriptor, convertedGoogleId);
        validate(fieldDescriptor, convertedGoogleId, "googleId");
        getMessageBuilder().setGoogleId(convertedGoogleId);
        return this;
    }

    public GoogleGroupId getGoogleId() {
        return getMessageBuilder().getGoogleId();
    }

    @CanIgnoreReturnValue
    public GoogleGroupCreatedVBuilder clearGoogleId() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.google.group.event.GoogleGroupCreated.getDescriptor().getFields().get(1);
        validateSetOnce(fieldDescriptor, io.spine.users.google.group.event.GoogleGroupCreated.getDefaultInstance().getGoogleId());
        getMessageBuilder().clearGoogleId();
        return this;
    }

    @CanIgnoreReturnValue
    public GoogleGroupCreatedVBuilder setDisplayName(String displayName) throws
            ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.google.group.event.GoogleGroupCreated.getDescriptor().getFields().get(2);
        validateSetOnce(fieldDescriptor, displayName);
        validate(fieldDescriptor, displayName, "displayName");
        getMessageBuilder().setDisplayName(displayName);
        return this;
    }

    public String getDisplayName() {
        return getMessageBuilder().getDisplayName();
    }

    @CanIgnoreReturnValue
    public GoogleGroupCreatedVBuilder clearDisplayName() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.google.group.event.GoogleGroupCreated.getDescriptor().getFields().get(2);
        validateSetOnce(fieldDescriptor, io.spine.users.google.group.event.GoogleGroupCreated.getDefaultInstance().getDisplayName());
        getMessageBuilder().clearDisplayName();
        return this;
    }

    @CanIgnoreReturnValue
    public GoogleGroupCreatedVBuilder setEmail(EmailAddress email) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.google.group.event.GoogleGroupCreated.getDescriptor().getFields().get(3);
        validateSetOnce(fieldDescriptor, email);
        validate(fieldDescriptor, email, "email");
        getMessageBuilder().setEmail(email);
        return this;
    }

    @CanIgnoreReturnValue
    public GoogleGroupCreatedVBuilder setRawEmail(String email) throws ValidationException,
            ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.google.group.event.GoogleGroupCreated.getDescriptor().getFields().get(3);
        io.spine.net.EmailAddress convertedEmail = convert(email, io.spine.net.EmailAddress.class);
        validateSetOnce(fieldDescriptor, convertedEmail);
        validate(fieldDescriptor, convertedEmail, "email");
        getMessageBuilder().setEmail(convertedEmail);
        return this;
    }

    public EmailAddress getEmail() {
        return getMessageBuilder().getEmail();
    }

    @CanIgnoreReturnValue
    public GoogleGroupCreatedVBuilder clearEmail() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.google.group.event.GoogleGroupCreated.getDescriptor().getFields().get(3);
        validateSetOnce(fieldDescriptor, io.spine.users.google.group.event.GoogleGroupCreated.getDefaultInstance().getEmail());
        getMessageBuilder().clearEmail();
        return this;
    }

    @CanIgnoreReturnValue
    public GoogleGroupCreatedVBuilder setDescription(String description) throws
            ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.google.group.event.GoogleGroupCreated.getDescriptor().getFields().get(4);
        validateSetOnce(fieldDescriptor, description);
        validate(fieldDescriptor, description, "description");
        getMessageBuilder().setDescription(description);
        return this;
    }

    public String getDescription() {
        return getMessageBuilder().getDescription();
    }

    @CanIgnoreReturnValue
    public GoogleGroupCreatedVBuilder clearDescription() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.google.group.event.GoogleGroupCreated.getDescriptor().getFields().get(4);
        validateSetOnce(fieldDescriptor, io.spine.users.google.group.event.GoogleGroupCreated.getDefaultInstance().getDescription());
        getMessageBuilder().clearDescription();
        return this;
    }

    public List<EmailAddress> getAlias() {
        return getMessageBuilder().getAliasList();
    }

    @CanIgnoreReturnValue
    public GoogleGroupCreatedVBuilder clearAlias() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.google.group.event.GoogleGroupCreated.getDescriptor().getFields().get(5);
        checkNotSetOnce(fieldDescriptor);
        getMessageBuilder().clearAlias();
        return this;
    }

    @CanIgnoreReturnValue
    public GoogleGroupCreatedVBuilder addAlias(EmailAddress value) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.google.group.event.GoogleGroupCreated.getDescriptor().getFields().get(5);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, value, "alias");
        getMessageBuilder().addAlias(value);
        return this;
    }

    @CanIgnoreReturnValue
    public GoogleGroupCreatedVBuilder setAlias(int index, EmailAddress value) throws
            ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.google.group.event.GoogleGroupCreated.getDescriptor().getFields().get(5);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, value, "alias");
        getMessageBuilder().setAlias(index, value);
        return this;
    }

    @CanIgnoreReturnValue
    public GoogleGroupCreatedVBuilder addAllAlias(List<EmailAddress> value) throws
            ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.google.group.event.GoogleGroupCreated.getDescriptor().getFields().get(5);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, value, "alias");
        getMessageBuilder().addAllAlias(value);
        return this;
    }

    @CanIgnoreReturnValue
    public GoogleGroupCreatedVBuilder addAlias(int index, EmailAddress value) throws
            ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.google.group.event.GoogleGroupCreated.getDescriptor().getFields().get(5);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, value, "alias");
        getMessageBuilder().addAlias(index, value);
        return this;
    }

    @CanIgnoreReturnValue
    public GoogleGroupCreatedVBuilder removeAlias(int index) {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.google.group.event.GoogleGroupCreated.getDescriptor().getFields().get(5);
        checkNotSetOnce(fieldDescriptor);
        getMessageBuilder().removeAlias(index);
        return this;
    }

    @CanIgnoreReturnValue
    public GoogleGroupCreatedVBuilder addRawAlias(String value) throws ValidationException,
            ConversionException {
        io.spine.net.EmailAddress convertedValue = convert(value, io.spine.net.EmailAddress.class);
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.google.group.event.GoogleGroupCreated.getDescriptor().getFields().get(5);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, convertedValue, "alias");
        getMessageBuilder().addAlias(convertedValue);
        return this;
    }

    @CanIgnoreReturnValue
    public GoogleGroupCreatedVBuilder setRawAlias(int index, String value) throws
            ValidationException, ConversionException {
        io.spine.net.EmailAddress convertedValue = convert(value, io.spine.net.EmailAddress.class);
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.google.group.event.GoogleGroupCreated.getDescriptor().getFields().get(5);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, convertedValue, "alias");
        getMessageBuilder().setAlias(index, convertedValue);
        return this;
    }

    @CanIgnoreReturnValue
    public GoogleGroupCreatedVBuilder addAllRawAlias(String value) throws ValidationException,
            ConversionException {
        final List<EmailAddress> convertedValue = convertToList(value, EmailAddress.class);
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.google.group.event.GoogleGroupCreated.getDescriptor().getFields().get(5);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, convertedValue, "alias");
        getMessageBuilder().addAllAlias(convertedValue);
        return this;
    }

    @CanIgnoreReturnValue
    public GoogleGroupCreatedVBuilder addRawAlias(int index, String value) throws
            ValidationException, ConversionException {
        io.spine.net.EmailAddress convertedValue = convert(value, io.spine.net.EmailAddress.class);
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.google.group.event.GoogleGroupCreated.getDescriptor().getFields().get(5);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, convertedValue, "alias");
        getMessageBuilder().addAlias(index, convertedValue);
        return this;
    }

    @CanIgnoreReturnValue
    public GoogleGroupCreatedVBuilder setDomain(InternetDomain domain) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.google.group.event.GoogleGroupCreated.getDescriptor().getFields().get(6);
        validateSetOnce(fieldDescriptor, domain);
        validate(fieldDescriptor, domain, "domain");
        getMessageBuilder().setDomain(domain);
        return this;
    }

    @CanIgnoreReturnValue
    public GoogleGroupCreatedVBuilder setRawDomain(String domain) throws ValidationException,
            ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.google.group.event.GoogleGroupCreated.getDescriptor().getFields().get(6);
        io.spine.net.InternetDomain convertedDomain = convert(domain, io.spine.net.InternetDomain.class);
        validateSetOnce(fieldDescriptor, convertedDomain);
        validate(fieldDescriptor, convertedDomain, "domain");
        getMessageBuilder().setDomain(convertedDomain);
        return this;
    }

    public InternetDomain getDomain() {
        return getMessageBuilder().getDomain();
    }

    @CanIgnoreReturnValue
    public GoogleGroupCreatedVBuilder clearDomain() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.google.group.event.GoogleGroupCreated.getDescriptor().getFields().get(6);
        validateSetOnce(fieldDescriptor, io.spine.users.google.group.event.GoogleGroupCreated.getDefaultInstance().getDomain());
        getMessageBuilder().clearDomain();
        return this;
    }

    @Override
    @CanIgnoreReturnValue
    public GoogleGroupCreatedVBuilder mergeFrom(GoogleGroupCreated message) {
        Map<Descriptors.FieldDescriptor, Object> fieldsMap = message.getAllFields();
        for (Map.Entry<Descriptors.FieldDescriptor, Object> entry : fieldsMap.entrySet()) {
            validateSetOnce(entry.getKey(), entry.getValue());
        }
        super.mergeFrom(message);
        return this;
    }
}
