// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: spine/users/group/group.proto

package io.spine.users.group;

/**
 * <pre>
 * A `Group` is a way to group users by their common functions and functional roles inside of
 * an organization or organizational unit.
 * The roles, assigned to a `Group` are implicitly inherited by all members of the group,
 * including sub-groups.
 * ## Usage Example
 * For example, a software development department of a company may well have the following groups:
 * * Developers
 *      ```
 *      {
 *          display_name: "Developers",
 *          email: "developers&#64;department.company.com",
 *          role: ["github-contributor", "test-server-admin"],
 *      }
 *      ```
 * * Support Engineers
 *      ```
 *      {
 *          display_name: "Support Team",
 *          email: "support&#64;department.company.com",
 *          role: ["bugtracker-contributor"],
 *      }
 *      ```
 * </pre>
 *
 * Protobuf type {@code spine.users.group.Group}
 */
public  final class Group extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:spine.users.group.Group)
    GroupOrBuilder {
private static final long serialVersionUID = 0L;
  // Use Group.newBuilder() to construct.
  private Group(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private Group() {
    displayName_ = "";
    description_ = "";
    role_ = java.util.Collections.emptyList();
  }

  @java.lang.Override
  public final com.google.protobuf.UnknownFieldSet
  getUnknownFields() {
    return this.unknownFields;
  }
  private Group(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    this();
    if (extensionRegistry == null) {
      throw new java.lang.NullPointerException();
    }
    int mutable_bitField0_ = 0;
    com.google.protobuf.UnknownFieldSet.Builder unknownFields =
        com.google.protobuf.UnknownFieldSet.newBuilder();
    try {
      boolean done = false;
      while (!done) {
        int tag = input.readTag();
        switch (tag) {
          case 0:
            done = true;
            break;
          case 10: {
            io.spine.users.GroupId.Builder subBuilder = null;
            if (id_ != null) {
              subBuilder = id_.toBuilder();
            }
            id_ = input.readMessage(io.spine.users.GroupId.parser(), extensionRegistry);
            if (subBuilder != null) {
              subBuilder.mergeFrom(id_);
              id_ = subBuilder.buildPartial();
            }

            break;
          }
          case 18: {
            java.lang.String s = input.readStringRequireUtf8();

            displayName_ = s;
            break;
          }
          case 26: {
            io.spine.net.EmailAddress.Builder subBuilder = null;
            if (email_ != null) {
              subBuilder = email_.toBuilder();
            }
            email_ = input.readMessage(io.spine.net.EmailAddress.parser(), extensionRegistry);
            if (subBuilder != null) {
              subBuilder.mergeFrom(email_);
              email_ = subBuilder.buildPartial();
            }

            break;
          }
          case 34: {
            java.lang.String s = input.readStringRequireUtf8();

            description_ = s;
            break;
          }
          case 42: {
            io.spine.users.OrganizationOrUnit.Builder subBuilder = null;
            if (originCase_ == 5) {
              subBuilder = ((io.spine.users.OrganizationOrUnit) origin_).toBuilder();
            }
            origin_ =
                input.readMessage(io.spine.users.OrganizationOrUnit.parser(), extensionRegistry);
            if (subBuilder != null) {
              subBuilder.mergeFrom((io.spine.users.OrganizationOrUnit) origin_);
              origin_ = subBuilder.buildPartial();
            }
            originCase_ = 5;
            break;
          }
          case 50: {
            io.spine.net.InternetDomain.Builder subBuilder = null;
            if (originCase_ == 6) {
              subBuilder = ((io.spine.net.InternetDomain) origin_).toBuilder();
            }
            origin_ =
                input.readMessage(io.spine.net.InternetDomain.parser(), extensionRegistry);
            if (subBuilder != null) {
              subBuilder.mergeFrom((io.spine.net.InternetDomain) origin_);
              origin_ = subBuilder.buildPartial();
            }
            originCase_ = 6;
            break;
          }
          case 58: {
            if (!((mutable_bitField0_ & 0x00000040) == 0x00000040)) {
              role_ = new java.util.ArrayList<io.spine.users.RoleId>();
              mutable_bitField0_ |= 0x00000040;
            }
            role_.add(
                input.readMessage(io.spine.users.RoleId.parser(), extensionRegistry));
            break;
          }
          default: {
            if (!parseUnknownFieldProto3(
                input, unknownFields, extensionRegistry, tag)) {
              done = true;
            }
            break;
          }
        }
      }
    } catch (com.google.protobuf.InvalidProtocolBufferException e) {
      throw e.setUnfinishedMessage(this);
    } catch (java.io.IOException e) {
      throw new com.google.protobuf.InvalidProtocolBufferException(
          e).setUnfinishedMessage(this);
    } finally {
      if (((mutable_bitField0_ & 0x00000040) == 0x00000040)) {
        role_ = java.util.Collections.unmodifiableList(role_);
      }
      this.unknownFields = unknownFields.build();
      makeExtensionsImmutable();
    }
  }
  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return io.spine.users.group.GroupProto.internal_static_spine_users_group_Group_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return io.spine.users.group.GroupProto.internal_static_spine_users_group_Group_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            io.spine.users.group.Group.class, io.spine.users.group.Group.Builder.class);
  }

  private int bitField0_;
  private int originCase_ = 0;
  private java.lang.Object origin_;
  public enum OriginCase
      implements com.google.protobuf.Internal.EnumLite {
    ORG_ENTITY(5),
    EXTERNAL_DOMAIN(6),
    ORIGIN_NOT_SET(0);
    private final int value;
    private OriginCase(int value) {
      this.value = value;
    }
    /**
     * @deprecated Use {@link #forNumber(int)} instead.
     */
    @java.lang.Deprecated
    public static OriginCase valueOf(int value) {
      return forNumber(value);
    }

    public static OriginCase forNumber(int value) {
      switch (value) {
        case 5: return ORG_ENTITY;
        case 6: return EXTERNAL_DOMAIN;
        case 0: return ORIGIN_NOT_SET;
        default: return null;
      }
    }
    public int getNumber() {
      return this.value;
    }
  };

  public OriginCase
  getOriginCase() {
    return OriginCase.forNumber(
        originCase_);
  }

  public static final int ID_FIELD_NUMBER = 1;
  private io.spine.users.GroupId id_;
  /**
   * <code>.spine.users.GroupId id = 1;</code>
   */
  public boolean hasId() {
    return id_ != null;
  }
  /**
   * <code>.spine.users.GroupId id = 1;</code>
   */
  public io.spine.users.GroupId getId() {
    return id_ == null ? io.spine.users.GroupId.getDefaultInstance() : id_;
  }
  /**
   * <code>.spine.users.GroupId id = 1;</code>
   */
  public io.spine.users.GroupIdOrBuilder getIdOrBuilder() {
    return getId();
  }

  public static final int DISPLAY_NAME_FIELD_NUMBER = 2;
  private volatile java.lang.Object displayName_;
  /**
   * <pre>
   * A name of a group to display on UI.
   * </pre>
   *
   * <code>string display_name = 2 [(.required) = true];</code>
   */
  public java.lang.String getDisplayName() {
    java.lang.Object ref = displayName_;
    if (ref instanceof java.lang.String) {
      return (java.lang.String) ref;
    } else {
      com.google.protobuf.ByteString bs = 
          (com.google.protobuf.ByteString) ref;
      java.lang.String s = bs.toStringUtf8();
      displayName_ = s;
      return s;
    }
  }
  /**
   * <pre>
   * A name of a group to display on UI.
   * </pre>
   *
   * <code>string display_name = 2 [(.required) = true];</code>
   */
  public com.google.protobuf.ByteString
      getDisplayNameBytes() {
    java.lang.Object ref = displayName_;
    if (ref instanceof java.lang.String) {
      com.google.protobuf.ByteString b = 
          com.google.protobuf.ByteString.copyFromUtf8(
              (java.lang.String) ref);
      displayName_ = b;
      return b;
    } else {
      return (com.google.protobuf.ByteString) ref;
    }
  }

  public static final int EMAIL_FIELD_NUMBER = 3;
  private io.spine.net.EmailAddress email_;
  /**
   * <pre>
   * An email address of the group if applicable.
   * The email address may be used to send messages to all the group members.
   * </pre>
   *
   * <code>.spine.net.EmailAddress email = 3;</code>
   */
  public boolean hasEmail() {
    return email_ != null;
  }
  /**
   * <pre>
   * An email address of the group if applicable.
   * The email address may be used to send messages to all the group members.
   * </pre>
   *
   * <code>.spine.net.EmailAddress email = 3;</code>
   */
  public io.spine.net.EmailAddress getEmail() {
    return email_ == null ? io.spine.net.EmailAddress.getDefaultInstance() : email_;
  }
  /**
   * <pre>
   * An email address of the group if applicable.
   * The email address may be used to send messages to all the group members.
   * </pre>
   *
   * <code>.spine.net.EmailAddress email = 3;</code>
   */
  public io.spine.net.EmailAddressOrBuilder getEmailOrBuilder() {
    return getEmail();
  }

  public static final int DESCRIPTION_FIELD_NUMBER = 4;
  private volatile java.lang.Object description_;
  /**
   * <pre>
   * A human-friendly description of a group.
   * </pre>
   *
   * <code>string description = 4;</code>
   */
  public java.lang.String getDescription() {
    java.lang.Object ref = description_;
    if (ref instanceof java.lang.String) {
      return (java.lang.String) ref;
    } else {
      com.google.protobuf.ByteString bs = 
          (com.google.protobuf.ByteString) ref;
      java.lang.String s = bs.toStringUtf8();
      description_ = s;
      return s;
    }
  }
  /**
   * <pre>
   * A human-friendly description of a group.
   * </pre>
   *
   * <code>string description = 4;</code>
   */
  public com.google.protobuf.ByteString
      getDescriptionBytes() {
    java.lang.Object ref = description_;
    if (ref instanceof java.lang.String) {
      com.google.protobuf.ByteString b = 
          com.google.protobuf.ByteString.copyFromUtf8(
              (java.lang.String) ref);
      description_ = b;
      return b;
    } else {
      return (com.google.protobuf.ByteString) ref;
    }
  }

  public static final int ORG_ENTITY_FIELD_NUMBER = 5;
  /**
   * <pre>
   * An organization or orgunit in one of the tenant's domains.
   * </pre>
   *
   * <code>.spine.users.OrganizationOrUnit org_entity = 5;</code>
   */
  public boolean hasOrgEntity() {
    return originCase_ == 5;
  }
  /**
   * <pre>
   * An organization or orgunit in one of the tenant's domains.
   * </pre>
   *
   * <code>.spine.users.OrganizationOrUnit org_entity = 5;</code>
   */
  public io.spine.users.OrganizationOrUnit getOrgEntity() {
    if (originCase_ == 5) {
       return (io.spine.users.OrganizationOrUnit) origin_;
    }
    return io.spine.users.OrganizationOrUnit.getDefaultInstance();
  }
  /**
   * <pre>
   * An organization or orgunit in one of the tenant's domains.
   * </pre>
   *
   * <code>.spine.users.OrganizationOrUnit org_entity = 5;</code>
   */
  public io.spine.users.OrganizationOrUnitOrBuilder getOrgEntityOrBuilder() {
    if (originCase_ == 5) {
       return (io.spine.users.OrganizationOrUnit) origin_;
    }
    return io.spine.users.OrganizationOrUnit.getDefaultInstance();
  }

  public static final int EXTERNAL_DOMAIN_FIELD_NUMBER = 6;
  /**
   * <pre>
   * An external domain.
   * </pre>
   *
   * <code>.spine.net.InternetDomain external_domain = 6;</code>
   */
  public boolean hasExternalDomain() {
    return originCase_ == 6;
  }
  /**
   * <pre>
   * An external domain.
   * </pre>
   *
   * <code>.spine.net.InternetDomain external_domain = 6;</code>
   */
  public io.spine.net.InternetDomain getExternalDomain() {
    if (originCase_ == 6) {
       return (io.spine.net.InternetDomain) origin_;
    }
    return io.spine.net.InternetDomain.getDefaultInstance();
  }
  /**
   * <pre>
   * An external domain.
   * </pre>
   *
   * <code>.spine.net.InternetDomain external_domain = 6;</code>
   */
  public io.spine.net.InternetDomainOrBuilder getExternalDomainOrBuilder() {
    if (originCase_ == 6) {
       return (io.spine.net.InternetDomain) origin_;
    }
    return io.spine.net.InternetDomain.getDefaultInstance();
  }

  public static final int ROLE_FIELD_NUMBER = 7;
  private java.util.List<io.spine.users.RoleId> role_;
  /**
   * <pre>
   * Roles explicitly assigned to the group.
   * </pre>
   *
   * <code>repeated .spine.users.RoleId role = 7;</code>
   */
  public java.util.List<io.spine.users.RoleId> getRoleList() {
    return role_;
  }
  /**
   * <pre>
   * Roles explicitly assigned to the group.
   * </pre>
   *
   * <code>repeated .spine.users.RoleId role = 7;</code>
   */
  public java.util.List<? extends io.spine.users.RoleIdOrBuilder> 
      getRoleOrBuilderList() {
    return role_;
  }
  /**
   * <pre>
   * Roles explicitly assigned to the group.
   * </pre>
   *
   * <code>repeated .spine.users.RoleId role = 7;</code>
   */
  public int getRoleCount() {
    return role_.size();
  }
  /**
   * <pre>
   * Roles explicitly assigned to the group.
   * </pre>
   *
   * <code>repeated .spine.users.RoleId role = 7;</code>
   */
  public io.spine.users.RoleId getRole(int index) {
    return role_.get(index);
  }
  /**
   * <pre>
   * Roles explicitly assigned to the group.
   * </pre>
   *
   * <code>repeated .spine.users.RoleId role = 7;</code>
   */
  public io.spine.users.RoleIdOrBuilder getRoleOrBuilder(
      int index) {
    return role_.get(index);
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (id_ != null) {
      output.writeMessage(1, getId());
    }
    if (!getDisplayNameBytes().isEmpty()) {
      com.google.protobuf.GeneratedMessageV3.writeString(output, 2, displayName_);
    }
    if (email_ != null) {
      output.writeMessage(3, getEmail());
    }
    if (!getDescriptionBytes().isEmpty()) {
      com.google.protobuf.GeneratedMessageV3.writeString(output, 4, description_);
    }
    if (originCase_ == 5) {
      output.writeMessage(5, (io.spine.users.OrganizationOrUnit) origin_);
    }
    if (originCase_ == 6) {
      output.writeMessage(6, (io.spine.net.InternetDomain) origin_);
    }
    for (int i = 0; i < role_.size(); i++) {
      output.writeMessage(7, role_.get(i));
    }
    unknownFields.writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (id_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getId());
    }
    if (!getDisplayNameBytes().isEmpty()) {
      size += com.google.protobuf.GeneratedMessageV3.computeStringSize(2, displayName_);
    }
    if (email_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(3, getEmail());
    }
    if (!getDescriptionBytes().isEmpty()) {
      size += com.google.protobuf.GeneratedMessageV3.computeStringSize(4, description_);
    }
    if (originCase_ == 5) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(5, (io.spine.users.OrganizationOrUnit) origin_);
    }
    if (originCase_ == 6) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(6, (io.spine.net.InternetDomain) origin_);
    }
    for (int i = 0; i < role_.size(); i++) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(7, role_.get(i));
    }
    size += unknownFields.getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof io.spine.users.group.Group)) {
      return super.equals(obj);
    }
    io.spine.users.group.Group other = (io.spine.users.group.Group) obj;

    boolean result = true;
    result = result && (hasId() == other.hasId());
    if (hasId()) {
      result = result && getId()
          .equals(other.getId());
    }
    result = result && getDisplayName()
        .equals(other.getDisplayName());
    result = result && (hasEmail() == other.hasEmail());
    if (hasEmail()) {
      result = result && getEmail()
          .equals(other.getEmail());
    }
    result = result && getDescription()
        .equals(other.getDescription());
    result = result && getRoleList()
        .equals(other.getRoleList());
    result = result && getOriginCase().equals(
        other.getOriginCase());
    if (!result) return false;
    switch (originCase_) {
      case 5:
        result = result && getOrgEntity()
            .equals(other.getOrgEntity());
        break;
      case 6:
        result = result && getExternalDomain()
            .equals(other.getExternalDomain());
        break;
      case 0:
      default:
    }
    result = result && unknownFields.equals(other.unknownFields);
    return result;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasId()) {
      hash = (37 * hash) + ID_FIELD_NUMBER;
      hash = (53 * hash) + getId().hashCode();
    }
    hash = (37 * hash) + DISPLAY_NAME_FIELD_NUMBER;
    hash = (53 * hash) + getDisplayName().hashCode();
    if (hasEmail()) {
      hash = (37 * hash) + EMAIL_FIELD_NUMBER;
      hash = (53 * hash) + getEmail().hashCode();
    }
    hash = (37 * hash) + DESCRIPTION_FIELD_NUMBER;
    hash = (53 * hash) + getDescription().hashCode();
    if (getRoleCount() > 0) {
      hash = (37 * hash) + ROLE_FIELD_NUMBER;
      hash = (53 * hash) + getRoleList().hashCode();
    }
    switch (originCase_) {
      case 5:
        hash = (37 * hash) + ORG_ENTITY_FIELD_NUMBER;
        hash = (53 * hash) + getOrgEntity().hashCode();
        break;
      case 6:
        hash = (37 * hash) + EXTERNAL_DOMAIN_FIELD_NUMBER;
        hash = (53 * hash) + getExternalDomain().hashCode();
        break;
      case 0:
      default:
    }
    hash = (29 * hash) + unknownFields.hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static io.spine.users.group.Group parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static io.spine.users.group.Group parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static io.spine.users.group.Group parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static io.spine.users.group.Group parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static io.spine.users.group.Group parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static io.spine.users.group.Group parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static io.spine.users.group.Group parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static io.spine.users.group.Group parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static io.spine.users.group.Group parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static io.spine.users.group.Group parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static io.spine.users.group.Group parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static io.spine.users.group.Group parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(io.spine.users.group.Group prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * A `Group` is a way to group users by their common functions and functional roles inside of
   * an organization or organizational unit.
   * The roles, assigned to a `Group` are implicitly inherited by all members of the group,
   * including sub-groups.
   * ## Usage Example
   * For example, a software development department of a company may well have the following groups:
   * * Developers
   *      ```
   *      {
   *          display_name: "Developers",
   *          email: "developers&#64;department.company.com",
   *          role: ["github-contributor", "test-server-admin"],
   *      }
   *      ```
   * * Support Engineers
   *      ```
   *      {
   *          display_name: "Support Team",
   *          email: "support&#64;department.company.com",
   *          role: ["bugtracker-contributor"],
   *      }
   *      ```
   * </pre>
   *
   * Protobuf type {@code spine.users.group.Group}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:spine.users.group.Group)
      io.spine.users.group.GroupOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return io.spine.users.group.GroupProto.internal_static_spine_users_group_Group_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return io.spine.users.group.GroupProto.internal_static_spine_users_group_Group_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              io.spine.users.group.Group.class, io.spine.users.group.Group.Builder.class);
    }

    // Construct using io.spine.users.group.Group.newBuilder()
    private Builder() {
      maybeForceBuilderInitialization();
    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);
      maybeForceBuilderInitialization();
    }
    private void maybeForceBuilderInitialization() {
      if (com.google.protobuf.GeneratedMessageV3
              .alwaysUseFieldBuilders) {
        getRoleFieldBuilder();
      }
    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      if (idBuilder_ == null) {
        id_ = null;
      } else {
        id_ = null;
        idBuilder_ = null;
      }
      displayName_ = "";

      if (emailBuilder_ == null) {
        email_ = null;
      } else {
        email_ = null;
        emailBuilder_ = null;
      }
      description_ = "";

      if (roleBuilder_ == null) {
        role_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000040);
      } else {
        roleBuilder_.clear();
      }
      originCase_ = 0;
      origin_ = null;
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return io.spine.users.group.GroupProto.internal_static_spine_users_group_Group_descriptor;
    }

    @java.lang.Override
    public io.spine.users.group.Group getDefaultInstanceForType() {
      return io.spine.users.group.Group.getDefaultInstance();
    }

    @java.lang.Override
    public io.spine.users.group.Group build() {
      io.spine.users.group.Group result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public io.spine.users.group.Group buildPartial() {
      io.spine.users.group.Group result = new io.spine.users.group.Group(this);
      int from_bitField0_ = bitField0_;
      int to_bitField0_ = 0;
      if (idBuilder_ == null) {
        result.id_ = id_;
      } else {
        result.id_ = idBuilder_.build();
      }
      result.displayName_ = displayName_;
      if (emailBuilder_ == null) {
        result.email_ = email_;
      } else {
        result.email_ = emailBuilder_.build();
      }
      result.description_ = description_;
      if (originCase_ == 5) {
        if (orgEntityBuilder_ == null) {
          result.origin_ = origin_;
        } else {
          result.origin_ = orgEntityBuilder_.build();
        }
      }
      if (originCase_ == 6) {
        if (externalDomainBuilder_ == null) {
          result.origin_ = origin_;
        } else {
          result.origin_ = externalDomainBuilder_.build();
        }
      }
      if (roleBuilder_ == null) {
        if (((bitField0_ & 0x00000040) == 0x00000040)) {
          role_ = java.util.Collections.unmodifiableList(role_);
          bitField0_ = (bitField0_ & ~0x00000040);
        }
        result.role_ = role_;
      } else {
        result.role_ = roleBuilder_.build();
      }
      result.bitField0_ = to_bitField0_;
      result.originCase_ = originCase_;
      onBuilt();
      return result;
    }

    @java.lang.Override
    public Builder clone() {
      return (Builder) super.clone();
    }
    @java.lang.Override
    public Builder setField(
        com.google.protobuf.Descriptors.FieldDescriptor field,
        java.lang.Object value) {
      return (Builder) super.setField(field, value);
    }
    @java.lang.Override
    public Builder clearField(
        com.google.protobuf.Descriptors.FieldDescriptor field) {
      return (Builder) super.clearField(field);
    }
    @java.lang.Override
    public Builder clearOneof(
        com.google.protobuf.Descriptors.OneofDescriptor oneof) {
      return (Builder) super.clearOneof(oneof);
    }
    @java.lang.Override
    public Builder setRepeatedField(
        com.google.protobuf.Descriptors.FieldDescriptor field,
        int index, java.lang.Object value) {
      return (Builder) super.setRepeatedField(field, index, value);
    }
    @java.lang.Override
    public Builder addRepeatedField(
        com.google.protobuf.Descriptors.FieldDescriptor field,
        java.lang.Object value) {
      return (Builder) super.addRepeatedField(field, value);
    }
    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof io.spine.users.group.Group) {
        return mergeFrom((io.spine.users.group.Group)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(io.spine.users.group.Group other) {
      if (other == io.spine.users.group.Group.getDefaultInstance()) return this;
      if (other.hasId()) {
        mergeId(other.getId());
      }
      if (!other.getDisplayName().isEmpty()) {
        displayName_ = other.displayName_;
        onChanged();
      }
      if (other.hasEmail()) {
        mergeEmail(other.getEmail());
      }
      if (!other.getDescription().isEmpty()) {
        description_ = other.description_;
        onChanged();
      }
      if (roleBuilder_ == null) {
        if (!other.role_.isEmpty()) {
          if (role_.isEmpty()) {
            role_ = other.role_;
            bitField0_ = (bitField0_ & ~0x00000040);
          } else {
            ensureRoleIsMutable();
            role_.addAll(other.role_);
          }
          onChanged();
        }
      } else {
        if (!other.role_.isEmpty()) {
          if (roleBuilder_.isEmpty()) {
            roleBuilder_.dispose();
            roleBuilder_ = null;
            role_ = other.role_;
            bitField0_ = (bitField0_ & ~0x00000040);
            roleBuilder_ = 
              com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders ?
                 getRoleFieldBuilder() : null;
          } else {
            roleBuilder_.addAllMessages(other.role_);
          }
        }
      }
      switch (other.getOriginCase()) {
        case ORG_ENTITY: {
          mergeOrgEntity(other.getOrgEntity());
          break;
        }
        case EXTERNAL_DOMAIN: {
          mergeExternalDomain(other.getExternalDomain());
          break;
        }
        case ORIGIN_NOT_SET: {
          break;
        }
      }
      this.mergeUnknownFields(other.unknownFields);
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      io.spine.users.group.Group parsedMessage = null;
      try {
        parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        parsedMessage = (io.spine.users.group.Group) e.getUnfinishedMessage();
        throw e.unwrapIOException();
      } finally {
        if (parsedMessage != null) {
          mergeFrom(parsedMessage);
        }
      }
      return this;
    }
    private int originCase_ = 0;
    private java.lang.Object origin_;
    public OriginCase
        getOriginCase() {
      return OriginCase.forNumber(
          originCase_);
    }

    public Builder clearOrigin() {
      originCase_ = 0;
      origin_ = null;
      onChanged();
      return this;
    }

    private int bitField0_;

    private io.spine.users.GroupId id_ = null;
    private com.google.protobuf.SingleFieldBuilderV3<
        io.spine.users.GroupId, io.spine.users.GroupId.Builder, io.spine.users.GroupIdOrBuilder> idBuilder_;
    /**
     * <code>.spine.users.GroupId id = 1;</code>
     */
    public boolean hasId() {
      return idBuilder_ != null || id_ != null;
    }
    /**
     * <code>.spine.users.GroupId id = 1;</code>
     */
    public io.spine.users.GroupId getId() {
      if (idBuilder_ == null) {
        return id_ == null ? io.spine.users.GroupId.getDefaultInstance() : id_;
      } else {
        return idBuilder_.getMessage();
      }
    }
    /**
     * <code>.spine.users.GroupId id = 1;</code>
     */
    public Builder setId(io.spine.users.GroupId value) {
      if (idBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        id_ = value;
        onChanged();
      } else {
        idBuilder_.setMessage(value);
      }

      return this;
    }
    /**
     * <code>.spine.users.GroupId id = 1;</code>
     */
    public Builder setId(
        io.spine.users.GroupId.Builder builderForValue) {
      if (idBuilder_ == null) {
        id_ = builderForValue.build();
        onChanged();
      } else {
        idBuilder_.setMessage(builderForValue.build());
      }

      return this;
    }
    /**
     * <code>.spine.users.GroupId id = 1;</code>
     */
    public Builder mergeId(io.spine.users.GroupId value) {
      if (idBuilder_ == null) {
        if (id_ != null) {
          id_ =
            io.spine.users.GroupId.newBuilder(id_).mergeFrom(value).buildPartial();
        } else {
          id_ = value;
        }
        onChanged();
      } else {
        idBuilder_.mergeFrom(value);
      }

      return this;
    }
    /**
     * <code>.spine.users.GroupId id = 1;</code>
     */
    public Builder clearId() {
      if (idBuilder_ == null) {
        id_ = null;
        onChanged();
      } else {
        id_ = null;
        idBuilder_ = null;
      }

      return this;
    }
    /**
     * <code>.spine.users.GroupId id = 1;</code>
     */
    public io.spine.users.GroupId.Builder getIdBuilder() {
      
      onChanged();
      return getIdFieldBuilder().getBuilder();
    }
    /**
     * <code>.spine.users.GroupId id = 1;</code>
     */
    public io.spine.users.GroupIdOrBuilder getIdOrBuilder() {
      if (idBuilder_ != null) {
        return idBuilder_.getMessageOrBuilder();
      } else {
        return id_ == null ?
            io.spine.users.GroupId.getDefaultInstance() : id_;
      }
    }
    /**
     * <code>.spine.users.GroupId id = 1;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        io.spine.users.GroupId, io.spine.users.GroupId.Builder, io.spine.users.GroupIdOrBuilder> 
        getIdFieldBuilder() {
      if (idBuilder_ == null) {
        idBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            io.spine.users.GroupId, io.spine.users.GroupId.Builder, io.spine.users.GroupIdOrBuilder>(
                getId(),
                getParentForChildren(),
                isClean());
        id_ = null;
      }
      return idBuilder_;
    }

    private java.lang.Object displayName_ = "";
    /**
     * <pre>
     * A name of a group to display on UI.
     * </pre>
     *
     * <code>string display_name = 2 [(.required) = true];</code>
     */
    public java.lang.String getDisplayName() {
      java.lang.Object ref = displayName_;
      if (!(ref instanceof java.lang.String)) {
        com.google.protobuf.ByteString bs =
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        displayName_ = s;
        return s;
      } else {
        return (java.lang.String) ref;
      }
    }
    /**
     * <pre>
     * A name of a group to display on UI.
     * </pre>
     *
     * <code>string display_name = 2 [(.required) = true];</code>
     */
    public com.google.protobuf.ByteString
        getDisplayNameBytes() {
      java.lang.Object ref = displayName_;
      if (ref instanceof String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        displayName_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }
    /**
     * <pre>
     * A name of a group to display on UI.
     * </pre>
     *
     * <code>string display_name = 2 [(.required) = true];</code>
     */
    public Builder setDisplayName(
        java.lang.String value) {
      if (value == null) {
    throw new NullPointerException();
  }
  
      displayName_ = value;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * A name of a group to display on UI.
     * </pre>
     *
     * <code>string display_name = 2 [(.required) = true];</code>
     */
    public Builder clearDisplayName() {
      
      displayName_ = getDefaultInstance().getDisplayName();
      onChanged();
      return this;
    }
    /**
     * <pre>
     * A name of a group to display on UI.
     * </pre>
     *
     * <code>string display_name = 2 [(.required) = true];</code>
     */
    public Builder setDisplayNameBytes(
        com.google.protobuf.ByteString value) {
      if (value == null) {
    throw new NullPointerException();
  }
  checkByteStringIsUtf8(value);
      
      displayName_ = value;
      onChanged();
      return this;
    }

    private io.spine.net.EmailAddress email_ = null;
    private com.google.protobuf.SingleFieldBuilderV3<
        io.spine.net.EmailAddress, io.spine.net.EmailAddress.Builder, io.spine.net.EmailAddressOrBuilder> emailBuilder_;
    /**
     * <pre>
     * An email address of the group if applicable.
     * The email address may be used to send messages to all the group members.
     * </pre>
     *
     * <code>.spine.net.EmailAddress email = 3;</code>
     */
    public boolean hasEmail() {
      return emailBuilder_ != null || email_ != null;
    }
    /**
     * <pre>
     * An email address of the group if applicable.
     * The email address may be used to send messages to all the group members.
     * </pre>
     *
     * <code>.spine.net.EmailAddress email = 3;</code>
     */
    public io.spine.net.EmailAddress getEmail() {
      if (emailBuilder_ == null) {
        return email_ == null ? io.spine.net.EmailAddress.getDefaultInstance() : email_;
      } else {
        return emailBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * An email address of the group if applicable.
     * The email address may be used to send messages to all the group members.
     * </pre>
     *
     * <code>.spine.net.EmailAddress email = 3;</code>
     */
    public Builder setEmail(io.spine.net.EmailAddress value) {
      if (emailBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        email_ = value;
        onChanged();
      } else {
        emailBuilder_.setMessage(value);
      }

      return this;
    }
    /**
     * <pre>
     * An email address of the group if applicable.
     * The email address may be used to send messages to all the group members.
     * </pre>
     *
     * <code>.spine.net.EmailAddress email = 3;</code>
     */
    public Builder setEmail(
        io.spine.net.EmailAddress.Builder builderForValue) {
      if (emailBuilder_ == null) {
        email_ = builderForValue.build();
        onChanged();
      } else {
        emailBuilder_.setMessage(builderForValue.build());
      }

      return this;
    }
    /**
     * <pre>
     * An email address of the group if applicable.
     * The email address may be used to send messages to all the group members.
     * </pre>
     *
     * <code>.spine.net.EmailAddress email = 3;</code>
     */
    public Builder mergeEmail(io.spine.net.EmailAddress value) {
      if (emailBuilder_ == null) {
        if (email_ != null) {
          email_ =
            io.spine.net.EmailAddress.newBuilder(email_).mergeFrom(value).buildPartial();
        } else {
          email_ = value;
        }
        onChanged();
      } else {
        emailBuilder_.mergeFrom(value);
      }

      return this;
    }
    /**
     * <pre>
     * An email address of the group if applicable.
     * The email address may be used to send messages to all the group members.
     * </pre>
     *
     * <code>.spine.net.EmailAddress email = 3;</code>
     */
    public Builder clearEmail() {
      if (emailBuilder_ == null) {
        email_ = null;
        onChanged();
      } else {
        email_ = null;
        emailBuilder_ = null;
      }

      return this;
    }
    /**
     * <pre>
     * An email address of the group if applicable.
     * The email address may be used to send messages to all the group members.
     * </pre>
     *
     * <code>.spine.net.EmailAddress email = 3;</code>
     */
    public io.spine.net.EmailAddress.Builder getEmailBuilder() {
      
      onChanged();
      return getEmailFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * An email address of the group if applicable.
     * The email address may be used to send messages to all the group members.
     * </pre>
     *
     * <code>.spine.net.EmailAddress email = 3;</code>
     */
    public io.spine.net.EmailAddressOrBuilder getEmailOrBuilder() {
      if (emailBuilder_ != null) {
        return emailBuilder_.getMessageOrBuilder();
      } else {
        return email_ == null ?
            io.spine.net.EmailAddress.getDefaultInstance() : email_;
      }
    }
    /**
     * <pre>
     * An email address of the group if applicable.
     * The email address may be used to send messages to all the group members.
     * </pre>
     *
     * <code>.spine.net.EmailAddress email = 3;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        io.spine.net.EmailAddress, io.spine.net.EmailAddress.Builder, io.spine.net.EmailAddressOrBuilder> 
        getEmailFieldBuilder() {
      if (emailBuilder_ == null) {
        emailBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            io.spine.net.EmailAddress, io.spine.net.EmailAddress.Builder, io.spine.net.EmailAddressOrBuilder>(
                getEmail(),
                getParentForChildren(),
                isClean());
        email_ = null;
      }
      return emailBuilder_;
    }

    private java.lang.Object description_ = "";
    /**
     * <pre>
     * A human-friendly description of a group.
     * </pre>
     *
     * <code>string description = 4;</code>
     */
    public java.lang.String getDescription() {
      java.lang.Object ref = description_;
      if (!(ref instanceof java.lang.String)) {
        com.google.protobuf.ByteString bs =
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        description_ = s;
        return s;
      } else {
        return (java.lang.String) ref;
      }
    }
    /**
     * <pre>
     * A human-friendly description of a group.
     * </pre>
     *
     * <code>string description = 4;</code>
     */
    public com.google.protobuf.ByteString
        getDescriptionBytes() {
      java.lang.Object ref = description_;
      if (ref instanceof String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        description_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }
    /**
     * <pre>
     * A human-friendly description of a group.
     * </pre>
     *
     * <code>string description = 4;</code>
     */
    public Builder setDescription(
        java.lang.String value) {
      if (value == null) {
    throw new NullPointerException();
  }
  
      description_ = value;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * A human-friendly description of a group.
     * </pre>
     *
     * <code>string description = 4;</code>
     */
    public Builder clearDescription() {
      
      description_ = getDefaultInstance().getDescription();
      onChanged();
      return this;
    }
    /**
     * <pre>
     * A human-friendly description of a group.
     * </pre>
     *
     * <code>string description = 4;</code>
     */
    public Builder setDescriptionBytes(
        com.google.protobuf.ByteString value) {
      if (value == null) {
    throw new NullPointerException();
  }
  checkByteStringIsUtf8(value);
      
      description_ = value;
      onChanged();
      return this;
    }

    private com.google.protobuf.SingleFieldBuilderV3<
        io.spine.users.OrganizationOrUnit, io.spine.users.OrganizationOrUnit.Builder, io.spine.users.OrganizationOrUnitOrBuilder> orgEntityBuilder_;
    /**
     * <pre>
     * An organization or orgunit in one of the tenant's domains.
     * </pre>
     *
     * <code>.spine.users.OrganizationOrUnit org_entity = 5;</code>
     */
    public boolean hasOrgEntity() {
      return originCase_ == 5;
    }
    /**
     * <pre>
     * An organization or orgunit in one of the tenant's domains.
     * </pre>
     *
     * <code>.spine.users.OrganizationOrUnit org_entity = 5;</code>
     */
    public io.spine.users.OrganizationOrUnit getOrgEntity() {
      if (orgEntityBuilder_ == null) {
        if (originCase_ == 5) {
          return (io.spine.users.OrganizationOrUnit) origin_;
        }
        return io.spine.users.OrganizationOrUnit.getDefaultInstance();
      } else {
        if (originCase_ == 5) {
          return orgEntityBuilder_.getMessage();
        }
        return io.spine.users.OrganizationOrUnit.getDefaultInstance();
      }
    }
    /**
     * <pre>
     * An organization or orgunit in one of the tenant's domains.
     * </pre>
     *
     * <code>.spine.users.OrganizationOrUnit org_entity = 5;</code>
     */
    public Builder setOrgEntity(io.spine.users.OrganizationOrUnit value) {
      if (orgEntityBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        origin_ = value;
        onChanged();
      } else {
        orgEntityBuilder_.setMessage(value);
      }
      originCase_ = 5;
      return this;
    }
    /**
     * <pre>
     * An organization or orgunit in one of the tenant's domains.
     * </pre>
     *
     * <code>.spine.users.OrganizationOrUnit org_entity = 5;</code>
     */
    public Builder setOrgEntity(
        io.spine.users.OrganizationOrUnit.Builder builderForValue) {
      if (orgEntityBuilder_ == null) {
        origin_ = builderForValue.build();
        onChanged();
      } else {
        orgEntityBuilder_.setMessage(builderForValue.build());
      }
      originCase_ = 5;
      return this;
    }
    /**
     * <pre>
     * An organization or orgunit in one of the tenant's domains.
     * </pre>
     *
     * <code>.spine.users.OrganizationOrUnit org_entity = 5;</code>
     */
    public Builder mergeOrgEntity(io.spine.users.OrganizationOrUnit value) {
      if (orgEntityBuilder_ == null) {
        if (originCase_ == 5 &&
            origin_ != io.spine.users.OrganizationOrUnit.getDefaultInstance()) {
          origin_ = io.spine.users.OrganizationOrUnit.newBuilder((io.spine.users.OrganizationOrUnit) origin_)
              .mergeFrom(value).buildPartial();
        } else {
          origin_ = value;
        }
        onChanged();
      } else {
        if (originCase_ == 5) {
          orgEntityBuilder_.mergeFrom(value);
        }
        orgEntityBuilder_.setMessage(value);
      }
      originCase_ = 5;
      return this;
    }
    /**
     * <pre>
     * An organization or orgunit in one of the tenant's domains.
     * </pre>
     *
     * <code>.spine.users.OrganizationOrUnit org_entity = 5;</code>
     */
    public Builder clearOrgEntity() {
      if (orgEntityBuilder_ == null) {
        if (originCase_ == 5) {
          originCase_ = 0;
          origin_ = null;
          onChanged();
        }
      } else {
        if (originCase_ == 5) {
          originCase_ = 0;
          origin_ = null;
        }
        orgEntityBuilder_.clear();
      }
      return this;
    }
    /**
     * <pre>
     * An organization or orgunit in one of the tenant's domains.
     * </pre>
     *
     * <code>.spine.users.OrganizationOrUnit org_entity = 5;</code>
     */
    public io.spine.users.OrganizationOrUnit.Builder getOrgEntityBuilder() {
      return getOrgEntityFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * An organization or orgunit in one of the tenant's domains.
     * </pre>
     *
     * <code>.spine.users.OrganizationOrUnit org_entity = 5;</code>
     */
    public io.spine.users.OrganizationOrUnitOrBuilder getOrgEntityOrBuilder() {
      if ((originCase_ == 5) && (orgEntityBuilder_ != null)) {
        return orgEntityBuilder_.getMessageOrBuilder();
      } else {
        if (originCase_ == 5) {
          return (io.spine.users.OrganizationOrUnit) origin_;
        }
        return io.spine.users.OrganizationOrUnit.getDefaultInstance();
      }
    }
    /**
     * <pre>
     * An organization or orgunit in one of the tenant's domains.
     * </pre>
     *
     * <code>.spine.users.OrganizationOrUnit org_entity = 5;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        io.spine.users.OrganizationOrUnit, io.spine.users.OrganizationOrUnit.Builder, io.spine.users.OrganizationOrUnitOrBuilder> 
        getOrgEntityFieldBuilder() {
      if (orgEntityBuilder_ == null) {
        if (!(originCase_ == 5)) {
          origin_ = io.spine.users.OrganizationOrUnit.getDefaultInstance();
        }
        orgEntityBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            io.spine.users.OrganizationOrUnit, io.spine.users.OrganizationOrUnit.Builder, io.spine.users.OrganizationOrUnitOrBuilder>(
                (io.spine.users.OrganizationOrUnit) origin_,
                getParentForChildren(),
                isClean());
        origin_ = null;
      }
      originCase_ = 5;
      onChanged();;
      return orgEntityBuilder_;
    }

    private com.google.protobuf.SingleFieldBuilderV3<
        io.spine.net.InternetDomain, io.spine.net.InternetDomain.Builder, io.spine.net.InternetDomainOrBuilder> externalDomainBuilder_;
    /**
     * <pre>
     * An external domain.
     * </pre>
     *
     * <code>.spine.net.InternetDomain external_domain = 6;</code>
     */
    public boolean hasExternalDomain() {
      return originCase_ == 6;
    }
    /**
     * <pre>
     * An external domain.
     * </pre>
     *
     * <code>.spine.net.InternetDomain external_domain = 6;</code>
     */
    public io.spine.net.InternetDomain getExternalDomain() {
      if (externalDomainBuilder_ == null) {
        if (originCase_ == 6) {
          return (io.spine.net.InternetDomain) origin_;
        }
        return io.spine.net.InternetDomain.getDefaultInstance();
      } else {
        if (originCase_ == 6) {
          return externalDomainBuilder_.getMessage();
        }
        return io.spine.net.InternetDomain.getDefaultInstance();
      }
    }
    /**
     * <pre>
     * An external domain.
     * </pre>
     *
     * <code>.spine.net.InternetDomain external_domain = 6;</code>
     */
    public Builder setExternalDomain(io.spine.net.InternetDomain value) {
      if (externalDomainBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        origin_ = value;
        onChanged();
      } else {
        externalDomainBuilder_.setMessage(value);
      }
      originCase_ = 6;
      return this;
    }
    /**
     * <pre>
     * An external domain.
     * </pre>
     *
     * <code>.spine.net.InternetDomain external_domain = 6;</code>
     */
    public Builder setExternalDomain(
        io.spine.net.InternetDomain.Builder builderForValue) {
      if (externalDomainBuilder_ == null) {
        origin_ = builderForValue.build();
        onChanged();
      } else {
        externalDomainBuilder_.setMessage(builderForValue.build());
      }
      originCase_ = 6;
      return this;
    }
    /**
     * <pre>
     * An external domain.
     * </pre>
     *
     * <code>.spine.net.InternetDomain external_domain = 6;</code>
     */
    public Builder mergeExternalDomain(io.spine.net.InternetDomain value) {
      if (externalDomainBuilder_ == null) {
        if (originCase_ == 6 &&
            origin_ != io.spine.net.InternetDomain.getDefaultInstance()) {
          origin_ = io.spine.net.InternetDomain.newBuilder((io.spine.net.InternetDomain) origin_)
              .mergeFrom(value).buildPartial();
        } else {
          origin_ = value;
        }
        onChanged();
      } else {
        if (originCase_ == 6) {
          externalDomainBuilder_.mergeFrom(value);
        }
        externalDomainBuilder_.setMessage(value);
      }
      originCase_ = 6;
      return this;
    }
    /**
     * <pre>
     * An external domain.
     * </pre>
     *
     * <code>.spine.net.InternetDomain external_domain = 6;</code>
     */
    public Builder clearExternalDomain() {
      if (externalDomainBuilder_ == null) {
        if (originCase_ == 6) {
          originCase_ = 0;
          origin_ = null;
          onChanged();
        }
      } else {
        if (originCase_ == 6) {
          originCase_ = 0;
          origin_ = null;
        }
        externalDomainBuilder_.clear();
      }
      return this;
    }
    /**
     * <pre>
     * An external domain.
     * </pre>
     *
     * <code>.spine.net.InternetDomain external_domain = 6;</code>
     */
    public io.spine.net.InternetDomain.Builder getExternalDomainBuilder() {
      return getExternalDomainFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * An external domain.
     * </pre>
     *
     * <code>.spine.net.InternetDomain external_domain = 6;</code>
     */
    public io.spine.net.InternetDomainOrBuilder getExternalDomainOrBuilder() {
      if ((originCase_ == 6) && (externalDomainBuilder_ != null)) {
        return externalDomainBuilder_.getMessageOrBuilder();
      } else {
        if (originCase_ == 6) {
          return (io.spine.net.InternetDomain) origin_;
        }
        return io.spine.net.InternetDomain.getDefaultInstance();
      }
    }
    /**
     * <pre>
     * An external domain.
     * </pre>
     *
     * <code>.spine.net.InternetDomain external_domain = 6;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        io.spine.net.InternetDomain, io.spine.net.InternetDomain.Builder, io.spine.net.InternetDomainOrBuilder> 
        getExternalDomainFieldBuilder() {
      if (externalDomainBuilder_ == null) {
        if (!(originCase_ == 6)) {
          origin_ = io.spine.net.InternetDomain.getDefaultInstance();
        }
        externalDomainBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            io.spine.net.InternetDomain, io.spine.net.InternetDomain.Builder, io.spine.net.InternetDomainOrBuilder>(
                (io.spine.net.InternetDomain) origin_,
                getParentForChildren(),
                isClean());
        origin_ = null;
      }
      originCase_ = 6;
      onChanged();;
      return externalDomainBuilder_;
    }

    private java.util.List<io.spine.users.RoleId> role_ =
      java.util.Collections.emptyList();
    private void ensureRoleIsMutable() {
      if (!((bitField0_ & 0x00000040) == 0x00000040)) {
        role_ = new java.util.ArrayList<io.spine.users.RoleId>(role_);
        bitField0_ |= 0x00000040;
       }
    }

    private com.google.protobuf.RepeatedFieldBuilderV3<
        io.spine.users.RoleId, io.spine.users.RoleId.Builder, io.spine.users.RoleIdOrBuilder> roleBuilder_;

    /**
     * <pre>
     * Roles explicitly assigned to the group.
     * </pre>
     *
     * <code>repeated .spine.users.RoleId role = 7;</code>
     */
    public java.util.List<io.spine.users.RoleId> getRoleList() {
      if (roleBuilder_ == null) {
        return java.util.Collections.unmodifiableList(role_);
      } else {
        return roleBuilder_.getMessageList();
      }
    }
    /**
     * <pre>
     * Roles explicitly assigned to the group.
     * </pre>
     *
     * <code>repeated .spine.users.RoleId role = 7;</code>
     */
    public int getRoleCount() {
      if (roleBuilder_ == null) {
        return role_.size();
      } else {
        return roleBuilder_.getCount();
      }
    }
    /**
     * <pre>
     * Roles explicitly assigned to the group.
     * </pre>
     *
     * <code>repeated .spine.users.RoleId role = 7;</code>
     */
    public io.spine.users.RoleId getRole(int index) {
      if (roleBuilder_ == null) {
        return role_.get(index);
      } else {
        return roleBuilder_.getMessage(index);
      }
    }
    /**
     * <pre>
     * Roles explicitly assigned to the group.
     * </pre>
     *
     * <code>repeated .spine.users.RoleId role = 7;</code>
     */
    public Builder setRole(
        int index, io.spine.users.RoleId value) {
      if (roleBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureRoleIsMutable();
        role_.set(index, value);
        onChanged();
      } else {
        roleBuilder_.setMessage(index, value);
      }
      return this;
    }
    /**
     * <pre>
     * Roles explicitly assigned to the group.
     * </pre>
     *
     * <code>repeated .spine.users.RoleId role = 7;</code>
     */
    public Builder setRole(
        int index, io.spine.users.RoleId.Builder builderForValue) {
      if (roleBuilder_ == null) {
        ensureRoleIsMutable();
        role_.set(index, builderForValue.build());
        onChanged();
      } else {
        roleBuilder_.setMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * Roles explicitly assigned to the group.
     * </pre>
     *
     * <code>repeated .spine.users.RoleId role = 7;</code>
     */
    public Builder addRole(io.spine.users.RoleId value) {
      if (roleBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureRoleIsMutable();
        role_.add(value);
        onChanged();
      } else {
        roleBuilder_.addMessage(value);
      }
      return this;
    }
    /**
     * <pre>
     * Roles explicitly assigned to the group.
     * </pre>
     *
     * <code>repeated .spine.users.RoleId role = 7;</code>
     */
    public Builder addRole(
        int index, io.spine.users.RoleId value) {
      if (roleBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureRoleIsMutable();
        role_.add(index, value);
        onChanged();
      } else {
        roleBuilder_.addMessage(index, value);
      }
      return this;
    }
    /**
     * <pre>
     * Roles explicitly assigned to the group.
     * </pre>
     *
     * <code>repeated .spine.users.RoleId role = 7;</code>
     */
    public Builder addRole(
        io.spine.users.RoleId.Builder builderForValue) {
      if (roleBuilder_ == null) {
        ensureRoleIsMutable();
        role_.add(builderForValue.build());
        onChanged();
      } else {
        roleBuilder_.addMessage(builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * Roles explicitly assigned to the group.
     * </pre>
     *
     * <code>repeated .spine.users.RoleId role = 7;</code>
     */
    public Builder addRole(
        int index, io.spine.users.RoleId.Builder builderForValue) {
      if (roleBuilder_ == null) {
        ensureRoleIsMutable();
        role_.add(index, builderForValue.build());
        onChanged();
      } else {
        roleBuilder_.addMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * Roles explicitly assigned to the group.
     * </pre>
     *
     * <code>repeated .spine.users.RoleId role = 7;</code>
     */
    public Builder addAllRole(
        java.lang.Iterable<? extends io.spine.users.RoleId> values) {
      if (roleBuilder_ == null) {
        ensureRoleIsMutable();
        com.google.protobuf.AbstractMessageLite.Builder.addAll(
            values, role_);
        onChanged();
      } else {
        roleBuilder_.addAllMessages(values);
      }
      return this;
    }
    /**
     * <pre>
     * Roles explicitly assigned to the group.
     * </pre>
     *
     * <code>repeated .spine.users.RoleId role = 7;</code>
     */
    public Builder clearRole() {
      if (roleBuilder_ == null) {
        role_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000040);
        onChanged();
      } else {
        roleBuilder_.clear();
      }
      return this;
    }
    /**
     * <pre>
     * Roles explicitly assigned to the group.
     * </pre>
     *
     * <code>repeated .spine.users.RoleId role = 7;</code>
     */
    public Builder removeRole(int index) {
      if (roleBuilder_ == null) {
        ensureRoleIsMutable();
        role_.remove(index);
        onChanged();
      } else {
        roleBuilder_.remove(index);
      }
      return this;
    }
    /**
     * <pre>
     * Roles explicitly assigned to the group.
     * </pre>
     *
     * <code>repeated .spine.users.RoleId role = 7;</code>
     */
    public io.spine.users.RoleId.Builder getRoleBuilder(
        int index) {
      return getRoleFieldBuilder().getBuilder(index);
    }
    /**
     * <pre>
     * Roles explicitly assigned to the group.
     * </pre>
     *
     * <code>repeated .spine.users.RoleId role = 7;</code>
     */
    public io.spine.users.RoleIdOrBuilder getRoleOrBuilder(
        int index) {
      if (roleBuilder_ == null) {
        return role_.get(index);  } else {
        return roleBuilder_.getMessageOrBuilder(index);
      }
    }
    /**
     * <pre>
     * Roles explicitly assigned to the group.
     * </pre>
     *
     * <code>repeated .spine.users.RoleId role = 7;</code>
     */
    public java.util.List<? extends io.spine.users.RoleIdOrBuilder> 
         getRoleOrBuilderList() {
      if (roleBuilder_ != null) {
        return roleBuilder_.getMessageOrBuilderList();
      } else {
        return java.util.Collections.unmodifiableList(role_);
      }
    }
    /**
     * <pre>
     * Roles explicitly assigned to the group.
     * </pre>
     *
     * <code>repeated .spine.users.RoleId role = 7;</code>
     */
    public io.spine.users.RoleId.Builder addRoleBuilder() {
      return getRoleFieldBuilder().addBuilder(
          io.spine.users.RoleId.getDefaultInstance());
    }
    /**
     * <pre>
     * Roles explicitly assigned to the group.
     * </pre>
     *
     * <code>repeated .spine.users.RoleId role = 7;</code>
     */
    public io.spine.users.RoleId.Builder addRoleBuilder(
        int index) {
      return getRoleFieldBuilder().addBuilder(
          index, io.spine.users.RoleId.getDefaultInstance());
    }
    /**
     * <pre>
     * Roles explicitly assigned to the group.
     * </pre>
     *
     * <code>repeated .spine.users.RoleId role = 7;</code>
     */
    public java.util.List<io.spine.users.RoleId.Builder> 
         getRoleBuilderList() {
      return getRoleFieldBuilder().getBuilderList();
    }
    private com.google.protobuf.RepeatedFieldBuilderV3<
        io.spine.users.RoleId, io.spine.users.RoleId.Builder, io.spine.users.RoleIdOrBuilder> 
        getRoleFieldBuilder() {
      if (roleBuilder_ == null) {
        roleBuilder_ = new com.google.protobuf.RepeatedFieldBuilderV3<
            io.spine.users.RoleId, io.spine.users.RoleId.Builder, io.spine.users.RoleIdOrBuilder>(
                role_,
                ((bitField0_ & 0x00000040) == 0x00000040),
                getParentForChildren(),
                isClean());
        role_ = null;
      }
      return roleBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFieldsProto3(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:spine.users.group.Group)
  }

  // @@protoc_insertion_point(class_scope:spine.users.group.Group)
  private static final io.spine.users.group.Group DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new io.spine.users.group.Group();
  }

  public static io.spine.users.group.Group getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<Group>
      PARSER = new com.google.protobuf.AbstractParser<Group>() {
    @java.lang.Override
    public Group parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return new Group(input, extensionRegistry);
    }
  };

  public static com.google.protobuf.Parser<Group> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<Group> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public io.spine.users.group.Group getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

