package io.spine.users.group;

import com.google.errorprone.annotations.CanIgnoreReturnValue;
import com.google.protobuf.Descriptors;
import io.spine.base.ConversionException;
import io.spine.core.UserId;
import io.spine.users.GroupId;
import io.spine.users.RoleId;
import io.spine.validate.AbstractValidatingBuilder;
import io.spine.validate.ValidationException;
import java.util.List;
import java.util.Map;
import javax.annotation.Generated;

@Generated("by Spine Model Compiler")
public final class GroupRolesPropagationVBuilder extends AbstractValidatingBuilder<GroupRolesPropagation, GroupRolesPropagation.Builder> {
    private GroupRolesPropagationVBuilder() {
    }

    public static GroupRolesPropagationVBuilder newBuilder() {
        return new GroupRolesPropagationVBuilder();
    }

    @CanIgnoreReturnValue
    public GroupRolesPropagationVBuilder setId(GroupId id) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.GroupRolesPropagation.getDescriptor().getFields().get(0);
        validateSetOnce(fieldDescriptor, id);
        validate(fieldDescriptor, id, "id");
        getMessageBuilder().setId(id);
        return this;
    }

    @CanIgnoreReturnValue
    public GroupRolesPropagationVBuilder setRawId(String id) throws ValidationException,
            ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.GroupRolesPropagation.getDescriptor().getFields().get(0);
        io.spine.users.GroupId convertedId = convert(id, io.spine.users.GroupId.class);
        validateSetOnce(fieldDescriptor, convertedId);
        validate(fieldDescriptor, convertedId, "id");
        getMessageBuilder().setId(convertedId);
        return this;
    }

    public GroupId getId() {
        return getMessageBuilder().getId();
    }

    @CanIgnoreReturnValue
    public GroupRolesPropagationVBuilder clearId() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.GroupRolesPropagation.getDescriptor().getFields().get(0);
        validateSetOnce(fieldDescriptor, io.spine.users.group.GroupRolesPropagation.getDefaultInstance().getId());
        getMessageBuilder().clearId();
        return this;
    }

    public List<UserId> getUserMember() {
        return getMessageBuilder().getUserMemberList();
    }

    @CanIgnoreReturnValue
    public GroupRolesPropagationVBuilder clearUserMember() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.GroupRolesPropagation.getDescriptor().getFields().get(1);
        checkNotSetOnce(fieldDescriptor);
        getMessageBuilder().clearUserMember();
        return this;
    }

    @CanIgnoreReturnValue
    public GroupRolesPropagationVBuilder addUserMember(UserId value) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.GroupRolesPropagation.getDescriptor().getFields().get(1);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, value, "userMember");
        getMessageBuilder().addUserMember(value);
        return this;
    }

    @CanIgnoreReturnValue
    public GroupRolesPropagationVBuilder setUserMember(int index, UserId value) throws
            ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.GroupRolesPropagation.getDescriptor().getFields().get(1);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, value, "userMember");
        getMessageBuilder().setUserMember(index, value);
        return this;
    }

    @CanIgnoreReturnValue
    public GroupRolesPropagationVBuilder addAllUserMember(List<UserId> value) throws
            ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.GroupRolesPropagation.getDescriptor().getFields().get(1);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, value, "userMember");
        getMessageBuilder().addAllUserMember(value);
        return this;
    }

    @CanIgnoreReturnValue
    public GroupRolesPropagationVBuilder addUserMember(int index, UserId value) throws
            ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.GroupRolesPropagation.getDescriptor().getFields().get(1);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, value, "userMember");
        getMessageBuilder().addUserMember(index, value);
        return this;
    }

    @CanIgnoreReturnValue
    public GroupRolesPropagationVBuilder removeUserMember(int index) {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.GroupRolesPropagation.getDescriptor().getFields().get(1);
        checkNotSetOnce(fieldDescriptor);
        getMessageBuilder().removeUserMember(index);
        return this;
    }

    @CanIgnoreReturnValue
    public GroupRolesPropagationVBuilder addRawUserMember(String value) throws ValidationException,
            ConversionException {
        io.spine.core.UserId convertedValue = convert(value, io.spine.core.UserId.class);
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.GroupRolesPropagation.getDescriptor().getFields().get(1);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, convertedValue, "userMember");
        getMessageBuilder().addUserMember(convertedValue);
        return this;
    }

    @CanIgnoreReturnValue
    public GroupRolesPropagationVBuilder setRawUserMember(int index, String value) throws
            ValidationException, ConversionException {
        io.spine.core.UserId convertedValue = convert(value, io.spine.core.UserId.class);
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.GroupRolesPropagation.getDescriptor().getFields().get(1);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, convertedValue, "userMember");
        getMessageBuilder().setUserMember(index, convertedValue);
        return this;
    }

    @CanIgnoreReturnValue
    public GroupRolesPropagationVBuilder addAllRawUserMember(String value) throws
            ValidationException, ConversionException {
        final List<UserId> convertedValue = convertToList(value, UserId.class);
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.GroupRolesPropagation.getDescriptor().getFields().get(1);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, convertedValue, "userMember");
        getMessageBuilder().addAllUserMember(convertedValue);
        return this;
    }

    @CanIgnoreReturnValue
    public GroupRolesPropagationVBuilder addRawUserMember(int index, String value) throws
            ValidationException, ConversionException {
        io.spine.core.UserId convertedValue = convert(value, io.spine.core.UserId.class);
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.GroupRolesPropagation.getDescriptor().getFields().get(1);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, convertedValue, "userMember");
        getMessageBuilder().addUserMember(index, convertedValue);
        return this;
    }

    public List<RoleId> getRole() {
        return getMessageBuilder().getRoleList();
    }

    @CanIgnoreReturnValue
    public GroupRolesPropagationVBuilder clearRole() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.GroupRolesPropagation.getDescriptor().getFields().get(2);
        checkNotSetOnce(fieldDescriptor);
        getMessageBuilder().clearRole();
        return this;
    }

    @CanIgnoreReturnValue
    public GroupRolesPropagationVBuilder addRole(RoleId value) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.GroupRolesPropagation.getDescriptor().getFields().get(2);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, value, "role");
        getMessageBuilder().addRole(value);
        return this;
    }

    @CanIgnoreReturnValue
    public GroupRolesPropagationVBuilder setRole(int index, RoleId value) throws
            ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.GroupRolesPropagation.getDescriptor().getFields().get(2);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, value, "role");
        getMessageBuilder().setRole(index, value);
        return this;
    }

    @CanIgnoreReturnValue
    public GroupRolesPropagationVBuilder addAllRole(List<RoleId> value) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.GroupRolesPropagation.getDescriptor().getFields().get(2);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, value, "role");
        getMessageBuilder().addAllRole(value);
        return this;
    }

    @CanIgnoreReturnValue
    public GroupRolesPropagationVBuilder addRole(int index, RoleId value) throws
            ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.GroupRolesPropagation.getDescriptor().getFields().get(2);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, value, "role");
        getMessageBuilder().addRole(index, value);
        return this;
    }

    @CanIgnoreReturnValue
    public GroupRolesPropagationVBuilder removeRole(int index) {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.GroupRolesPropagation.getDescriptor().getFields().get(2);
        checkNotSetOnce(fieldDescriptor);
        getMessageBuilder().removeRole(index);
        return this;
    }

    @CanIgnoreReturnValue
    public GroupRolesPropagationVBuilder addRawRole(String value) throws ValidationException,
            ConversionException {
        io.spine.users.RoleId convertedValue = convert(value, io.spine.users.RoleId.class);
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.GroupRolesPropagation.getDescriptor().getFields().get(2);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, convertedValue, "role");
        getMessageBuilder().addRole(convertedValue);
        return this;
    }

    @CanIgnoreReturnValue
    public GroupRolesPropagationVBuilder setRawRole(int index, String value) throws
            ValidationException, ConversionException {
        io.spine.users.RoleId convertedValue = convert(value, io.spine.users.RoleId.class);
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.GroupRolesPropagation.getDescriptor().getFields().get(2);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, convertedValue, "role");
        getMessageBuilder().setRole(index, convertedValue);
        return this;
    }

    @CanIgnoreReturnValue
    public GroupRolesPropagationVBuilder addAllRawRole(String value) throws ValidationException,
            ConversionException {
        final List<RoleId> convertedValue = convertToList(value, RoleId.class);
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.GroupRolesPropagation.getDescriptor().getFields().get(2);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, convertedValue, "role");
        getMessageBuilder().addAllRole(convertedValue);
        return this;
    }

    @CanIgnoreReturnValue
    public GroupRolesPropagationVBuilder addRawRole(int index, String value) throws
            ValidationException, ConversionException {
        io.spine.users.RoleId convertedValue = convert(value, io.spine.users.RoleId.class);
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.GroupRolesPropagation.getDescriptor().getFields().get(2);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, convertedValue, "role");
        getMessageBuilder().addRole(index, convertedValue);
        return this;
    }

    @Override
    @CanIgnoreReturnValue
    public GroupRolesPropagationVBuilder mergeFrom(GroupRolesPropagation message) {
        Map<Descriptors.FieldDescriptor, Object> fieldsMap = message.getAllFields();
        for (Map.Entry<Descriptors.FieldDescriptor, Object> entry : fieldsMap.entrySet()) {
            validateSetOnce(entry.getKey(), entry.getValue());
        }
        super.mergeFrom(message);
        return this;
    }
}
