package io.spine.users.group;

import com.google.errorprone.annotations.CanIgnoreReturnValue;
import com.google.protobuf.Descriptors;
import io.spine.base.ConversionException;
import io.spine.net.EmailAddress;
import io.spine.net.InternetDomain;
import io.spine.users.GroupId;
import io.spine.users.OrganizationOrUnit;
import io.spine.users.RoleId;
import io.spine.validate.AbstractValidatingBuilder;
import io.spine.validate.ValidationException;
import java.util.List;
import java.util.Map;
import javax.annotation.Generated;

@Generated("by Spine Model Compiler")
public final class GroupVBuilder extends AbstractValidatingBuilder<Group, Group.Builder> {
    private GroupVBuilder() {
    }

    public static GroupVBuilder newBuilder() {
        return new GroupVBuilder();
    }

    @CanIgnoreReturnValue
    public GroupVBuilder setId(GroupId id) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.Group.getDescriptor().getFields().get(0);
        validateSetOnce(fieldDescriptor, id);
        validate(fieldDescriptor, id, "id");
        getMessageBuilder().setId(id);
        return this;
    }

    @CanIgnoreReturnValue
    public GroupVBuilder setRawId(String id) throws ValidationException, ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.Group.getDescriptor().getFields().get(0);
        io.spine.users.GroupId convertedId = convert(id, io.spine.users.GroupId.class);
        validateSetOnce(fieldDescriptor, convertedId);
        validate(fieldDescriptor, convertedId, "id");
        getMessageBuilder().setId(convertedId);
        return this;
    }

    public GroupId getId() {
        return getMessageBuilder().getId();
    }

    @CanIgnoreReturnValue
    public GroupVBuilder clearId() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.Group.getDescriptor().getFields().get(0);
        validateSetOnce(fieldDescriptor, io.spine.users.group.Group.getDefaultInstance().getId());
        getMessageBuilder().clearId();
        return this;
    }

    @CanIgnoreReturnValue
    public GroupVBuilder setDisplayName(String displayName) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.Group.getDescriptor().getFields().get(1);
        validateSetOnce(fieldDescriptor, displayName);
        validate(fieldDescriptor, displayName, "displayName");
        getMessageBuilder().setDisplayName(displayName);
        return this;
    }

    public String getDisplayName() {
        return getMessageBuilder().getDisplayName();
    }

    @CanIgnoreReturnValue
    public GroupVBuilder clearDisplayName() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.Group.getDescriptor().getFields().get(1);
        validateSetOnce(fieldDescriptor, io.spine.users.group.Group.getDefaultInstance().getDisplayName());
        getMessageBuilder().clearDisplayName();
        return this;
    }

    @CanIgnoreReturnValue
    public GroupVBuilder setEmail(EmailAddress email) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.Group.getDescriptor().getFields().get(2);
        validateSetOnce(fieldDescriptor, email);
        validate(fieldDescriptor, email, "email");
        getMessageBuilder().setEmail(email);
        return this;
    }

    @CanIgnoreReturnValue
    public GroupVBuilder setRawEmail(String email) throws ValidationException, ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.Group.getDescriptor().getFields().get(2);
        io.spine.net.EmailAddress convertedEmail = convert(email, io.spine.net.EmailAddress.class);
        validateSetOnce(fieldDescriptor, convertedEmail);
        validate(fieldDescriptor, convertedEmail, "email");
        getMessageBuilder().setEmail(convertedEmail);
        return this;
    }

    public EmailAddress getEmail() {
        return getMessageBuilder().getEmail();
    }

    @CanIgnoreReturnValue
    public GroupVBuilder clearEmail() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.Group.getDescriptor().getFields().get(2);
        validateSetOnce(fieldDescriptor, io.spine.users.group.Group.getDefaultInstance().getEmail());
        getMessageBuilder().clearEmail();
        return this;
    }

    @CanIgnoreReturnValue
    public GroupVBuilder setDescription(String description) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.Group.getDescriptor().getFields().get(3);
        validateSetOnce(fieldDescriptor, description);
        validate(fieldDescriptor, description, "description");
        getMessageBuilder().setDescription(description);
        return this;
    }

    public String getDescription() {
        return getMessageBuilder().getDescription();
    }

    @CanIgnoreReturnValue
    public GroupVBuilder clearDescription() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.Group.getDescriptor().getFields().get(3);
        validateSetOnce(fieldDescriptor, io.spine.users.group.Group.getDefaultInstance().getDescription());
        getMessageBuilder().clearDescription();
        return this;
    }

    @CanIgnoreReturnValue
    public GroupVBuilder setOrgEntity(OrganizationOrUnit orgEntity) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.Group.getDescriptor().getFields().get(4);
        validateSetOnce(fieldDescriptor, orgEntity);
        validate(fieldDescriptor, orgEntity, "orgEntity");
        getMessageBuilder().setOrgEntity(orgEntity);
        return this;
    }

    @CanIgnoreReturnValue
    public GroupVBuilder setRawOrgEntity(String orgEntity) throws ValidationException,
            ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.Group.getDescriptor().getFields().get(4);
        io.spine.users.OrganizationOrUnit convertedOrgEntity = convert(orgEntity, io.spine.users.OrganizationOrUnit.class);
        validateSetOnce(fieldDescriptor, convertedOrgEntity);
        validate(fieldDescriptor, convertedOrgEntity, "orgEntity");
        getMessageBuilder().setOrgEntity(convertedOrgEntity);
        return this;
    }

    public OrganizationOrUnit getOrgEntity() {
        return getMessageBuilder().getOrgEntity();
    }

    @CanIgnoreReturnValue
    public GroupVBuilder clearOrgEntity() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.Group.getDescriptor().getFields().get(4);
        validateSetOnce(fieldDescriptor, io.spine.users.group.Group.getDefaultInstance().getOrgEntity());
        getMessageBuilder().clearOrgEntity();
        return this;
    }

    @CanIgnoreReturnValue
    public GroupVBuilder setExternalDomain(InternetDomain externalDomain) throws
            ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.Group.getDescriptor().getFields().get(5);
        validateSetOnce(fieldDescriptor, externalDomain);
        validate(fieldDescriptor, externalDomain, "externalDomain");
        getMessageBuilder().setExternalDomain(externalDomain);
        return this;
    }

    @CanIgnoreReturnValue
    public GroupVBuilder setRawExternalDomain(String externalDomain) throws ValidationException,
            ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.Group.getDescriptor().getFields().get(5);
        io.spine.net.InternetDomain convertedExternalDomain = convert(externalDomain, io.spine.net.InternetDomain.class);
        validateSetOnce(fieldDescriptor, convertedExternalDomain);
        validate(fieldDescriptor, convertedExternalDomain, "externalDomain");
        getMessageBuilder().setExternalDomain(convertedExternalDomain);
        return this;
    }

    public InternetDomain getExternalDomain() {
        return getMessageBuilder().getExternalDomain();
    }

    @CanIgnoreReturnValue
    public GroupVBuilder clearExternalDomain() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.Group.getDescriptor().getFields().get(5);
        validateSetOnce(fieldDescriptor, io.spine.users.group.Group.getDefaultInstance().getExternalDomain());
        getMessageBuilder().clearExternalDomain();
        return this;
    }

    public List<RoleId> getRole() {
        return getMessageBuilder().getRoleList();
    }

    @CanIgnoreReturnValue
    public GroupVBuilder clearRole() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.Group.getDescriptor().getFields().get(6);
        checkNotSetOnce(fieldDescriptor);
        getMessageBuilder().clearRole();
        return this;
    }

    @CanIgnoreReturnValue
    public GroupVBuilder addRole(RoleId value) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.Group.getDescriptor().getFields().get(6);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, value, "role");
        getMessageBuilder().addRole(value);
        return this;
    }

    @CanIgnoreReturnValue
    public GroupVBuilder setRole(int index, RoleId value) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.Group.getDescriptor().getFields().get(6);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, value, "role");
        getMessageBuilder().setRole(index, value);
        return this;
    }

    @CanIgnoreReturnValue
    public GroupVBuilder addAllRole(List<RoleId> value) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.Group.getDescriptor().getFields().get(6);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, value, "role");
        getMessageBuilder().addAllRole(value);
        return this;
    }

    @CanIgnoreReturnValue
    public GroupVBuilder addRole(int index, RoleId value) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.Group.getDescriptor().getFields().get(6);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, value, "role");
        getMessageBuilder().addRole(index, value);
        return this;
    }

    @CanIgnoreReturnValue
    public GroupVBuilder removeRole(int index) {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.Group.getDescriptor().getFields().get(6);
        checkNotSetOnce(fieldDescriptor);
        getMessageBuilder().removeRole(index);
        return this;
    }

    @CanIgnoreReturnValue
    public GroupVBuilder addRawRole(String value) throws ValidationException, ConversionException {
        io.spine.users.RoleId convertedValue = convert(value, io.spine.users.RoleId.class);
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.Group.getDescriptor().getFields().get(6);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, convertedValue, "role");
        getMessageBuilder().addRole(convertedValue);
        return this;
    }

    @CanIgnoreReturnValue
    public GroupVBuilder setRawRole(int index, String value) throws ValidationException,
            ConversionException {
        io.spine.users.RoleId convertedValue = convert(value, io.spine.users.RoleId.class);
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.Group.getDescriptor().getFields().get(6);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, convertedValue, "role");
        getMessageBuilder().setRole(index, convertedValue);
        return this;
    }

    @CanIgnoreReturnValue
    public GroupVBuilder addAllRawRole(String value) throws ValidationException,
            ConversionException {
        final List<RoleId> convertedValue = convertToList(value, RoleId.class);
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.Group.getDescriptor().getFields().get(6);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, convertedValue, "role");
        getMessageBuilder().addAllRole(convertedValue);
        return this;
    }

    @CanIgnoreReturnValue
    public GroupVBuilder addRawRole(int index, String value) throws ValidationException,
            ConversionException {
        io.spine.users.RoleId convertedValue = convert(value, io.spine.users.RoleId.class);
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.Group.getDescriptor().getFields().get(6);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, convertedValue, "role");
        getMessageBuilder().addRole(index, convertedValue);
        return this;
    }

    @Override
    @CanIgnoreReturnValue
    public GroupVBuilder mergeFrom(Group message) {
        Map<Descriptors.FieldDescriptor, Object> fieldsMap = message.getAllFields();
        for (Map.Entry<Descriptors.FieldDescriptor, Object> entry : fieldsMap.entrySet()) {
            validateSetOnce(entry.getKey(), entry.getValue());
        }
        super.mergeFrom(message);
        return this;
    }
}
