package io.spine.users.group.command;

import com.google.errorprone.annotations.CanIgnoreReturnValue;
import com.google.protobuf.Descriptors;
import io.spine.base.ConversionException;
import io.spine.net.EmailAddress;
import io.spine.net.InternetDomain;
import io.spine.users.GroupId;
import io.spine.users.OrganizationOrUnit;
import io.spine.validate.AbstractValidatingBuilder;
import io.spine.validate.ValidationException;
import java.util.Map;
import javax.annotation.Generated;

@Generated("by Spine Model Compiler")
public final class CreateGroupVBuilder extends AbstractValidatingBuilder<CreateGroup, CreateGroup.Builder> {
    private CreateGroupVBuilder() {
    }

    public static CreateGroupVBuilder newBuilder() {
        return new CreateGroupVBuilder();
    }

    @CanIgnoreReturnValue
    public CreateGroupVBuilder setId(GroupId id) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.command.CreateGroup.getDescriptor().getFields().get(0);
        validateSetOnce(fieldDescriptor, id);
        validate(fieldDescriptor, id, "id");
        getMessageBuilder().setId(id);
        return this;
    }

    @CanIgnoreReturnValue
    public CreateGroupVBuilder setRawId(String id) throws ValidationException, ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.command.CreateGroup.getDescriptor().getFields().get(0);
        io.spine.users.GroupId convertedId = convert(id, io.spine.users.GroupId.class);
        validateSetOnce(fieldDescriptor, convertedId);
        validate(fieldDescriptor, convertedId, "id");
        getMessageBuilder().setId(convertedId);
        return this;
    }

    public GroupId getId() {
        return getMessageBuilder().getId();
    }

    @CanIgnoreReturnValue
    public CreateGroupVBuilder clearId() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.command.CreateGroup.getDescriptor().getFields().get(0);
        validateSetOnce(fieldDescriptor, io.spine.users.group.command.CreateGroup.getDefaultInstance().getId());
        getMessageBuilder().clearId();
        return this;
    }

    @CanIgnoreReturnValue
    public CreateGroupVBuilder setDisplayName(String displayName) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.command.CreateGroup.getDescriptor().getFields().get(1);
        validateSetOnce(fieldDescriptor, displayName);
        validate(fieldDescriptor, displayName, "displayName");
        getMessageBuilder().setDisplayName(displayName);
        return this;
    }

    public String getDisplayName() {
        return getMessageBuilder().getDisplayName();
    }

    @CanIgnoreReturnValue
    public CreateGroupVBuilder clearDisplayName() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.command.CreateGroup.getDescriptor().getFields().get(1);
        validateSetOnce(fieldDescriptor, io.spine.users.group.command.CreateGroup.getDefaultInstance().getDisplayName());
        getMessageBuilder().clearDisplayName();
        return this;
    }

    @CanIgnoreReturnValue
    public CreateGroupVBuilder setDescription(String description) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.command.CreateGroup.getDescriptor().getFields().get(2);
        validateSetOnce(fieldDescriptor, description);
        validate(fieldDescriptor, description, "description");
        getMessageBuilder().setDescription(description);
        return this;
    }

    public String getDescription() {
        return getMessageBuilder().getDescription();
    }

    @CanIgnoreReturnValue
    public CreateGroupVBuilder clearDescription() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.command.CreateGroup.getDescriptor().getFields().get(2);
        validateSetOnce(fieldDescriptor, io.spine.users.group.command.CreateGroup.getDefaultInstance().getDescription());
        getMessageBuilder().clearDescription();
        return this;
    }

    @CanIgnoreReturnValue
    public CreateGroupVBuilder setOrgEntity(OrganizationOrUnit orgEntity) throws
            ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.command.CreateGroup.getDescriptor().getFields().get(3);
        validateSetOnce(fieldDescriptor, orgEntity);
        validate(fieldDescriptor, orgEntity, "orgEntity");
        getMessageBuilder().setOrgEntity(orgEntity);
        return this;
    }

    @CanIgnoreReturnValue
    public CreateGroupVBuilder setRawOrgEntity(String orgEntity) throws ValidationException,
            ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.command.CreateGroup.getDescriptor().getFields().get(3);
        io.spine.users.OrganizationOrUnit convertedOrgEntity = convert(orgEntity, io.spine.users.OrganizationOrUnit.class);
        validateSetOnce(fieldDescriptor, convertedOrgEntity);
        validate(fieldDescriptor, convertedOrgEntity, "orgEntity");
        getMessageBuilder().setOrgEntity(convertedOrgEntity);
        return this;
    }

    public OrganizationOrUnit getOrgEntity() {
        return getMessageBuilder().getOrgEntity();
    }

    @CanIgnoreReturnValue
    public CreateGroupVBuilder clearOrgEntity() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.command.CreateGroup.getDescriptor().getFields().get(3);
        validateSetOnce(fieldDescriptor, io.spine.users.group.command.CreateGroup.getDefaultInstance().getOrgEntity());
        getMessageBuilder().clearOrgEntity();
        return this;
    }

    @CanIgnoreReturnValue
    public CreateGroupVBuilder setExternalDomain(InternetDomain externalDomain) throws
            ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.command.CreateGroup.getDescriptor().getFields().get(4);
        validateSetOnce(fieldDescriptor, externalDomain);
        validate(fieldDescriptor, externalDomain, "externalDomain");
        getMessageBuilder().setExternalDomain(externalDomain);
        return this;
    }

    @CanIgnoreReturnValue
    public CreateGroupVBuilder setRawExternalDomain(String externalDomain) throws
            ValidationException, ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.command.CreateGroup.getDescriptor().getFields().get(4);
        io.spine.net.InternetDomain convertedExternalDomain = convert(externalDomain, io.spine.net.InternetDomain.class);
        validateSetOnce(fieldDescriptor, convertedExternalDomain);
        validate(fieldDescriptor, convertedExternalDomain, "externalDomain");
        getMessageBuilder().setExternalDomain(convertedExternalDomain);
        return this;
    }

    public InternetDomain getExternalDomain() {
        return getMessageBuilder().getExternalDomain();
    }

    @CanIgnoreReturnValue
    public CreateGroupVBuilder clearExternalDomain() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.command.CreateGroup.getDescriptor().getFields().get(4);
        validateSetOnce(fieldDescriptor, io.spine.users.group.command.CreateGroup.getDefaultInstance().getExternalDomain());
        getMessageBuilder().clearExternalDomain();
        return this;
    }

    @CanIgnoreReturnValue
    public CreateGroupVBuilder setEmail(EmailAddress email) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.command.CreateGroup.getDescriptor().getFields().get(5);
        validateSetOnce(fieldDescriptor, email);
        validate(fieldDescriptor, email, "email");
        getMessageBuilder().setEmail(email);
        return this;
    }

    @CanIgnoreReturnValue
    public CreateGroupVBuilder setRawEmail(String email) throws ValidationException,
            ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.command.CreateGroup.getDescriptor().getFields().get(5);
        io.spine.net.EmailAddress convertedEmail = convert(email, io.spine.net.EmailAddress.class);
        validateSetOnce(fieldDescriptor, convertedEmail);
        validate(fieldDescriptor, convertedEmail, "email");
        getMessageBuilder().setEmail(convertedEmail);
        return this;
    }

    public EmailAddress getEmail() {
        return getMessageBuilder().getEmail();
    }

    @CanIgnoreReturnValue
    public CreateGroupVBuilder clearEmail() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.command.CreateGroup.getDescriptor().getFields().get(5);
        validateSetOnce(fieldDescriptor, io.spine.users.group.command.CreateGroup.getDefaultInstance().getEmail());
        getMessageBuilder().clearEmail();
        return this;
    }

    @Override
    @CanIgnoreReturnValue
    public CreateGroupVBuilder mergeFrom(CreateGroup message) {
        Map<Descriptors.FieldDescriptor, Object> fieldsMap = message.getAllFields();
        for (Map.Entry<Descriptors.FieldDescriptor, Object> entry : fieldsMap.entrySet()) {
            validateSetOnce(entry.getKey(), entry.getValue());
        }
        super.mergeFrom(message);
        return this;
    }
}
