package io.spine.users.group.google;

import com.google.errorprone.annotations.CanIgnoreReturnValue;
import com.google.protobuf.Descriptors;
import io.spine.base.ConversionException;
import io.spine.net.EmailAddress;
import io.spine.users.GoogleGroupId;
import io.spine.users.GroupId;
import io.spine.validate.AbstractValidatingBuilder;
import io.spine.validate.ValidationException;
import java.util.List;
import java.util.Map;
import javax.annotation.Generated;

@Generated("by Spine Model Compiler")
public final class GoogleGroupVBuilder extends AbstractValidatingBuilder<GoogleGroup, GoogleGroup.Builder> {
    private GoogleGroupVBuilder() {
    }

    public static GoogleGroupVBuilder newBuilder() {
        return new GoogleGroupVBuilder();
    }

    @CanIgnoreReturnValue
    public GoogleGroupVBuilder setId(GroupId id) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.google.GoogleGroup.getDescriptor().getFields().get(0);
        validateSetOnce(fieldDescriptor, id);
        validate(fieldDescriptor, id, "id");
        getMessageBuilder().setId(id);
        return this;
    }

    @CanIgnoreReturnValue
    public GoogleGroupVBuilder setRawId(String id) throws ValidationException, ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.google.GoogleGroup.getDescriptor().getFields().get(0);
        io.spine.users.GroupId convertedId = convert(id, io.spine.users.GroupId.class);
        validateSetOnce(fieldDescriptor, convertedId);
        validate(fieldDescriptor, convertedId, "id");
        getMessageBuilder().setId(convertedId);
        return this;
    }

    public GroupId getId() {
        return getMessageBuilder().getId();
    }

    @CanIgnoreReturnValue
    public GoogleGroupVBuilder clearId() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.google.GoogleGroup.getDescriptor().getFields().get(0);
        validateSetOnce(fieldDescriptor, io.spine.users.group.google.GoogleGroup.getDefaultInstance().getId());
        getMessageBuilder().clearId();
        return this;
    }

    @CanIgnoreReturnValue
    public GoogleGroupVBuilder setGoogleId(GoogleGroupId googleId) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.google.GoogleGroup.getDescriptor().getFields().get(1);
        validateSetOnce(fieldDescriptor, googleId);
        validate(fieldDescriptor, googleId, "googleId");
        getMessageBuilder().setGoogleId(googleId);
        return this;
    }

    @CanIgnoreReturnValue
    public GoogleGroupVBuilder setRawGoogleId(String googleId) throws ValidationException,
            ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.google.GoogleGroup.getDescriptor().getFields().get(1);
        io.spine.users.GoogleGroupId convertedGoogleId = convert(googleId, io.spine.users.GoogleGroupId.class);
        validateSetOnce(fieldDescriptor, convertedGoogleId);
        validate(fieldDescriptor, convertedGoogleId, "googleId");
        getMessageBuilder().setGoogleId(convertedGoogleId);
        return this;
    }

    public GoogleGroupId getGoogleId() {
        return getMessageBuilder().getGoogleId();
    }

    @CanIgnoreReturnValue
    public GoogleGroupVBuilder clearGoogleId() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.google.GoogleGroup.getDescriptor().getFields().get(1);
        validateSetOnce(fieldDescriptor, io.spine.users.group.google.GoogleGroup.getDefaultInstance().getGoogleId());
        getMessageBuilder().clearGoogleId();
        return this;
    }

    public List<EmailAddress> getAlias() {
        return getMessageBuilder().getAliasList();
    }

    @CanIgnoreReturnValue
    public GoogleGroupVBuilder clearAlias() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.google.GoogleGroup.getDescriptor().getFields().get(2);
        checkNotSetOnce(fieldDescriptor);
        getMessageBuilder().clearAlias();
        return this;
    }

    @CanIgnoreReturnValue
    public GoogleGroupVBuilder addAlias(EmailAddress value) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.google.GoogleGroup.getDescriptor().getFields().get(2);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, value, "alias");
        getMessageBuilder().addAlias(value);
        return this;
    }

    @CanIgnoreReturnValue
    public GoogleGroupVBuilder setAlias(int index, EmailAddress value) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.google.GoogleGroup.getDescriptor().getFields().get(2);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, value, "alias");
        getMessageBuilder().setAlias(index, value);
        return this;
    }

    @CanIgnoreReturnValue
    public GoogleGroupVBuilder addAllAlias(List<EmailAddress> value) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.google.GoogleGroup.getDescriptor().getFields().get(2);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, value, "alias");
        getMessageBuilder().addAllAlias(value);
        return this;
    }

    @CanIgnoreReturnValue
    public GoogleGroupVBuilder addAlias(int index, EmailAddress value) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.google.GoogleGroup.getDescriptor().getFields().get(2);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, value, "alias");
        getMessageBuilder().addAlias(index, value);
        return this;
    }

    @CanIgnoreReturnValue
    public GoogleGroupVBuilder removeAlias(int index) {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.google.GoogleGroup.getDescriptor().getFields().get(2);
        checkNotSetOnce(fieldDescriptor);
        getMessageBuilder().removeAlias(index);
        return this;
    }

    @CanIgnoreReturnValue
    public GoogleGroupVBuilder addRawAlias(String value) throws ValidationException,
            ConversionException {
        io.spine.net.EmailAddress convertedValue = convert(value, io.spine.net.EmailAddress.class);
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.google.GoogleGroup.getDescriptor().getFields().get(2);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, convertedValue, "alias");
        getMessageBuilder().addAlias(convertedValue);
        return this;
    }

    @CanIgnoreReturnValue
    public GoogleGroupVBuilder setRawAlias(int index, String value) throws ValidationException,
            ConversionException {
        io.spine.net.EmailAddress convertedValue = convert(value, io.spine.net.EmailAddress.class);
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.google.GoogleGroup.getDescriptor().getFields().get(2);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, convertedValue, "alias");
        getMessageBuilder().setAlias(index, convertedValue);
        return this;
    }

    @CanIgnoreReturnValue
    public GoogleGroupVBuilder addAllRawAlias(String value) throws ValidationException,
            ConversionException {
        final List<EmailAddress> convertedValue = convertToList(value, EmailAddress.class);
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.google.GoogleGroup.getDescriptor().getFields().get(2);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, convertedValue, "alias");
        getMessageBuilder().addAllAlias(convertedValue);
        return this;
    }

    @CanIgnoreReturnValue
    public GoogleGroupVBuilder addRawAlias(int index, String value) throws ValidationException,
            ConversionException {
        io.spine.net.EmailAddress convertedValue = convert(value, io.spine.net.EmailAddress.class);
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.google.GoogleGroup.getDescriptor().getFields().get(2);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, convertedValue, "alias");
        getMessageBuilder().addAlias(index, convertedValue);
        return this;
    }

    @Override
    @CanIgnoreReturnValue
    public GoogleGroupVBuilder mergeFrom(GoogleGroup message) {
        Map<Descriptors.FieldDescriptor, Object> fieldsMap = message.getAllFields();
        for (Map.Entry<Descriptors.FieldDescriptor, Object> entry : fieldsMap.entrySet()) {
            validateSetOnce(entry.getKey(), entry.getValue());
        }
        super.mergeFrom(message);
        return this;
    }
}
