package io.spine.users.group.google;

import com.google.errorprone.annotations.CanIgnoreReturnValue;
import com.google.protobuf.Descriptors;
import io.spine.base.ConversionException;
import io.spine.users.GoogleIdMappingViewId;
import io.spine.users.GroupId;
import io.spine.validate.AbstractValidatingBuilder;
import io.spine.validate.ValidationException;
import java.util.Collections;
import java.util.Map;
import javax.annotation.Generated;

@Generated("by Spine Model Compiler")
public final class GoogleIdMappingViewVBuilder extends AbstractValidatingBuilder<GoogleIdMappingView, GoogleIdMappingView.Builder> {
    private GoogleIdMappingViewVBuilder() {
    }

    public static GoogleIdMappingViewVBuilder newBuilder() {
        return new GoogleIdMappingViewVBuilder();
    }

    @CanIgnoreReturnValue
    public GoogleIdMappingViewVBuilder setId(GoogleIdMappingViewId id) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.google.GoogleIdMappingView.getDescriptor().getFields().get(0);
        validateSetOnce(fieldDescriptor, id);
        validate(fieldDescriptor, id, "id");
        getMessageBuilder().setId(id);
        return this;
    }

    @CanIgnoreReturnValue
    public GoogleIdMappingViewVBuilder setRawId(String id) throws ValidationException,
            ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.google.GoogleIdMappingView.getDescriptor().getFields().get(0);
        io.spine.users.GoogleIdMappingViewId convertedId = convert(id, io.spine.users.GoogleIdMappingViewId.class);
        validateSetOnce(fieldDescriptor, convertedId);
        validate(fieldDescriptor, convertedId, "id");
        getMessageBuilder().setId(convertedId);
        return this;
    }

    public GoogleIdMappingViewId getId() {
        return getMessageBuilder().getId();
    }

    @CanIgnoreReturnValue
    public GoogleIdMappingViewVBuilder clearId() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.google.GoogleIdMappingView.getDescriptor().getFields().get(0);
        validateSetOnce(fieldDescriptor, io.spine.users.group.google.GoogleIdMappingView.getDefaultInstance().getId());
        getMessageBuilder().clearId();
        return this;
    }

    public Map<String, GroupId> getGroupsMap() {
        return getMessageBuilder().getGroupsMap();
    }

    @CanIgnoreReturnValue
    public GoogleIdMappingViewVBuilder putGroups(String key, GroupId value) throws
            ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.google.GoogleIdMappingView.getDescriptor().getFields().get(1);
        checkNotSetOnce(fieldDescriptor);
        final Map<String, GroupId> mapToValidate = Collections.singletonMap(key, value);
        validate(fieldDescriptor, mapToValidate, "groups");
        getMessageBuilder().putGroups(key, value);
        return this;
    }

    @CanIgnoreReturnValue
    public GoogleIdMappingViewVBuilder clearGroups() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.google.GoogleIdMappingView.getDescriptor().getFields().get(1);
        checkNotSetOnce(fieldDescriptor);
        getMessageBuilder().clearGroups();
        return this;
    }

    @CanIgnoreReturnValue
    public GoogleIdMappingViewVBuilder putAllGroups(Map<String, GroupId> map) throws
            ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.google.GoogleIdMappingView.getDescriptor().getFields().get(1);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, map, "groups");
        getMessageBuilder().putAllGroups(map);
        return this;
    }

    @CanIgnoreReturnValue
    public GoogleIdMappingViewVBuilder removeGroups(String key) {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.google.GoogleIdMappingView.getDescriptor().getFields().get(1);
        checkNotSetOnce(fieldDescriptor);
        getMessageBuilder().removeGroups(key);
        return this;
    }

    @CanIgnoreReturnValue
    public GoogleIdMappingViewVBuilder putRawgroups(String key, String value) throws
            ValidationException, ConversionException {
        java.lang.String convertedKey = convert(key, java.lang.String.class);
        io.spine.users.GroupId convertedValue = convert(value, io.spine.users.GroupId.class);
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.google.GoogleIdMappingView.getDescriptor().getFields().get(1);
        checkNotSetOnce(fieldDescriptor);
        final Map<String, GroupId> mapToValidate = Collections.singletonMap(convertedKey, convertedValue);
        validate(fieldDescriptor, mapToValidate, "groups");
        getMessageBuilder().putGroups(convertedKey, convertedValue);
        return this;
    }

    @CanIgnoreReturnValue
    public GoogleIdMappingViewVBuilder putAllGroups(String map) throws ValidationException,
            ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.group.google.GoogleIdMappingView.getDescriptor().getFields().get(1);
        checkNotSetOnce(fieldDescriptor);
        final Map<String, GroupId> convertedValue = convertToMap(map, String.class, GroupId.class);
        getMessageBuilder().putAllGroups(convertedValue);
        return this;
    }

    @Override
    @CanIgnoreReturnValue
    public GoogleIdMappingViewVBuilder mergeFrom(GoogleIdMappingView message) {
        Map<Descriptors.FieldDescriptor, Object> fieldsMap = message.getAllFields();
        for (Map.Entry<Descriptors.FieldDescriptor, Object> entry : fieldsMap.entrySet()) {
            validateSetOnce(entry.getKey(), entry.getValue());
        }
        super.mergeFrom(message);
        return this;
    }
}
