package io.spine.users.group.rejection;

import io.spine.base.ThrowableMessage;
import io.spine.net.InternetDomain;
import io.spine.users.GroupId;
import io.spine.validate.Validate;
import javax.annotation.Generated;

/**
 * <pre>
 *  The rejection to moving an external user.
 *
 * </pre>
 *
 * Rejection based on proto type {@code io.spine.users.group.rejection.CannotMoveExternalGroup}
 */
@Generated("by Spine Model Compiler")
public class CannotMoveExternalGroup extends ThrowableMessage {
    private static final long serialVersionUID = 0L;

    /**
     * Creates a new instance.
     *
     * @param builder the builder for the rejection
     */
    private CannotMoveExternalGroup(Builder builder) {
        super(builder.rejectionMessage());
    }

    @Override
    public Rejections.CannotMoveExternalGroup messageThrown() {
        return (Rejections.CannotMoveExternalGroup) super.messageThrown();
    }

    /**
     * @return a new builder for the rejection
     */
    public static Builder newBuilder() {
        return new Builder();
    }

    /**
     * The builder for the {@code CannotMoveExternalGroup} rejection.
     */
    public static class Builder {
        private final Rejections.CannotMoveExternalGroup.Builder builder = Rejections.CannotMoveExternalGroup.newBuilder();

        /**
         * Prevent direct instantiation of the builder.
         */
        private Builder() {
        }

        public Builder setId(GroupId id) {
            builder.setId(id);
            return this;
        }

        /**
         * <pre>
         *  An external domain the group belongs to.
         * </pre>
         */
        public Builder setExternalDomain(InternetDomain externalDomain) {
            builder.setExternalDomain(externalDomain);
            return this;
        }

        /**
         * Obtains the rejection and validates it.
         */
        private Rejections.CannotMoveExternalGroup rejectionMessage() {
            Rejections.CannotMoveExternalGroup message = builder.build();
            Validate.checkValid(message);
            return message;
        }

        /**
         * Creates the rejection from the builder and validates it.
         */
        public CannotMoveExternalGroup build() {
            return new CannotMoveExternalGroup(this);
        }
    }
}
