package io.spine.users.group.rejection;

import io.spine.base.ThrowableMessage;
import io.spine.users.GroupId;
import io.spine.validate.Validate;
import javax.annotation.Generated;

/**
 * <pre>
 *  The rejection is generated when joining a parent group forms a cycle.
 *
 * </pre>
 *
 * Rejection based on proto type {@code io.spine.users.group.rejection.GroupsCannotFormCycles}
 */
@Generated("by Spine Model Compiler")
public class GroupsCannotFormCycles extends ThrowableMessage {
    private static final long serialVersionUID = 0L;

    /**
     * Creates a new instance.
     *
     * @param builder the builder for the rejection
     */
    private GroupsCannotFormCycles(Builder builder) {
        super(builder.rejectionMessage());
    }

    @Override
    public Rejections.GroupsCannotFormCycles messageThrown() {
        return (Rejections.GroupsCannotFormCycles) super.messageThrown();
    }

    /**
     * @return a new builder for the rejection
     */
    public static Builder newBuilder() {
        return new Builder();
    }

    /**
     * The builder for the {@code GroupsCannotFormCycles} rejection.
     */
    public static class Builder {
        private final Rejections.GroupsCannotFormCycles.Builder builder = Rejections.GroupsCannotFormCycles.newBuilder();

        /**
         * Prevent direct instantiation of the builder.
         */
        private Builder() {
        }

        public Builder setId(GroupId id) {
            builder.setId(id);
            return this;
        }

        /**
         * <pre>
         *  A group that closes a cycle.
         * </pre>
         */
        public Builder setClosingGroup(GroupId closingGroup) {
            builder.setClosingGroup(closingGroup);
            return this;
        }

        /**
         * Obtains the rejection and validates it.
         */
        private Rejections.GroupsCannotFormCycles rejectionMessage() {
            Rejections.GroupsCannotFormCycles message = builder.build();
            Validate.checkValid(message);
            return message;
        }

        /**
         * Creates the rejection from the builder and validates it.
         */
        public GroupsCannotFormCycles build() {
            return new GroupsCannotFormCycles(this);
        }
    }
}
