package io.spine.users.group.rejection;

import io.spine.base.ThrowableMessage;
import io.spine.users.GroupId;
import io.spine.users.RoleId;
import io.spine.validate.Validate;
import javax.annotation.Generated;

/**
 * <pre>
 *  The rejection is generated when trying to remove a role that isn't assigned to a group.
 *
 * </pre>
 *
 * Rejection based on proto type {@code io.spine.users.group.rejection.RoleIsNotAssignedToGroup}
 */
@Generated("by Spine Model Compiler")
public class RoleIsNotAssignedToGroup extends ThrowableMessage {
    private static final long serialVersionUID = 0L;

    /**
     * Creates a new instance.
     *
     * @param builder the builder for the rejection
     */
    private RoleIsNotAssignedToGroup(Builder builder) {
        super(builder.rejectionMessage());
    }

    @Override
    public Rejections.RoleIsNotAssignedToGroup messageThrown() {
        return (Rejections.RoleIsNotAssignedToGroup) super.messageThrown();
    }

    /**
     * @return a new builder for the rejection
     */
    public static Builder newBuilder() {
        return new Builder();
    }

    /**
     * The builder for the {@code RoleIsNotAssignedToGroup} rejection.
     */
    public static class Builder {
        private final Rejections.RoleIsNotAssignedToGroup.Builder builder = Rejections.RoleIsNotAssignedToGroup.newBuilder();

        /**
         * Prevent direct instantiation of the builder.
         */
        private Builder() {
        }

        public Builder setId(GroupId id) {
            builder.setId(id);
            return this;
        }

        /**
         * <pre>
         *  An ID of the role.
         * </pre>
         */
        public Builder setRoleId(RoleId roleId) {
            builder.setRoleId(roleId);
            return this;
        }

        /**
         * Obtains the rejection and validates it.
         */
        private Rejections.RoleIsNotAssignedToGroup rejectionMessage() {
            Rejections.RoleIsNotAssignedToGroup message = builder.build();
            Validate.checkValid(message);
            return message;
        }

        /**
         * Creates the rejection from the builder and validates it.
         */
        public RoleIsNotAssignedToGroup build() {
            return new RoleIsNotAssignedToGroup(this);
        }
    }
}
