package io.spine.users.organization;

import com.google.errorprone.annotations.CanIgnoreReturnValue;
import com.google.protobuf.Descriptors;
import io.spine.base.ConversionException;
import io.spine.core.TenantId;
import io.spine.net.InternetDomain;
import io.spine.users.OrganizationId;
import io.spine.validate.AbstractValidatingBuilder;
import io.spine.validate.ValidationException;
import java.util.Map;
import javax.annotation.Generated;

@Generated("by Spine Model Compiler")
public final class OrganizationVBuilder extends AbstractValidatingBuilder<Organization, Organization.Builder> {
    private OrganizationVBuilder() {
    }

    public static OrganizationVBuilder newBuilder() {
        return new OrganizationVBuilder();
    }

    @CanIgnoreReturnValue
    public OrganizationVBuilder setId(OrganizationId id) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.organization.Organization.getDescriptor().getFields().get(0);
        validateSetOnce(fieldDescriptor, id);
        validate(fieldDescriptor, id, "id");
        getMessageBuilder().setId(id);
        return this;
    }

    @CanIgnoreReturnValue
    public OrganizationVBuilder setRawId(String id) throws ValidationException,
            ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.organization.Organization.getDescriptor().getFields().get(0);
        io.spine.users.OrganizationId convertedId = convert(id, io.spine.users.OrganizationId.class);
        validateSetOnce(fieldDescriptor, convertedId);
        validate(fieldDescriptor, convertedId, "id");
        getMessageBuilder().setId(convertedId);
        return this;
    }

    public OrganizationId getId() {
        return getMessageBuilder().getId();
    }

    @CanIgnoreReturnValue
    public OrganizationVBuilder clearId() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.organization.Organization.getDescriptor().getFields().get(0);
        validateSetOnce(fieldDescriptor, io.spine.users.organization.Organization.getDefaultInstance().getId());
        getMessageBuilder().clearId();
        return this;
    }

    @CanIgnoreReturnValue
    public OrganizationVBuilder setDisplayName(String displayName) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.organization.Organization.getDescriptor().getFields().get(1);
        validateSetOnce(fieldDescriptor, displayName);
        validate(fieldDescriptor, displayName, "displayName");
        getMessageBuilder().setDisplayName(displayName);
        return this;
    }

    public String getDisplayName() {
        return getMessageBuilder().getDisplayName();
    }

    @CanIgnoreReturnValue
    public OrganizationVBuilder clearDisplayName() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.organization.Organization.getDescriptor().getFields().get(1);
        validateSetOnce(fieldDescriptor, io.spine.users.organization.Organization.getDefaultInstance().getDisplayName());
        getMessageBuilder().clearDisplayName();
        return this;
    }

    @CanIgnoreReturnValue
    public OrganizationVBuilder setDomain(InternetDomain domain) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.organization.Organization.getDescriptor().getFields().get(2);
        validateSetOnce(fieldDescriptor, domain);
        validate(fieldDescriptor, domain, "domain");
        getMessageBuilder().setDomain(domain);
        return this;
    }

    @CanIgnoreReturnValue
    public OrganizationVBuilder setRawDomain(String domain) throws ValidationException,
            ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.organization.Organization.getDescriptor().getFields().get(2);
        io.spine.net.InternetDomain convertedDomain = convert(domain, io.spine.net.InternetDomain.class);
        validateSetOnce(fieldDescriptor, convertedDomain);
        validate(fieldDescriptor, convertedDomain, "domain");
        getMessageBuilder().setDomain(convertedDomain);
        return this;
    }

    public InternetDomain getDomain() {
        return getMessageBuilder().getDomain();
    }

    @CanIgnoreReturnValue
    public OrganizationVBuilder clearDomain() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.organization.Organization.getDescriptor().getFields().get(2);
        validateSetOnce(fieldDescriptor, io.spine.users.organization.Organization.getDefaultInstance().getDomain());
        getMessageBuilder().clearDomain();
        return this;
    }

    @CanIgnoreReturnValue
    public OrganizationVBuilder setTenant(TenantId tenant) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.organization.Organization.getDescriptor().getFields().get(3);
        validateSetOnce(fieldDescriptor, tenant);
        validate(fieldDescriptor, tenant, "tenant");
        getMessageBuilder().setTenant(tenant);
        return this;
    }

    @CanIgnoreReturnValue
    public OrganizationVBuilder setRawTenant(String tenant) throws ValidationException,
            ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.organization.Organization.getDescriptor().getFields().get(3);
        io.spine.core.TenantId convertedTenant = convert(tenant, io.spine.core.TenantId.class);
        validateSetOnce(fieldDescriptor, convertedTenant);
        validate(fieldDescriptor, convertedTenant, "tenant");
        getMessageBuilder().setTenant(convertedTenant);
        return this;
    }

    public TenantId getTenant() {
        return getMessageBuilder().getTenant();
    }

    @CanIgnoreReturnValue
    public OrganizationVBuilder clearTenant() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.organization.Organization.getDescriptor().getFields().get(3);
        validateSetOnce(fieldDescriptor, io.spine.users.organization.Organization.getDefaultInstance().getTenant());
        getMessageBuilder().clearTenant();
        return this;
    }

    @Override
    @CanIgnoreReturnValue
    public OrganizationVBuilder mergeFrom(Organization message) {
        Map<Descriptors.FieldDescriptor, Object> fieldsMap = message.getAllFields();
        for (Map.Entry<Descriptors.FieldDescriptor, Object> entry : fieldsMap.entrySet()) {
            validateSetOnce(entry.getKey(), entry.getValue());
        }
        super.mergeFrom(message);
        return this;
    }
}
