package io.spine.users.organization.command;

import com.google.errorprone.annotations.CanIgnoreReturnValue;
import com.google.protobuf.Descriptors;
import io.spine.base.ConversionException;
import io.spine.core.TenantId;
import io.spine.net.InternetDomain;
import io.spine.users.OrganizationId;
import io.spine.validate.AbstractValidatingBuilder;
import io.spine.validate.ValidationException;
import java.util.Map;
import javax.annotation.Generated;

@Generated("by Spine Model Compiler")
public final class CreateOrganizationVBuilder extends AbstractValidatingBuilder<CreateOrganization, CreateOrganization.Builder> {
    private CreateOrganizationVBuilder() {
    }

    public static CreateOrganizationVBuilder newBuilder() {
        return new CreateOrganizationVBuilder();
    }

    @CanIgnoreReturnValue
    public CreateOrganizationVBuilder setId(OrganizationId id) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.organization.command.CreateOrganization.getDescriptor().getFields().get(0);
        validateSetOnce(fieldDescriptor, id);
        validate(fieldDescriptor, id, "id");
        getMessageBuilder().setId(id);
        return this;
    }

    @CanIgnoreReturnValue
    public CreateOrganizationVBuilder setRawId(String id) throws ValidationException,
            ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.organization.command.CreateOrganization.getDescriptor().getFields().get(0);
        io.spine.users.OrganizationId convertedId = convert(id, io.spine.users.OrganizationId.class);
        validateSetOnce(fieldDescriptor, convertedId);
        validate(fieldDescriptor, convertedId, "id");
        getMessageBuilder().setId(convertedId);
        return this;
    }

    public OrganizationId getId() {
        return getMessageBuilder().getId();
    }

    @CanIgnoreReturnValue
    public CreateOrganizationVBuilder clearId() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.organization.command.CreateOrganization.getDescriptor().getFields().get(0);
        validateSetOnce(fieldDescriptor, io.spine.users.organization.command.CreateOrganization.getDefaultInstance().getId());
        getMessageBuilder().clearId();
        return this;
    }

    @CanIgnoreReturnValue
    public CreateOrganizationVBuilder setDisplayName(String displayName) throws
            ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.organization.command.CreateOrganization.getDescriptor().getFields().get(1);
        validateSetOnce(fieldDescriptor, displayName);
        validate(fieldDescriptor, displayName, "displayName");
        getMessageBuilder().setDisplayName(displayName);
        return this;
    }

    public String getDisplayName() {
        return getMessageBuilder().getDisplayName();
    }

    @CanIgnoreReturnValue
    public CreateOrganizationVBuilder clearDisplayName() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.organization.command.CreateOrganization.getDescriptor().getFields().get(1);
        validateSetOnce(fieldDescriptor, io.spine.users.organization.command.CreateOrganization.getDefaultInstance().getDisplayName());
        getMessageBuilder().clearDisplayName();
        return this;
    }

    @CanIgnoreReturnValue
    public CreateOrganizationVBuilder setDomain(InternetDomain domain) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.organization.command.CreateOrganization.getDescriptor().getFields().get(2);
        validateSetOnce(fieldDescriptor, domain);
        validate(fieldDescriptor, domain, "domain");
        getMessageBuilder().setDomain(domain);
        return this;
    }

    @CanIgnoreReturnValue
    public CreateOrganizationVBuilder setRawDomain(String domain) throws ValidationException,
            ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.organization.command.CreateOrganization.getDescriptor().getFields().get(2);
        io.spine.net.InternetDomain convertedDomain = convert(domain, io.spine.net.InternetDomain.class);
        validateSetOnce(fieldDescriptor, convertedDomain);
        validate(fieldDescriptor, convertedDomain, "domain");
        getMessageBuilder().setDomain(convertedDomain);
        return this;
    }

    public InternetDomain getDomain() {
        return getMessageBuilder().getDomain();
    }

    @CanIgnoreReturnValue
    public CreateOrganizationVBuilder clearDomain() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.organization.command.CreateOrganization.getDescriptor().getFields().get(2);
        validateSetOnce(fieldDescriptor, io.spine.users.organization.command.CreateOrganization.getDefaultInstance().getDomain());
        getMessageBuilder().clearDomain();
        return this;
    }

    @CanIgnoreReturnValue
    public CreateOrganizationVBuilder setTenant(TenantId tenant) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.organization.command.CreateOrganization.getDescriptor().getFields().get(3);
        validateSetOnce(fieldDescriptor, tenant);
        validate(fieldDescriptor, tenant, "tenant");
        getMessageBuilder().setTenant(tenant);
        return this;
    }

    @CanIgnoreReturnValue
    public CreateOrganizationVBuilder setRawTenant(String tenant) throws ValidationException,
            ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.organization.command.CreateOrganization.getDescriptor().getFields().get(3);
        io.spine.core.TenantId convertedTenant = convert(tenant, io.spine.core.TenantId.class);
        validateSetOnce(fieldDescriptor, convertedTenant);
        validate(fieldDescriptor, convertedTenant, "tenant");
        getMessageBuilder().setTenant(convertedTenant);
        return this;
    }

    public TenantId getTenant() {
        return getMessageBuilder().getTenant();
    }

    @CanIgnoreReturnValue
    public CreateOrganizationVBuilder clearTenant() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.organization.command.CreateOrganization.getDescriptor().getFields().get(3);
        validateSetOnce(fieldDescriptor, io.spine.users.organization.command.CreateOrganization.getDefaultInstance().getTenant());
        getMessageBuilder().clearTenant();
        return this;
    }

    @Override
    @CanIgnoreReturnValue
    public CreateOrganizationVBuilder mergeFrom(CreateOrganization message) {
        Map<Descriptors.FieldDescriptor, Object> fieldsMap = message.getAllFields();
        for (Map.Entry<Descriptors.FieldDescriptor, Object> entry : fieldsMap.entrySet()) {
            validateSetOnce(entry.getKey(), entry.getValue());
        }
        super.mergeFrom(message);
        return this;
    }
}
