package io.spine.users.organization.event;

import com.google.errorprone.annotations.CanIgnoreReturnValue;
import com.google.protobuf.Descriptors;
import io.spine.base.ConversionException;
import io.spine.core.TenantId;
import io.spine.users.OrganizationId;
import io.spine.validate.AbstractValidatingBuilder;
import io.spine.validate.ValidationException;
import java.util.Map;
import javax.annotation.Generated;

@Generated("by Spine Model Compiler")
public final class OrganizationTenantChangedVBuilder extends AbstractValidatingBuilder<OrganizationTenantChanged, OrganizationTenantChanged.Builder> {
    private OrganizationTenantChangedVBuilder() {
    }

    public static OrganizationTenantChangedVBuilder newBuilder() {
        return new OrganizationTenantChangedVBuilder();
    }

    @CanIgnoreReturnValue
    public OrganizationTenantChangedVBuilder setId(OrganizationId id) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.organization.event.OrganizationTenantChanged.getDescriptor().getFields().get(0);
        validateSetOnce(fieldDescriptor, id);
        validate(fieldDescriptor, id, "id");
        getMessageBuilder().setId(id);
        return this;
    }

    @CanIgnoreReturnValue
    public OrganizationTenantChangedVBuilder setRawId(String id) throws ValidationException,
            ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.organization.event.OrganizationTenantChanged.getDescriptor().getFields().get(0);
        io.spine.users.OrganizationId convertedId = convert(id, io.spine.users.OrganizationId.class);
        validateSetOnce(fieldDescriptor, convertedId);
        validate(fieldDescriptor, convertedId, "id");
        getMessageBuilder().setId(convertedId);
        return this;
    }

    public OrganizationId getId() {
        return getMessageBuilder().getId();
    }

    @CanIgnoreReturnValue
    public OrganizationTenantChangedVBuilder clearId() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.organization.event.OrganizationTenantChanged.getDescriptor().getFields().get(0);
        validateSetOnce(fieldDescriptor, io.spine.users.organization.event.OrganizationTenantChanged.getDefaultInstance().getId());
        getMessageBuilder().clearId();
        return this;
    }

    @CanIgnoreReturnValue
    public OrganizationTenantChangedVBuilder setNewTenant(TenantId newTenant) throws
            ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.organization.event.OrganizationTenantChanged.getDescriptor().getFields().get(1);
        validateSetOnce(fieldDescriptor, newTenant);
        validate(fieldDescriptor, newTenant, "newTenant");
        getMessageBuilder().setNewTenant(newTenant);
        return this;
    }

    @CanIgnoreReturnValue
    public OrganizationTenantChangedVBuilder setRawNewTenant(String newTenant) throws
            ValidationException, ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.organization.event.OrganizationTenantChanged.getDescriptor().getFields().get(1);
        io.spine.core.TenantId convertedNewTenant = convert(newTenant, io.spine.core.TenantId.class);
        validateSetOnce(fieldDescriptor, convertedNewTenant);
        validate(fieldDescriptor, convertedNewTenant, "newTenant");
        getMessageBuilder().setNewTenant(convertedNewTenant);
        return this;
    }

    public TenantId getNewTenant() {
        return getMessageBuilder().getNewTenant();
    }

    @CanIgnoreReturnValue
    public OrganizationTenantChangedVBuilder clearNewTenant() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.organization.event.OrganizationTenantChanged.getDescriptor().getFields().get(1);
        validateSetOnce(fieldDescriptor, io.spine.users.organization.event.OrganizationTenantChanged.getDefaultInstance().getNewTenant());
        getMessageBuilder().clearNewTenant();
        return this;
    }

    @CanIgnoreReturnValue
    public OrganizationTenantChangedVBuilder setOldTenant(TenantId oldTenant) throws
            ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.organization.event.OrganizationTenantChanged.getDescriptor().getFields().get(2);
        validateSetOnce(fieldDescriptor, oldTenant);
        validate(fieldDescriptor, oldTenant, "oldTenant");
        getMessageBuilder().setOldTenant(oldTenant);
        return this;
    }

    @CanIgnoreReturnValue
    public OrganizationTenantChangedVBuilder setRawOldTenant(String oldTenant) throws
            ValidationException, ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.organization.event.OrganizationTenantChanged.getDescriptor().getFields().get(2);
        io.spine.core.TenantId convertedOldTenant = convert(oldTenant, io.spine.core.TenantId.class);
        validateSetOnce(fieldDescriptor, convertedOldTenant);
        validate(fieldDescriptor, convertedOldTenant, "oldTenant");
        getMessageBuilder().setOldTenant(convertedOldTenant);
        return this;
    }

    public TenantId getOldTenant() {
        return getMessageBuilder().getOldTenant();
    }

    @CanIgnoreReturnValue
    public OrganizationTenantChangedVBuilder clearOldTenant() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.organization.event.OrganizationTenantChanged.getDescriptor().getFields().get(2);
        validateSetOnce(fieldDescriptor, io.spine.users.organization.event.OrganizationTenantChanged.getDefaultInstance().getOldTenant());
        getMessageBuilder().clearOldTenant();
        return this;
    }

    @Override
    @CanIgnoreReturnValue
    public OrganizationTenantChangedVBuilder mergeFrom(OrganizationTenantChanged message) {
        Map<Descriptors.FieldDescriptor, Object> fieldsMap = message.getAllFields();
        for (Map.Entry<Descriptors.FieldDescriptor, Object> entry : fieldsMap.entrySet()) {
            validateSetOnce(entry.getKey(), entry.getValue());
        }
        super.mergeFrom(message);
        return this;
    }
}
