package io.spine.users.orgunit;

import com.google.errorprone.annotations.CanIgnoreReturnValue;
import com.google.protobuf.Descriptors;
import io.spine.base.ConversionException;
import io.spine.net.InternetDomain;
import io.spine.users.OrgUnitId;
import io.spine.users.OrganizationOrUnit;
import io.spine.validate.AbstractValidatingBuilder;
import io.spine.validate.ValidationException;
import java.util.Map;
import javax.annotation.Generated;

@Generated("by Spine Model Compiler")
public final class OrgUnitVBuilder extends AbstractValidatingBuilder<OrgUnit, OrgUnit.Builder> {
    private OrgUnitVBuilder() {
    }

    public static OrgUnitVBuilder newBuilder() {
        return new OrgUnitVBuilder();
    }

    @CanIgnoreReturnValue
    public OrgUnitVBuilder setId(OrgUnitId id) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.orgunit.OrgUnit.getDescriptor().getFields().get(0);
        validateSetOnce(fieldDescriptor, id);
        validate(fieldDescriptor, id, "id");
        getMessageBuilder().setId(id);
        return this;
    }

    @CanIgnoreReturnValue
    public OrgUnitVBuilder setRawId(String id) throws ValidationException, ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.orgunit.OrgUnit.getDescriptor().getFields().get(0);
        io.spine.users.OrgUnitId convertedId = convert(id, io.spine.users.OrgUnitId.class);
        validateSetOnce(fieldDescriptor, convertedId);
        validate(fieldDescriptor, convertedId, "id");
        getMessageBuilder().setId(convertedId);
        return this;
    }

    public OrgUnitId getId() {
        return getMessageBuilder().getId();
    }

    @CanIgnoreReturnValue
    public OrgUnitVBuilder clearId() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.orgunit.OrgUnit.getDescriptor().getFields().get(0);
        validateSetOnce(fieldDescriptor, io.spine.users.orgunit.OrgUnit.getDefaultInstance().getId());
        getMessageBuilder().clearId();
        return this;
    }

    @CanIgnoreReturnValue
    public OrgUnitVBuilder setDisplayName(String displayName) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.orgunit.OrgUnit.getDescriptor().getFields().get(1);
        validateSetOnce(fieldDescriptor, displayName);
        validate(fieldDescriptor, displayName, "displayName");
        getMessageBuilder().setDisplayName(displayName);
        return this;
    }

    public String getDisplayName() {
        return getMessageBuilder().getDisplayName();
    }

    @CanIgnoreReturnValue
    public OrgUnitVBuilder clearDisplayName() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.orgunit.OrgUnit.getDescriptor().getFields().get(1);
        validateSetOnce(fieldDescriptor, io.spine.users.orgunit.OrgUnit.getDefaultInstance().getDisplayName());
        getMessageBuilder().clearDisplayName();
        return this;
    }

    @CanIgnoreReturnValue
    public OrgUnitVBuilder setParentEntity(OrganizationOrUnit parentEntity) throws
            ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.orgunit.OrgUnit.getDescriptor().getFields().get(2);
        validateSetOnce(fieldDescriptor, parentEntity);
        validate(fieldDescriptor, parentEntity, "parentEntity");
        getMessageBuilder().setParentEntity(parentEntity);
        return this;
    }

    @CanIgnoreReturnValue
    public OrgUnitVBuilder setRawParentEntity(String parentEntity) throws ValidationException,
            ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.orgunit.OrgUnit.getDescriptor().getFields().get(2);
        io.spine.users.OrganizationOrUnit convertedParentEntity = convert(parentEntity, io.spine.users.OrganizationOrUnit.class);
        validateSetOnce(fieldDescriptor, convertedParentEntity);
        validate(fieldDescriptor, convertedParentEntity, "parentEntity");
        getMessageBuilder().setParentEntity(convertedParentEntity);
        return this;
    }

    public OrganizationOrUnit getParentEntity() {
        return getMessageBuilder().getParentEntity();
    }

    @CanIgnoreReturnValue
    public OrgUnitVBuilder clearParentEntity() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.orgunit.OrgUnit.getDescriptor().getFields().get(2);
        validateSetOnce(fieldDescriptor, io.spine.users.orgunit.OrgUnit.getDefaultInstance().getParentEntity());
        getMessageBuilder().clearParentEntity();
        return this;
    }

    @CanIgnoreReturnValue
    public OrgUnitVBuilder setDomain(InternetDomain domain) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.orgunit.OrgUnit.getDescriptor().getFields().get(3);
        validateSetOnce(fieldDescriptor, domain);
        validate(fieldDescriptor, domain, "domain");
        getMessageBuilder().setDomain(domain);
        return this;
    }

    @CanIgnoreReturnValue
    public OrgUnitVBuilder setRawDomain(String domain) throws ValidationException,
            ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.orgunit.OrgUnit.getDescriptor().getFields().get(3);
        io.spine.net.InternetDomain convertedDomain = convert(domain, io.spine.net.InternetDomain.class);
        validateSetOnce(fieldDescriptor, convertedDomain);
        validate(fieldDescriptor, convertedDomain, "domain");
        getMessageBuilder().setDomain(convertedDomain);
        return this;
    }

    public InternetDomain getDomain() {
        return getMessageBuilder().getDomain();
    }

    @CanIgnoreReturnValue
    public OrgUnitVBuilder clearDomain() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.orgunit.OrgUnit.getDescriptor().getFields().get(3);
        validateSetOnce(fieldDescriptor, io.spine.users.orgunit.OrgUnit.getDefaultInstance().getDomain());
        getMessageBuilder().clearDomain();
        return this;
    }

    @Override
    @CanIgnoreReturnValue
    public OrgUnitVBuilder mergeFrom(OrgUnit message) {
        Map<Descriptors.FieldDescriptor, Object> fieldsMap = message.getAllFields();
        for (Map.Entry<Descriptors.FieldDescriptor, Object> entry : fieldsMap.entrySet()) {
            validateSetOnce(entry.getKey(), entry.getValue());
        }
        super.mergeFrom(message);
        return this;
    }
}
