package io.spine.users.orgunit.rejection;

import io.spine.base.ThrowableMessage;
import io.spine.users.OrgUnitId;
import io.spine.validate.Validate;
import javax.annotation.Generated;

/**
 * <pre>
 *  The rejection is generated when a change to an organizational structure forms a cycle.
 *
 * </pre>
 *
 * Rejection based on proto type {@code io.spine.users.orgunit.rejection.OrgUnitsCannotFormCycles}
 */
@Generated("by Spine Model Compiler")
public class OrgUnitsCannotFormCycles extends ThrowableMessage {
    private static final long serialVersionUID = 0L;

    /**
     * Creates a new instance.
     *
     * @param builder the builder for the rejection
     */
    private OrgUnitsCannotFormCycles(Builder builder) {
        super(builder.rejectionMessage());
    }

    @Override
    public Rejections.OrgUnitsCannotFormCycles messageThrown() {
        return (Rejections.OrgUnitsCannotFormCycles) super.messageThrown();
    }

    /**
     * @return a new builder for the rejection
     */
    public static Builder newBuilder() {
        return new Builder();
    }

    /**
     * The builder for the {@code OrgUnitsCannotFormCycles} rejection.
     */
    public static class Builder {
        private final Rejections.OrgUnitsCannotFormCycles.Builder builder = Rejections.OrgUnitsCannotFormCycles.newBuilder();

        /**
         * Prevent direct instantiation of the builder.
         */
        private Builder() {
        }

        public Builder setId(OrgUnitId id) {
            builder.setId(id);
            return this;
        }

        /**
         * <pre>
         *  An orgunit that closes a cycle.
         * </pre>
         */
        public Builder setClosingOrgUnit(OrgUnitId closingOrgUnit) {
            builder.setClosingOrgUnit(closingOrgUnit);
            return this;
        }

        /**
         * Obtains the rejection and validates it.
         */
        private Rejections.OrgUnitsCannotFormCycles rejectionMessage() {
            Rejections.OrgUnitsCannotFormCycles message = builder.build();
            Validate.checkValid(message);
            return message;
        }

        /**
         * Creates the rejection from the builder and validates it.
         */
        public OrgUnitsCannotFormCycles build() {
            return new OrgUnitsCannotFormCycles(this);
        }
    }
}
