// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: spine/users/role/role.proto

package io.spine.users.role;

/**
 * <pre>
 * A role that can be assigned to `Users` and `Groups`, to perform access control.
 * Roles are assigned to `Users` and `Group` directly and explicitly (please see `AssignRoleToUser`,
 * `AssignRoleToUser` commands). A `Role` exists in the scope of an organization or an orgunit,
 * therefore it can be assigned only to those `Users` and `Groups` that are in the same organization
 * and/or orgunit (or their child orgunits).
 * ## Access Control
 * The roles assigned to a `Group` are recursively propagated to all members of the group.
 * This propagation is implicit and is not reflected in aggregate states.
 * Therefore, when carrying out role-based access control, consider that a `User` or a `Group`
 * has not only the roles listed in the aggregate state but effectively all the roles derived from
 * parent groups.
 * ## Case Study
 * Here is a simple case study to facilitate understanding of the roles.
 * Consider the following organizational structure:
 * ```
 *          Chips &amp; Cookies            &lt;-- Organization
 *            /          &#92;
 *      Accounting   Cookie Factory    &lt;-- OrgUnit
 *          /   &#92;         &#92;
 *         /   John Doe  Jack Jackson  &lt;-- User
 *        /
 *  external_auditors                  &lt;-- Group
 *       |
 *   Jane Smith                        &lt;-- User
 * ```
 * Here are the statements about "Chips &amp; Cookies" that will help you gain intuition on
 * how to apply roles in your application:
 * 1. If `office-visitor` role belongs to "Chips &amp; Cookies" organization it can be assigned to any
 *    user or group depicted above.
 * 2. If `color-printer-user` role belongs to "Accounting" orgunit it can be assigned only to
 *    John Doe, Jane Smith, and `external_audior` group.
 * 3. If `bank-account-reader` role is assigned to `external_auditors` group, Jane Smith as a member
 *    of the group implicitly has this role too.
 * 4. If `3rd-floor-visitor` role is assigned to Jane Smith, she effectively has both this role
 *    and all roles from `external_auditors` group.
 * 5. Jack Jackson can't be assigned `color-printer-user` role because it belongs to another
 *    organizational unit.
 * </pre>
 *
 * Protobuf type {@code spine.users.role.Role}
 */
public  final class Role extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:spine.users.role.Role)
    RoleOrBuilder {
private static final long serialVersionUID = 0L;
  // Use Role.newBuilder() to construct.
  private Role(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private Role() {
    displayName_ = "";
  }

  @java.lang.Override
  public final com.google.protobuf.UnknownFieldSet
  getUnknownFields() {
    return this.unknownFields;
  }
  private Role(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    this();
    if (extensionRegistry == null) {
      throw new java.lang.NullPointerException();
    }
    int mutable_bitField0_ = 0;
    com.google.protobuf.UnknownFieldSet.Builder unknownFields =
        com.google.protobuf.UnknownFieldSet.newBuilder();
    try {
      boolean done = false;
      while (!done) {
        int tag = input.readTag();
        switch (tag) {
          case 0:
            done = true;
            break;
          case 10: {
            io.spine.users.RoleId.Builder subBuilder = null;
            if (id_ != null) {
              subBuilder = id_.toBuilder();
            }
            id_ = input.readMessage(io.spine.users.RoleId.parser(), extensionRegistry);
            if (subBuilder != null) {
              subBuilder.mergeFrom(id_);
              id_ = subBuilder.buildPartial();
            }

            break;
          }
          case 18: {
            java.lang.String s = input.readStringRequireUtf8();

            displayName_ = s;
            break;
          }
          case 26: {
            io.spine.users.OrganizationOrUnit.Builder subBuilder = null;
            if (orgEntity_ != null) {
              subBuilder = orgEntity_.toBuilder();
            }
            orgEntity_ = input.readMessage(io.spine.users.OrganizationOrUnit.parser(), extensionRegistry);
            if (subBuilder != null) {
              subBuilder.mergeFrom(orgEntity_);
              orgEntity_ = subBuilder.buildPartial();
            }

            break;
          }
          default: {
            if (!parseUnknownFieldProto3(
                input, unknownFields, extensionRegistry, tag)) {
              done = true;
            }
            break;
          }
        }
      }
    } catch (com.google.protobuf.InvalidProtocolBufferException e) {
      throw e.setUnfinishedMessage(this);
    } catch (java.io.IOException e) {
      throw new com.google.protobuf.InvalidProtocolBufferException(
          e).setUnfinishedMessage(this);
    } finally {
      this.unknownFields = unknownFields.build();
      makeExtensionsImmutable();
    }
  }
  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return io.spine.users.role.RoleProto.internal_static_spine_users_role_Role_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return io.spine.users.role.RoleProto.internal_static_spine_users_role_Role_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            io.spine.users.role.Role.class, io.spine.users.role.Role.Builder.class);
  }

  public static final int ID_FIELD_NUMBER = 1;
  private io.spine.users.RoleId id_;
  /**
   * <code>.spine.users.RoleId id = 1;</code>
   */
  public boolean hasId() {
    return id_ != null;
  }
  /**
   * <code>.spine.users.RoleId id = 1;</code>
   */
  public io.spine.users.RoleId getId() {
    return id_ == null ? io.spine.users.RoleId.getDefaultInstance() : id_;
  }
  /**
   * <code>.spine.users.RoleId id = 1;</code>
   */
  public io.spine.users.RoleIdOrBuilder getIdOrBuilder() {
    return getId();
  }

  public static final int DISPLAY_NAME_FIELD_NUMBER = 2;
  private volatile java.lang.Object displayName_;
  /**
   * <pre>
   * A name of the role to be displayed on UI.
   * </pre>
   *
   * <code>string display_name = 2 [(.required) = true];</code>
   */
  public java.lang.String getDisplayName() {
    java.lang.Object ref = displayName_;
    if (ref instanceof java.lang.String) {
      return (java.lang.String) ref;
    } else {
      com.google.protobuf.ByteString bs = 
          (com.google.protobuf.ByteString) ref;
      java.lang.String s = bs.toStringUtf8();
      displayName_ = s;
      return s;
    }
  }
  /**
   * <pre>
   * A name of the role to be displayed on UI.
   * </pre>
   *
   * <code>string display_name = 2 [(.required) = true];</code>
   */
  public com.google.protobuf.ByteString
      getDisplayNameBytes() {
    java.lang.Object ref = displayName_;
    if (ref instanceof java.lang.String) {
      com.google.protobuf.ByteString b = 
          com.google.protobuf.ByteString.copyFromUtf8(
              (java.lang.String) ref);
      displayName_ = b;
      return b;
    } else {
      return (com.google.protobuf.ByteString) ref;
    }
  }

  public static final int ORG_ENTITY_FIELD_NUMBER = 3;
  private io.spine.users.OrganizationOrUnit orgEntity_;
  /**
   * <pre>
   * An organization or organizational unit the role belongs to.
   * </pre>
   *
   * <code>.spine.users.OrganizationOrUnit org_entity = 3;</code>
   */
  public boolean hasOrgEntity() {
    return orgEntity_ != null;
  }
  /**
   * <pre>
   * An organization or organizational unit the role belongs to.
   * </pre>
   *
   * <code>.spine.users.OrganizationOrUnit org_entity = 3;</code>
   */
  public io.spine.users.OrganizationOrUnit getOrgEntity() {
    return orgEntity_ == null ? io.spine.users.OrganizationOrUnit.getDefaultInstance() : orgEntity_;
  }
  /**
   * <pre>
   * An organization or organizational unit the role belongs to.
   * </pre>
   *
   * <code>.spine.users.OrganizationOrUnit org_entity = 3;</code>
   */
  public io.spine.users.OrganizationOrUnitOrBuilder getOrgEntityOrBuilder() {
    return getOrgEntity();
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (id_ != null) {
      output.writeMessage(1, getId());
    }
    if (!getDisplayNameBytes().isEmpty()) {
      com.google.protobuf.GeneratedMessageV3.writeString(output, 2, displayName_);
    }
    if (orgEntity_ != null) {
      output.writeMessage(3, getOrgEntity());
    }
    unknownFields.writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (id_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getId());
    }
    if (!getDisplayNameBytes().isEmpty()) {
      size += com.google.protobuf.GeneratedMessageV3.computeStringSize(2, displayName_);
    }
    if (orgEntity_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(3, getOrgEntity());
    }
    size += unknownFields.getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof io.spine.users.role.Role)) {
      return super.equals(obj);
    }
    io.spine.users.role.Role other = (io.spine.users.role.Role) obj;

    boolean result = true;
    result = result && (hasId() == other.hasId());
    if (hasId()) {
      result = result && getId()
          .equals(other.getId());
    }
    result = result && getDisplayName()
        .equals(other.getDisplayName());
    result = result && (hasOrgEntity() == other.hasOrgEntity());
    if (hasOrgEntity()) {
      result = result && getOrgEntity()
          .equals(other.getOrgEntity());
    }
    result = result && unknownFields.equals(other.unknownFields);
    return result;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasId()) {
      hash = (37 * hash) + ID_FIELD_NUMBER;
      hash = (53 * hash) + getId().hashCode();
    }
    hash = (37 * hash) + DISPLAY_NAME_FIELD_NUMBER;
    hash = (53 * hash) + getDisplayName().hashCode();
    if (hasOrgEntity()) {
      hash = (37 * hash) + ORG_ENTITY_FIELD_NUMBER;
      hash = (53 * hash) + getOrgEntity().hashCode();
    }
    hash = (29 * hash) + unknownFields.hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static io.spine.users.role.Role parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static io.spine.users.role.Role parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static io.spine.users.role.Role parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static io.spine.users.role.Role parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static io.spine.users.role.Role parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static io.spine.users.role.Role parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static io.spine.users.role.Role parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static io.spine.users.role.Role parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static io.spine.users.role.Role parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static io.spine.users.role.Role parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static io.spine.users.role.Role parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static io.spine.users.role.Role parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(io.spine.users.role.Role prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * A role that can be assigned to `Users` and `Groups`, to perform access control.
   * Roles are assigned to `Users` and `Group` directly and explicitly (please see `AssignRoleToUser`,
   * `AssignRoleToUser` commands). A `Role` exists in the scope of an organization or an orgunit,
   * therefore it can be assigned only to those `Users` and `Groups` that are in the same organization
   * and/or orgunit (or their child orgunits).
   * ## Access Control
   * The roles assigned to a `Group` are recursively propagated to all members of the group.
   * This propagation is implicit and is not reflected in aggregate states.
   * Therefore, when carrying out role-based access control, consider that a `User` or a `Group`
   * has not only the roles listed in the aggregate state but effectively all the roles derived from
   * parent groups.
   * ## Case Study
   * Here is a simple case study to facilitate understanding of the roles.
   * Consider the following organizational structure:
   * ```
   *          Chips &amp; Cookies            &lt;-- Organization
   *            /          &#92;
   *      Accounting   Cookie Factory    &lt;-- OrgUnit
   *          /   &#92;         &#92;
   *         /   John Doe  Jack Jackson  &lt;-- User
   *        /
   *  external_auditors                  &lt;-- Group
   *       |
   *   Jane Smith                        &lt;-- User
   * ```
   * Here are the statements about "Chips &amp; Cookies" that will help you gain intuition on
   * how to apply roles in your application:
   * 1. If `office-visitor` role belongs to "Chips &amp; Cookies" organization it can be assigned to any
   *    user or group depicted above.
   * 2. If `color-printer-user` role belongs to "Accounting" orgunit it can be assigned only to
   *    John Doe, Jane Smith, and `external_audior` group.
   * 3. If `bank-account-reader` role is assigned to `external_auditors` group, Jane Smith as a member
   *    of the group implicitly has this role too.
   * 4. If `3rd-floor-visitor` role is assigned to Jane Smith, she effectively has both this role
   *    and all roles from `external_auditors` group.
   * 5. Jack Jackson can't be assigned `color-printer-user` role because it belongs to another
   *    organizational unit.
   * </pre>
   *
   * Protobuf type {@code spine.users.role.Role}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:spine.users.role.Role)
      io.spine.users.role.RoleOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return io.spine.users.role.RoleProto.internal_static_spine_users_role_Role_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return io.spine.users.role.RoleProto.internal_static_spine_users_role_Role_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              io.spine.users.role.Role.class, io.spine.users.role.Role.Builder.class);
    }

    // Construct using io.spine.users.role.Role.newBuilder()
    private Builder() {
      maybeForceBuilderInitialization();
    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);
      maybeForceBuilderInitialization();
    }
    private void maybeForceBuilderInitialization() {
      if (com.google.protobuf.GeneratedMessageV3
              .alwaysUseFieldBuilders) {
      }
    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      if (idBuilder_ == null) {
        id_ = null;
      } else {
        id_ = null;
        idBuilder_ = null;
      }
      displayName_ = "";

      if (orgEntityBuilder_ == null) {
        orgEntity_ = null;
      } else {
        orgEntity_ = null;
        orgEntityBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return io.spine.users.role.RoleProto.internal_static_spine_users_role_Role_descriptor;
    }

    @java.lang.Override
    public io.spine.users.role.Role getDefaultInstanceForType() {
      return io.spine.users.role.Role.getDefaultInstance();
    }

    @java.lang.Override
    public io.spine.users.role.Role build() {
      io.spine.users.role.Role result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public io.spine.users.role.Role buildPartial() {
      io.spine.users.role.Role result = new io.spine.users.role.Role(this);
      if (idBuilder_ == null) {
        result.id_ = id_;
      } else {
        result.id_ = idBuilder_.build();
      }
      result.displayName_ = displayName_;
      if (orgEntityBuilder_ == null) {
        result.orgEntity_ = orgEntity_;
      } else {
        result.orgEntity_ = orgEntityBuilder_.build();
      }
      onBuilt();
      return result;
    }

    @java.lang.Override
    public Builder clone() {
      return (Builder) super.clone();
    }
    @java.lang.Override
    public Builder setField(
        com.google.protobuf.Descriptors.FieldDescriptor field,
        java.lang.Object value) {
      return (Builder) super.setField(field, value);
    }
    @java.lang.Override
    public Builder clearField(
        com.google.protobuf.Descriptors.FieldDescriptor field) {
      return (Builder) super.clearField(field);
    }
    @java.lang.Override
    public Builder clearOneof(
        com.google.protobuf.Descriptors.OneofDescriptor oneof) {
      return (Builder) super.clearOneof(oneof);
    }
    @java.lang.Override
    public Builder setRepeatedField(
        com.google.protobuf.Descriptors.FieldDescriptor field,
        int index, java.lang.Object value) {
      return (Builder) super.setRepeatedField(field, index, value);
    }
    @java.lang.Override
    public Builder addRepeatedField(
        com.google.protobuf.Descriptors.FieldDescriptor field,
        java.lang.Object value) {
      return (Builder) super.addRepeatedField(field, value);
    }
    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof io.spine.users.role.Role) {
        return mergeFrom((io.spine.users.role.Role)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(io.spine.users.role.Role other) {
      if (other == io.spine.users.role.Role.getDefaultInstance()) return this;
      if (other.hasId()) {
        mergeId(other.getId());
      }
      if (!other.getDisplayName().isEmpty()) {
        displayName_ = other.displayName_;
        onChanged();
      }
      if (other.hasOrgEntity()) {
        mergeOrgEntity(other.getOrgEntity());
      }
      this.mergeUnknownFields(other.unknownFields);
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      io.spine.users.role.Role parsedMessage = null;
      try {
        parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        parsedMessage = (io.spine.users.role.Role) e.getUnfinishedMessage();
        throw e.unwrapIOException();
      } finally {
        if (parsedMessage != null) {
          mergeFrom(parsedMessage);
        }
      }
      return this;
    }

    private io.spine.users.RoleId id_ = null;
    private com.google.protobuf.SingleFieldBuilderV3<
        io.spine.users.RoleId, io.spine.users.RoleId.Builder, io.spine.users.RoleIdOrBuilder> idBuilder_;
    /**
     * <code>.spine.users.RoleId id = 1;</code>
     */
    public boolean hasId() {
      return idBuilder_ != null || id_ != null;
    }
    /**
     * <code>.spine.users.RoleId id = 1;</code>
     */
    public io.spine.users.RoleId getId() {
      if (idBuilder_ == null) {
        return id_ == null ? io.spine.users.RoleId.getDefaultInstance() : id_;
      } else {
        return idBuilder_.getMessage();
      }
    }
    /**
     * <code>.spine.users.RoleId id = 1;</code>
     */
    public Builder setId(io.spine.users.RoleId value) {
      if (idBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        id_ = value;
        onChanged();
      } else {
        idBuilder_.setMessage(value);
      }

      return this;
    }
    /**
     * <code>.spine.users.RoleId id = 1;</code>
     */
    public Builder setId(
        io.spine.users.RoleId.Builder builderForValue) {
      if (idBuilder_ == null) {
        id_ = builderForValue.build();
        onChanged();
      } else {
        idBuilder_.setMessage(builderForValue.build());
      }

      return this;
    }
    /**
     * <code>.spine.users.RoleId id = 1;</code>
     */
    public Builder mergeId(io.spine.users.RoleId value) {
      if (idBuilder_ == null) {
        if (id_ != null) {
          id_ =
            io.spine.users.RoleId.newBuilder(id_).mergeFrom(value).buildPartial();
        } else {
          id_ = value;
        }
        onChanged();
      } else {
        idBuilder_.mergeFrom(value);
      }

      return this;
    }
    /**
     * <code>.spine.users.RoleId id = 1;</code>
     */
    public Builder clearId() {
      if (idBuilder_ == null) {
        id_ = null;
        onChanged();
      } else {
        id_ = null;
        idBuilder_ = null;
      }

      return this;
    }
    /**
     * <code>.spine.users.RoleId id = 1;</code>
     */
    public io.spine.users.RoleId.Builder getIdBuilder() {
      
      onChanged();
      return getIdFieldBuilder().getBuilder();
    }
    /**
     * <code>.spine.users.RoleId id = 1;</code>
     */
    public io.spine.users.RoleIdOrBuilder getIdOrBuilder() {
      if (idBuilder_ != null) {
        return idBuilder_.getMessageOrBuilder();
      } else {
        return id_ == null ?
            io.spine.users.RoleId.getDefaultInstance() : id_;
      }
    }
    /**
     * <code>.spine.users.RoleId id = 1;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        io.spine.users.RoleId, io.spine.users.RoleId.Builder, io.spine.users.RoleIdOrBuilder> 
        getIdFieldBuilder() {
      if (idBuilder_ == null) {
        idBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            io.spine.users.RoleId, io.spine.users.RoleId.Builder, io.spine.users.RoleIdOrBuilder>(
                getId(),
                getParentForChildren(),
                isClean());
        id_ = null;
      }
      return idBuilder_;
    }

    private java.lang.Object displayName_ = "";
    /**
     * <pre>
     * A name of the role to be displayed on UI.
     * </pre>
     *
     * <code>string display_name = 2 [(.required) = true];</code>
     */
    public java.lang.String getDisplayName() {
      java.lang.Object ref = displayName_;
      if (!(ref instanceof java.lang.String)) {
        com.google.protobuf.ByteString bs =
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        displayName_ = s;
        return s;
      } else {
        return (java.lang.String) ref;
      }
    }
    /**
     * <pre>
     * A name of the role to be displayed on UI.
     * </pre>
     *
     * <code>string display_name = 2 [(.required) = true];</code>
     */
    public com.google.protobuf.ByteString
        getDisplayNameBytes() {
      java.lang.Object ref = displayName_;
      if (ref instanceof String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        displayName_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }
    /**
     * <pre>
     * A name of the role to be displayed on UI.
     * </pre>
     *
     * <code>string display_name = 2 [(.required) = true];</code>
     */
    public Builder setDisplayName(
        java.lang.String value) {
      if (value == null) {
    throw new NullPointerException();
  }
  
      displayName_ = value;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * A name of the role to be displayed on UI.
     * </pre>
     *
     * <code>string display_name = 2 [(.required) = true];</code>
     */
    public Builder clearDisplayName() {
      
      displayName_ = getDefaultInstance().getDisplayName();
      onChanged();
      return this;
    }
    /**
     * <pre>
     * A name of the role to be displayed on UI.
     * </pre>
     *
     * <code>string display_name = 2 [(.required) = true];</code>
     */
    public Builder setDisplayNameBytes(
        com.google.protobuf.ByteString value) {
      if (value == null) {
    throw new NullPointerException();
  }
  checkByteStringIsUtf8(value);
      
      displayName_ = value;
      onChanged();
      return this;
    }

    private io.spine.users.OrganizationOrUnit orgEntity_ = null;
    private com.google.protobuf.SingleFieldBuilderV3<
        io.spine.users.OrganizationOrUnit, io.spine.users.OrganizationOrUnit.Builder, io.spine.users.OrganizationOrUnitOrBuilder> orgEntityBuilder_;
    /**
     * <pre>
     * An organization or organizational unit the role belongs to.
     * </pre>
     *
     * <code>.spine.users.OrganizationOrUnit org_entity = 3;</code>
     */
    public boolean hasOrgEntity() {
      return orgEntityBuilder_ != null || orgEntity_ != null;
    }
    /**
     * <pre>
     * An organization or organizational unit the role belongs to.
     * </pre>
     *
     * <code>.spine.users.OrganizationOrUnit org_entity = 3;</code>
     */
    public io.spine.users.OrganizationOrUnit getOrgEntity() {
      if (orgEntityBuilder_ == null) {
        return orgEntity_ == null ? io.spine.users.OrganizationOrUnit.getDefaultInstance() : orgEntity_;
      } else {
        return orgEntityBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * An organization or organizational unit the role belongs to.
     * </pre>
     *
     * <code>.spine.users.OrganizationOrUnit org_entity = 3;</code>
     */
    public Builder setOrgEntity(io.spine.users.OrganizationOrUnit value) {
      if (orgEntityBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        orgEntity_ = value;
        onChanged();
      } else {
        orgEntityBuilder_.setMessage(value);
      }

      return this;
    }
    /**
     * <pre>
     * An organization or organizational unit the role belongs to.
     * </pre>
     *
     * <code>.spine.users.OrganizationOrUnit org_entity = 3;</code>
     */
    public Builder setOrgEntity(
        io.spine.users.OrganizationOrUnit.Builder builderForValue) {
      if (orgEntityBuilder_ == null) {
        orgEntity_ = builderForValue.build();
        onChanged();
      } else {
        orgEntityBuilder_.setMessage(builderForValue.build());
      }

      return this;
    }
    /**
     * <pre>
     * An organization or organizational unit the role belongs to.
     * </pre>
     *
     * <code>.spine.users.OrganizationOrUnit org_entity = 3;</code>
     */
    public Builder mergeOrgEntity(io.spine.users.OrganizationOrUnit value) {
      if (orgEntityBuilder_ == null) {
        if (orgEntity_ != null) {
          orgEntity_ =
            io.spine.users.OrganizationOrUnit.newBuilder(orgEntity_).mergeFrom(value).buildPartial();
        } else {
          orgEntity_ = value;
        }
        onChanged();
      } else {
        orgEntityBuilder_.mergeFrom(value);
      }

      return this;
    }
    /**
     * <pre>
     * An organization or organizational unit the role belongs to.
     * </pre>
     *
     * <code>.spine.users.OrganizationOrUnit org_entity = 3;</code>
     */
    public Builder clearOrgEntity() {
      if (orgEntityBuilder_ == null) {
        orgEntity_ = null;
        onChanged();
      } else {
        orgEntity_ = null;
        orgEntityBuilder_ = null;
      }

      return this;
    }
    /**
     * <pre>
     * An organization or organizational unit the role belongs to.
     * </pre>
     *
     * <code>.spine.users.OrganizationOrUnit org_entity = 3;</code>
     */
    public io.spine.users.OrganizationOrUnit.Builder getOrgEntityBuilder() {
      
      onChanged();
      return getOrgEntityFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * An organization or organizational unit the role belongs to.
     * </pre>
     *
     * <code>.spine.users.OrganizationOrUnit org_entity = 3;</code>
     */
    public io.spine.users.OrganizationOrUnitOrBuilder getOrgEntityOrBuilder() {
      if (orgEntityBuilder_ != null) {
        return orgEntityBuilder_.getMessageOrBuilder();
      } else {
        return orgEntity_ == null ?
            io.spine.users.OrganizationOrUnit.getDefaultInstance() : orgEntity_;
      }
    }
    /**
     * <pre>
     * An organization or organizational unit the role belongs to.
     * </pre>
     *
     * <code>.spine.users.OrganizationOrUnit org_entity = 3;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        io.spine.users.OrganizationOrUnit, io.spine.users.OrganizationOrUnit.Builder, io.spine.users.OrganizationOrUnitOrBuilder> 
        getOrgEntityFieldBuilder() {
      if (orgEntityBuilder_ == null) {
        orgEntityBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            io.spine.users.OrganizationOrUnit, io.spine.users.OrganizationOrUnit.Builder, io.spine.users.OrganizationOrUnitOrBuilder>(
                getOrgEntity(),
                getParentForChildren(),
                isClean());
        orgEntity_ = null;
      }
      return orgEntityBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFieldsProto3(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:spine.users.role.Role)
  }

  // @@protoc_insertion_point(class_scope:spine.users.role.Role)
  private static final io.spine.users.role.Role DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new io.spine.users.role.Role();
  }

  public static io.spine.users.role.Role getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<Role>
      PARSER = new com.google.protobuf.AbstractParser<Role>() {
    @java.lang.Override
    public Role parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return new Role(input, extensionRegistry);
    }
  };

  public static com.google.protobuf.Parser<Role> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<Role> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public io.spine.users.role.Role getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

