// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: spine/users/signin/sign_in.proto

package io.spine.users.signin;

/**
 * <pre>
 * The process of a user sign-in.
 * This process manager covers a straightforward sign-in scenario:
 * 1. `SignUserIn` command initializes the sign-in process.
 * 2. If a `User` aggregate with the given ID already exists all checks pass the `SignInSuccessful`
 *    event is generated in response.
 * 3. Otherwise, the process manager creates a `User` aggregate and then attempts to `SignUserIn`
 *    again.
 * To sign a user in, the process manager ensures the following:
 * 1. a user directory is aware of the given identity;
 * 2. a user directory authorizes the user to sign-in (the opposite would be if the user account
 *    was suspended);
 * 3. the given identity is associated with the user (see `AddAuthIdentity` command).
 * If one of the checks fails, the process is completed immediately with `SignInFailed` event.
 * </pre>
 *
 * Protobuf type {@code spine.users.signin.SignIn}
 */
public  final class SignIn extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:spine.users.signin.SignIn)
    SignInOrBuilder {
private static final long serialVersionUID = 0L;
  // Use SignIn.newBuilder() to construct.
  private SignIn(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private SignIn() {
    status_ = 0;
    failureReason_ = 0;
  }

  @java.lang.Override
  public final com.google.protobuf.UnknownFieldSet
  getUnknownFields() {
    return this.unknownFields;
  }
  private SignIn(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    this();
    if (extensionRegistry == null) {
      throw new java.lang.NullPointerException();
    }
    int mutable_bitField0_ = 0;
    com.google.protobuf.UnknownFieldSet.Builder unknownFields =
        com.google.protobuf.UnknownFieldSet.newBuilder();
    try {
      boolean done = false;
      while (!done) {
        int tag = input.readTag();
        switch (tag) {
          case 0:
            done = true;
            break;
          case 10: {
            io.spine.core.UserId.Builder subBuilder = null;
            if (id_ != null) {
              subBuilder = id_.toBuilder();
            }
            id_ = input.readMessage(io.spine.core.UserId.parser(), extensionRegistry);
            if (subBuilder != null) {
              subBuilder.mergeFrom(id_);
              id_ = subBuilder.buildPartial();
            }

            break;
          }
          case 16: {
            int rawValue = input.readEnum();

            status_ = rawValue;
            break;
          }
          case 26: {
            io.spine.users.user.Identity.Builder subBuilder = null;
            if (identity_ != null) {
              subBuilder = identity_.toBuilder();
            }
            identity_ = input.readMessage(io.spine.users.user.Identity.parser(), extensionRegistry);
            if (subBuilder != null) {
              subBuilder.mergeFrom(identity_);
              identity_ = subBuilder.buildPartial();
            }

            break;
          }
          case 32: {
            int rawValue = input.readEnum();

            failureReason_ = rawValue;
            break;
          }
          default: {
            if (!parseUnknownFieldProto3(
                input, unknownFields, extensionRegistry, tag)) {
              done = true;
            }
            break;
          }
        }
      }
    } catch (com.google.protobuf.InvalidProtocolBufferException e) {
      throw e.setUnfinishedMessage(this);
    } catch (java.io.IOException e) {
      throw new com.google.protobuf.InvalidProtocolBufferException(
          e).setUnfinishedMessage(this);
    } finally {
      this.unknownFields = unknownFields.build();
      makeExtensionsImmutable();
    }
  }
  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return io.spine.users.signin.BasicSignInProto.internal_static_spine_users_signin_SignIn_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return io.spine.users.signin.BasicSignInProto.internal_static_spine_users_signin_SignIn_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            io.spine.users.signin.SignIn.class, io.spine.users.signin.SignIn.Builder.class);
  }

  /**
   * <pre>
   * A status of the sign-in process.
   * </pre>
   *
   * Protobuf enum {@code spine.users.signin.SignIn.Status}
   */
  public enum Status
      implements com.google.protobuf.ProtocolMessageEnum {
    /**
     * <code>SIS_UNKNOWN = 0;</code>
     */
    SIS_UNKNOWN(0),
    /**
     * <pre>
     * Indicates that the process manager is waiting until a `User` aggregate is created.
     * If there is no `User` aggregate for the given `core.UserId` the process manager
     * creates it in the first instance, and then attempt to sign the user in.
     * </pre>
     *
     * <code>AWAITING_USER_AGGREGATE_CREATION = 1;</code>
     */
    AWAITING_USER_AGGREGATE_CREATION(1),
    /**
     * <pre>
     * Indicates that the user was successfully signed-in.
     * </pre>
     *
     * <code>COMPLETED = 2;</code>
     */
    COMPLETED(2),
    /**
     * <pre>
     * The sign-in process failed.
     * </pre>
     *
     * <code>FAILED = 3;</code>
     */
    FAILED(3),
    UNRECOGNIZED(-1),
    ;

    /**
     * <code>SIS_UNKNOWN = 0;</code>
     */
    public static final int SIS_UNKNOWN_VALUE = 0;
    /**
     * <pre>
     * Indicates that the process manager is waiting until a `User` aggregate is created.
     * If there is no `User` aggregate for the given `core.UserId` the process manager
     * creates it in the first instance, and then attempt to sign the user in.
     * </pre>
     *
     * <code>AWAITING_USER_AGGREGATE_CREATION = 1;</code>
     */
    public static final int AWAITING_USER_AGGREGATE_CREATION_VALUE = 1;
    /**
     * <pre>
     * Indicates that the user was successfully signed-in.
     * </pre>
     *
     * <code>COMPLETED = 2;</code>
     */
    public static final int COMPLETED_VALUE = 2;
    /**
     * <pre>
     * The sign-in process failed.
     * </pre>
     *
     * <code>FAILED = 3;</code>
     */
    public static final int FAILED_VALUE = 3;


    public final int getNumber() {
      if (this == UNRECOGNIZED) {
        throw new java.lang.IllegalArgumentException(
            "Can't get the number of an unknown enum value.");
      }
      return value;
    }

    /**
     * @deprecated Use {@link #forNumber(int)} instead.
     */
    @java.lang.Deprecated
    public static Status valueOf(int value) {
      return forNumber(value);
    }

    public static Status forNumber(int value) {
      switch (value) {
        case 0: return SIS_UNKNOWN;
        case 1: return AWAITING_USER_AGGREGATE_CREATION;
        case 2: return COMPLETED;
        case 3: return FAILED;
        default: return null;
      }
    }

    public static com.google.protobuf.Internal.EnumLiteMap<Status>
        internalGetValueMap() {
      return internalValueMap;
    }
    private static final com.google.protobuf.Internal.EnumLiteMap<
        Status> internalValueMap =
          new com.google.protobuf.Internal.EnumLiteMap<Status>() {
            public Status findValueByNumber(int number) {
              return Status.forNumber(number);
            }
          };

    public final com.google.protobuf.Descriptors.EnumValueDescriptor
        getValueDescriptor() {
      return getDescriptor().getValues().get(ordinal());
    }
    public final com.google.protobuf.Descriptors.EnumDescriptor
        getDescriptorForType() {
      return getDescriptor();
    }
    public static final com.google.protobuf.Descriptors.EnumDescriptor
        getDescriptor() {
      return io.spine.users.signin.SignIn.getDescriptor().getEnumTypes().get(0);
    }

    private static final Status[] VALUES = values();

    public static Status valueOf(
        com.google.protobuf.Descriptors.EnumValueDescriptor desc) {
      if (desc.getType() != getDescriptor()) {
        throw new java.lang.IllegalArgumentException(
          "EnumValueDescriptor is not for this type.");
      }
      if (desc.getIndex() == -1) {
        return UNRECOGNIZED;
      }
      return VALUES[desc.getIndex()];
    }

    private final int value;

    private Status(int value) {
      this.value = value;
    }

    // @@protoc_insertion_point(enum_scope:spine.users.signin.SignIn.Status)
  }

  public static final int ID_FIELD_NUMBER = 1;
  private io.spine.core.UserId id_;
  /**
   * <code>.spine.core.UserId id = 1;</code>
   */
  public boolean hasId() {
    return id_ != null;
  }
  /**
   * <code>.spine.core.UserId id = 1;</code>
   */
  public io.spine.core.UserId getId() {
    return id_ == null ? io.spine.core.UserId.getDefaultInstance() : id_;
  }
  /**
   * <code>.spine.core.UserId id = 1;</code>
   */
  public io.spine.core.UserIdOrBuilder getIdOrBuilder() {
    return getId();
  }

  public static final int STATUS_FIELD_NUMBER = 2;
  private int status_;
  /**
   * <pre>
   * The current status of the process.
   * </pre>
   *
   * <code>.spine.users.signin.SignIn.Status status = 2;</code>
   */
  public int getStatusValue() {
    return status_;
  }
  /**
   * <pre>
   * The current status of the process.
   * </pre>
   *
   * <code>.spine.users.signin.SignIn.Status status = 2;</code>
   */
  public io.spine.users.signin.SignIn.Status getStatus() {
    @SuppressWarnings("deprecation")
    io.spine.users.signin.SignIn.Status result = io.spine.users.signin.SignIn.Status.valueOf(status_);
    return result == null ? io.spine.users.signin.SignIn.Status.UNRECOGNIZED : result;
  }

  public static final int IDENTITY_FIELD_NUMBER = 3;
  private io.spine.users.user.Identity identity_;
  /**
   * <pre>
   * A user identity used to sign-in.
   * </pre>
   *
   * <code>.spine.users.Identity identity = 3 [(.required) = true];</code>
   */
  public boolean hasIdentity() {
    return identity_ != null;
  }
  /**
   * <pre>
   * A user identity used to sign-in.
   * </pre>
   *
   * <code>.spine.users.Identity identity = 3 [(.required) = true];</code>
   */
  public io.spine.users.user.Identity getIdentity() {
    return identity_ == null ? io.spine.users.user.Identity.getDefaultInstance() : identity_;
  }
  /**
   * <pre>
   * A user identity used to sign-in.
   * </pre>
   *
   * <code>.spine.users.Identity identity = 3 [(.required) = true];</code>
   */
  public io.spine.users.user.IdentityOrBuilder getIdentityOrBuilder() {
    return getIdentity();
  }

  public static final int FAILURE_REASON_FIELD_NUMBER = 4;
  private int failureReason_;
  /**
   * <pre>
   * A reason why the process failed, if applicable.
   * </pre>
   *
   * <code>.spine.users.signin.SignInFailureReason failure_reason = 4;</code>
   */
  public int getFailureReasonValue() {
    return failureReason_;
  }
  /**
   * <pre>
   * A reason why the process failed, if applicable.
   * </pre>
   *
   * <code>.spine.users.signin.SignInFailureReason failure_reason = 4;</code>
   */
  public io.spine.users.signin.SignInFailureReason getFailureReason() {
    @SuppressWarnings("deprecation")
    io.spine.users.signin.SignInFailureReason result = io.spine.users.signin.SignInFailureReason.valueOf(failureReason_);
    return result == null ? io.spine.users.signin.SignInFailureReason.UNRECOGNIZED : result;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (id_ != null) {
      output.writeMessage(1, getId());
    }
    if (status_ != io.spine.users.signin.SignIn.Status.SIS_UNKNOWN.getNumber()) {
      output.writeEnum(2, status_);
    }
    if (identity_ != null) {
      output.writeMessage(3, getIdentity());
    }
    if (failureReason_ != io.spine.users.signin.SignInFailureReason.SIFR_UNDEFINED.getNumber()) {
      output.writeEnum(4, failureReason_);
    }
    unknownFields.writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (id_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getId());
    }
    if (status_ != io.spine.users.signin.SignIn.Status.SIS_UNKNOWN.getNumber()) {
      size += com.google.protobuf.CodedOutputStream
        .computeEnumSize(2, status_);
    }
    if (identity_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(3, getIdentity());
    }
    if (failureReason_ != io.spine.users.signin.SignInFailureReason.SIFR_UNDEFINED.getNumber()) {
      size += com.google.protobuf.CodedOutputStream
        .computeEnumSize(4, failureReason_);
    }
    size += unknownFields.getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof io.spine.users.signin.SignIn)) {
      return super.equals(obj);
    }
    io.spine.users.signin.SignIn other = (io.spine.users.signin.SignIn) obj;

    boolean result = true;
    result = result && (hasId() == other.hasId());
    if (hasId()) {
      result = result && getId()
          .equals(other.getId());
    }
    result = result && status_ == other.status_;
    result = result && (hasIdentity() == other.hasIdentity());
    if (hasIdentity()) {
      result = result && getIdentity()
          .equals(other.getIdentity());
    }
    result = result && failureReason_ == other.failureReason_;
    result = result && unknownFields.equals(other.unknownFields);
    return result;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasId()) {
      hash = (37 * hash) + ID_FIELD_NUMBER;
      hash = (53 * hash) + getId().hashCode();
    }
    hash = (37 * hash) + STATUS_FIELD_NUMBER;
    hash = (53 * hash) + status_;
    if (hasIdentity()) {
      hash = (37 * hash) + IDENTITY_FIELD_NUMBER;
      hash = (53 * hash) + getIdentity().hashCode();
    }
    hash = (37 * hash) + FAILURE_REASON_FIELD_NUMBER;
    hash = (53 * hash) + failureReason_;
    hash = (29 * hash) + unknownFields.hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static io.spine.users.signin.SignIn parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static io.spine.users.signin.SignIn parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static io.spine.users.signin.SignIn parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static io.spine.users.signin.SignIn parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static io.spine.users.signin.SignIn parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static io.spine.users.signin.SignIn parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static io.spine.users.signin.SignIn parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static io.spine.users.signin.SignIn parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static io.spine.users.signin.SignIn parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static io.spine.users.signin.SignIn parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static io.spine.users.signin.SignIn parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static io.spine.users.signin.SignIn parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(io.spine.users.signin.SignIn prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * The process of a user sign-in.
   * This process manager covers a straightforward sign-in scenario:
   * 1. `SignUserIn` command initializes the sign-in process.
   * 2. If a `User` aggregate with the given ID already exists all checks pass the `SignInSuccessful`
   *    event is generated in response.
   * 3. Otherwise, the process manager creates a `User` aggregate and then attempts to `SignUserIn`
   *    again.
   * To sign a user in, the process manager ensures the following:
   * 1. a user directory is aware of the given identity;
   * 2. a user directory authorizes the user to sign-in (the opposite would be if the user account
   *    was suspended);
   * 3. the given identity is associated with the user (see `AddAuthIdentity` command).
   * If one of the checks fails, the process is completed immediately with `SignInFailed` event.
   * </pre>
   *
   * Protobuf type {@code spine.users.signin.SignIn}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:spine.users.signin.SignIn)
      io.spine.users.signin.SignInOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return io.spine.users.signin.BasicSignInProto.internal_static_spine_users_signin_SignIn_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return io.spine.users.signin.BasicSignInProto.internal_static_spine_users_signin_SignIn_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              io.spine.users.signin.SignIn.class, io.spine.users.signin.SignIn.Builder.class);
    }

    // Construct using io.spine.users.signin.SignIn.newBuilder()
    private Builder() {
      maybeForceBuilderInitialization();
    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);
      maybeForceBuilderInitialization();
    }
    private void maybeForceBuilderInitialization() {
      if (com.google.protobuf.GeneratedMessageV3
              .alwaysUseFieldBuilders) {
      }
    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      if (idBuilder_ == null) {
        id_ = null;
      } else {
        id_ = null;
        idBuilder_ = null;
      }
      status_ = 0;

      if (identityBuilder_ == null) {
        identity_ = null;
      } else {
        identity_ = null;
        identityBuilder_ = null;
      }
      failureReason_ = 0;

      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return io.spine.users.signin.BasicSignInProto.internal_static_spine_users_signin_SignIn_descriptor;
    }

    @java.lang.Override
    public io.spine.users.signin.SignIn getDefaultInstanceForType() {
      return io.spine.users.signin.SignIn.getDefaultInstance();
    }

    @java.lang.Override
    public io.spine.users.signin.SignIn build() {
      io.spine.users.signin.SignIn result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public io.spine.users.signin.SignIn buildPartial() {
      io.spine.users.signin.SignIn result = new io.spine.users.signin.SignIn(this);
      if (idBuilder_ == null) {
        result.id_ = id_;
      } else {
        result.id_ = idBuilder_.build();
      }
      result.status_ = status_;
      if (identityBuilder_ == null) {
        result.identity_ = identity_;
      } else {
        result.identity_ = identityBuilder_.build();
      }
      result.failureReason_ = failureReason_;
      onBuilt();
      return result;
    }

    @java.lang.Override
    public Builder clone() {
      return (Builder) super.clone();
    }
    @java.lang.Override
    public Builder setField(
        com.google.protobuf.Descriptors.FieldDescriptor field,
        java.lang.Object value) {
      return (Builder) super.setField(field, value);
    }
    @java.lang.Override
    public Builder clearField(
        com.google.protobuf.Descriptors.FieldDescriptor field) {
      return (Builder) super.clearField(field);
    }
    @java.lang.Override
    public Builder clearOneof(
        com.google.protobuf.Descriptors.OneofDescriptor oneof) {
      return (Builder) super.clearOneof(oneof);
    }
    @java.lang.Override
    public Builder setRepeatedField(
        com.google.protobuf.Descriptors.FieldDescriptor field,
        int index, java.lang.Object value) {
      return (Builder) super.setRepeatedField(field, index, value);
    }
    @java.lang.Override
    public Builder addRepeatedField(
        com.google.protobuf.Descriptors.FieldDescriptor field,
        java.lang.Object value) {
      return (Builder) super.addRepeatedField(field, value);
    }
    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof io.spine.users.signin.SignIn) {
        return mergeFrom((io.spine.users.signin.SignIn)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(io.spine.users.signin.SignIn other) {
      if (other == io.spine.users.signin.SignIn.getDefaultInstance()) return this;
      if (other.hasId()) {
        mergeId(other.getId());
      }
      if (other.status_ != 0) {
        setStatusValue(other.getStatusValue());
      }
      if (other.hasIdentity()) {
        mergeIdentity(other.getIdentity());
      }
      if (other.failureReason_ != 0) {
        setFailureReasonValue(other.getFailureReasonValue());
      }
      this.mergeUnknownFields(other.unknownFields);
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      io.spine.users.signin.SignIn parsedMessage = null;
      try {
        parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        parsedMessage = (io.spine.users.signin.SignIn) e.getUnfinishedMessage();
        throw e.unwrapIOException();
      } finally {
        if (parsedMessage != null) {
          mergeFrom(parsedMessage);
        }
      }
      return this;
    }

    private io.spine.core.UserId id_ = null;
    private com.google.protobuf.SingleFieldBuilderV3<
        io.spine.core.UserId, io.spine.core.UserId.Builder, io.spine.core.UserIdOrBuilder> idBuilder_;
    /**
     * <code>.spine.core.UserId id = 1;</code>
     */
    public boolean hasId() {
      return idBuilder_ != null || id_ != null;
    }
    /**
     * <code>.spine.core.UserId id = 1;</code>
     */
    public io.spine.core.UserId getId() {
      if (idBuilder_ == null) {
        return id_ == null ? io.spine.core.UserId.getDefaultInstance() : id_;
      } else {
        return idBuilder_.getMessage();
      }
    }
    /**
     * <code>.spine.core.UserId id = 1;</code>
     */
    public Builder setId(io.spine.core.UserId value) {
      if (idBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        id_ = value;
        onChanged();
      } else {
        idBuilder_.setMessage(value);
      }

      return this;
    }
    /**
     * <code>.spine.core.UserId id = 1;</code>
     */
    public Builder setId(
        io.spine.core.UserId.Builder builderForValue) {
      if (idBuilder_ == null) {
        id_ = builderForValue.build();
        onChanged();
      } else {
        idBuilder_.setMessage(builderForValue.build());
      }

      return this;
    }
    /**
     * <code>.spine.core.UserId id = 1;</code>
     */
    public Builder mergeId(io.spine.core.UserId value) {
      if (idBuilder_ == null) {
        if (id_ != null) {
          id_ =
            io.spine.core.UserId.newBuilder(id_).mergeFrom(value).buildPartial();
        } else {
          id_ = value;
        }
        onChanged();
      } else {
        idBuilder_.mergeFrom(value);
      }

      return this;
    }
    /**
     * <code>.spine.core.UserId id = 1;</code>
     */
    public Builder clearId() {
      if (idBuilder_ == null) {
        id_ = null;
        onChanged();
      } else {
        id_ = null;
        idBuilder_ = null;
      }

      return this;
    }
    /**
     * <code>.spine.core.UserId id = 1;</code>
     */
    public io.spine.core.UserId.Builder getIdBuilder() {
      
      onChanged();
      return getIdFieldBuilder().getBuilder();
    }
    /**
     * <code>.spine.core.UserId id = 1;</code>
     */
    public io.spine.core.UserIdOrBuilder getIdOrBuilder() {
      if (idBuilder_ != null) {
        return idBuilder_.getMessageOrBuilder();
      } else {
        return id_ == null ?
            io.spine.core.UserId.getDefaultInstance() : id_;
      }
    }
    /**
     * <code>.spine.core.UserId id = 1;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        io.spine.core.UserId, io.spine.core.UserId.Builder, io.spine.core.UserIdOrBuilder> 
        getIdFieldBuilder() {
      if (idBuilder_ == null) {
        idBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            io.spine.core.UserId, io.spine.core.UserId.Builder, io.spine.core.UserIdOrBuilder>(
                getId(),
                getParentForChildren(),
                isClean());
        id_ = null;
      }
      return idBuilder_;
    }

    private int status_ = 0;
    /**
     * <pre>
     * The current status of the process.
     * </pre>
     *
     * <code>.spine.users.signin.SignIn.Status status = 2;</code>
     */
    public int getStatusValue() {
      return status_;
    }
    /**
     * <pre>
     * The current status of the process.
     * </pre>
     *
     * <code>.spine.users.signin.SignIn.Status status = 2;</code>
     */
    public Builder setStatusValue(int value) {
      status_ = value;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * The current status of the process.
     * </pre>
     *
     * <code>.spine.users.signin.SignIn.Status status = 2;</code>
     */
    public io.spine.users.signin.SignIn.Status getStatus() {
      @SuppressWarnings("deprecation")
      io.spine.users.signin.SignIn.Status result = io.spine.users.signin.SignIn.Status.valueOf(status_);
      return result == null ? io.spine.users.signin.SignIn.Status.UNRECOGNIZED : result;
    }
    /**
     * <pre>
     * The current status of the process.
     * </pre>
     *
     * <code>.spine.users.signin.SignIn.Status status = 2;</code>
     */
    public Builder setStatus(io.spine.users.signin.SignIn.Status value) {
      if (value == null) {
        throw new NullPointerException();
      }
      
      status_ = value.getNumber();
      onChanged();
      return this;
    }
    /**
     * <pre>
     * The current status of the process.
     * </pre>
     *
     * <code>.spine.users.signin.SignIn.Status status = 2;</code>
     */
    public Builder clearStatus() {
      
      status_ = 0;
      onChanged();
      return this;
    }

    private io.spine.users.user.Identity identity_ = null;
    private com.google.protobuf.SingleFieldBuilderV3<
        io.spine.users.user.Identity, io.spine.users.user.Identity.Builder, io.spine.users.user.IdentityOrBuilder> identityBuilder_;
    /**
     * <pre>
     * A user identity used to sign-in.
     * </pre>
     *
     * <code>.spine.users.Identity identity = 3 [(.required) = true];</code>
     */
    public boolean hasIdentity() {
      return identityBuilder_ != null || identity_ != null;
    }
    /**
     * <pre>
     * A user identity used to sign-in.
     * </pre>
     *
     * <code>.spine.users.Identity identity = 3 [(.required) = true];</code>
     */
    public io.spine.users.user.Identity getIdentity() {
      if (identityBuilder_ == null) {
        return identity_ == null ? io.spine.users.user.Identity.getDefaultInstance() : identity_;
      } else {
        return identityBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * A user identity used to sign-in.
     * </pre>
     *
     * <code>.spine.users.Identity identity = 3 [(.required) = true];</code>
     */
    public Builder setIdentity(io.spine.users.user.Identity value) {
      if (identityBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        identity_ = value;
        onChanged();
      } else {
        identityBuilder_.setMessage(value);
      }

      return this;
    }
    /**
     * <pre>
     * A user identity used to sign-in.
     * </pre>
     *
     * <code>.spine.users.Identity identity = 3 [(.required) = true];</code>
     */
    public Builder setIdentity(
        io.spine.users.user.Identity.Builder builderForValue) {
      if (identityBuilder_ == null) {
        identity_ = builderForValue.build();
        onChanged();
      } else {
        identityBuilder_.setMessage(builderForValue.build());
      }

      return this;
    }
    /**
     * <pre>
     * A user identity used to sign-in.
     * </pre>
     *
     * <code>.spine.users.Identity identity = 3 [(.required) = true];</code>
     */
    public Builder mergeIdentity(io.spine.users.user.Identity value) {
      if (identityBuilder_ == null) {
        if (identity_ != null) {
          identity_ =
            io.spine.users.user.Identity.newBuilder(identity_).mergeFrom(value).buildPartial();
        } else {
          identity_ = value;
        }
        onChanged();
      } else {
        identityBuilder_.mergeFrom(value);
      }

      return this;
    }
    /**
     * <pre>
     * A user identity used to sign-in.
     * </pre>
     *
     * <code>.spine.users.Identity identity = 3 [(.required) = true];</code>
     */
    public Builder clearIdentity() {
      if (identityBuilder_ == null) {
        identity_ = null;
        onChanged();
      } else {
        identity_ = null;
        identityBuilder_ = null;
      }

      return this;
    }
    /**
     * <pre>
     * A user identity used to sign-in.
     * </pre>
     *
     * <code>.spine.users.Identity identity = 3 [(.required) = true];</code>
     */
    public io.spine.users.user.Identity.Builder getIdentityBuilder() {
      
      onChanged();
      return getIdentityFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * A user identity used to sign-in.
     * </pre>
     *
     * <code>.spine.users.Identity identity = 3 [(.required) = true];</code>
     */
    public io.spine.users.user.IdentityOrBuilder getIdentityOrBuilder() {
      if (identityBuilder_ != null) {
        return identityBuilder_.getMessageOrBuilder();
      } else {
        return identity_ == null ?
            io.spine.users.user.Identity.getDefaultInstance() : identity_;
      }
    }
    /**
     * <pre>
     * A user identity used to sign-in.
     * </pre>
     *
     * <code>.spine.users.Identity identity = 3 [(.required) = true];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        io.spine.users.user.Identity, io.spine.users.user.Identity.Builder, io.spine.users.user.IdentityOrBuilder> 
        getIdentityFieldBuilder() {
      if (identityBuilder_ == null) {
        identityBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            io.spine.users.user.Identity, io.spine.users.user.Identity.Builder, io.spine.users.user.IdentityOrBuilder>(
                getIdentity(),
                getParentForChildren(),
                isClean());
        identity_ = null;
      }
      return identityBuilder_;
    }

    private int failureReason_ = 0;
    /**
     * <pre>
     * A reason why the process failed, if applicable.
     * </pre>
     *
     * <code>.spine.users.signin.SignInFailureReason failure_reason = 4;</code>
     */
    public int getFailureReasonValue() {
      return failureReason_;
    }
    /**
     * <pre>
     * A reason why the process failed, if applicable.
     * </pre>
     *
     * <code>.spine.users.signin.SignInFailureReason failure_reason = 4;</code>
     */
    public Builder setFailureReasonValue(int value) {
      failureReason_ = value;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * A reason why the process failed, if applicable.
     * </pre>
     *
     * <code>.spine.users.signin.SignInFailureReason failure_reason = 4;</code>
     */
    public io.spine.users.signin.SignInFailureReason getFailureReason() {
      @SuppressWarnings("deprecation")
      io.spine.users.signin.SignInFailureReason result = io.spine.users.signin.SignInFailureReason.valueOf(failureReason_);
      return result == null ? io.spine.users.signin.SignInFailureReason.UNRECOGNIZED : result;
    }
    /**
     * <pre>
     * A reason why the process failed, if applicable.
     * </pre>
     *
     * <code>.spine.users.signin.SignInFailureReason failure_reason = 4;</code>
     */
    public Builder setFailureReason(io.spine.users.signin.SignInFailureReason value) {
      if (value == null) {
        throw new NullPointerException();
      }
      
      failureReason_ = value.getNumber();
      onChanged();
      return this;
    }
    /**
     * <pre>
     * A reason why the process failed, if applicable.
     * </pre>
     *
     * <code>.spine.users.signin.SignInFailureReason failure_reason = 4;</code>
     */
    public Builder clearFailureReason() {
      
      failureReason_ = 0;
      onChanged();
      return this;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFieldsProto3(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:spine.users.signin.SignIn)
  }

  // @@protoc_insertion_point(class_scope:spine.users.signin.SignIn)
  private static final io.spine.users.signin.SignIn DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new io.spine.users.signin.SignIn();
  }

  public static io.spine.users.signin.SignIn getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<SignIn>
      PARSER = new com.google.protobuf.AbstractParser<SignIn>() {
    @java.lang.Override
    public SignIn parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return new SignIn(input, extensionRegistry);
    }
  };

  public static com.google.protobuf.Parser<SignIn> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<SignIn> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public io.spine.users.signin.SignIn getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

