package io.spine.users.signin;

import com.google.errorprone.annotations.CanIgnoreReturnValue;
import com.google.protobuf.Descriptors;
import io.spine.base.ConversionException;
import io.spine.core.UserId;
import io.spine.users.user.Identity;
import io.spine.validate.AbstractValidatingBuilder;
import io.spine.validate.ValidationException;
import java.util.Map;
import javax.annotation.Generated;

@Generated("by Spine Model Compiler")
public final class SignInVBuilder extends AbstractValidatingBuilder<SignIn, SignIn.Builder> {
    private SignInVBuilder() {
    }

    public static SignInVBuilder newBuilder() {
        return new SignInVBuilder();
    }

    @CanIgnoreReturnValue
    public SignInVBuilder setId(UserId id) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.signin.SignIn.getDescriptor().getFields().get(0);
        validateSetOnce(fieldDescriptor, id);
        validate(fieldDescriptor, id, "id");
        getMessageBuilder().setId(id);
        return this;
    }

    @CanIgnoreReturnValue
    public SignInVBuilder setRawId(String id) throws ValidationException, ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.signin.SignIn.getDescriptor().getFields().get(0);
        io.spine.core.UserId convertedId = convert(id, io.spine.core.UserId.class);
        validateSetOnce(fieldDescriptor, convertedId);
        validate(fieldDescriptor, convertedId, "id");
        getMessageBuilder().setId(convertedId);
        return this;
    }

    public UserId getId() {
        return getMessageBuilder().getId();
    }

    @CanIgnoreReturnValue
    public SignInVBuilder clearId() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.signin.SignIn.getDescriptor().getFields().get(0);
        validateSetOnce(fieldDescriptor, io.spine.users.signin.SignIn.getDefaultInstance().getId());
        getMessageBuilder().clearId();
        return this;
    }

    @CanIgnoreReturnValue
    public SignInVBuilder setStatus(SignIn.Status status) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.signin.SignIn.getDescriptor().getFields().get(1);
        validateSetOnce(fieldDescriptor, status);
        validate(fieldDescriptor, status, "status");
        getMessageBuilder().setStatus(status);
        return this;
    }

    @CanIgnoreReturnValue
    public SignInVBuilder setRawStatus(String status) throws ValidationException,
            ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.signin.SignIn.getDescriptor().getFields().get(1);
        io.spine.users.signin.SignIn.Status convertedStatus = convert(status, io.spine.users.signin.SignIn.Status.class);
        validateSetOnce(fieldDescriptor, convertedStatus);
        validate(fieldDescriptor, convertedStatus, "status");
        getMessageBuilder().setStatus(convertedStatus);
        return this;
    }

    public SignIn.Status getStatus() {
        return getMessageBuilder().getStatus();
    }

    @CanIgnoreReturnValue
    public SignInVBuilder clearStatus() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.signin.SignIn.getDescriptor().getFields().get(1);
        validateSetOnce(fieldDescriptor, io.spine.users.signin.SignIn.getDefaultInstance().getStatus());
        getMessageBuilder().clearStatus();
        return this;
    }

    @CanIgnoreReturnValue
    public SignInVBuilder setIdentity(Identity identity) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.signin.SignIn.getDescriptor().getFields().get(2);
        validateSetOnce(fieldDescriptor, identity);
        validate(fieldDescriptor, identity, "identity");
        getMessageBuilder().setIdentity(identity);
        return this;
    }

    @CanIgnoreReturnValue
    public SignInVBuilder setRawIdentity(String identity) throws ValidationException,
            ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.signin.SignIn.getDescriptor().getFields().get(2);
        io.spine.users.user.Identity convertedIdentity = convert(identity, io.spine.users.user.Identity.class);
        validateSetOnce(fieldDescriptor, convertedIdentity);
        validate(fieldDescriptor, convertedIdentity, "identity");
        getMessageBuilder().setIdentity(convertedIdentity);
        return this;
    }

    public Identity getIdentity() {
        return getMessageBuilder().getIdentity();
    }

    @CanIgnoreReturnValue
    public SignInVBuilder clearIdentity() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.signin.SignIn.getDescriptor().getFields().get(2);
        validateSetOnce(fieldDescriptor, io.spine.users.signin.SignIn.getDefaultInstance().getIdentity());
        getMessageBuilder().clearIdentity();
        return this;
    }

    @CanIgnoreReturnValue
    public SignInVBuilder setFailureReason(SignInFailureReason failureReason) throws
            ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.signin.SignIn.getDescriptor().getFields().get(3);
        validateSetOnce(fieldDescriptor, failureReason);
        validate(fieldDescriptor, failureReason, "failureReason");
        getMessageBuilder().setFailureReason(failureReason);
        return this;
    }

    @CanIgnoreReturnValue
    public SignInVBuilder setRawFailureReason(String failureReason) throws ValidationException,
            ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.signin.SignIn.getDescriptor().getFields().get(3);
        io.spine.users.signin.SignInFailureReason convertedFailureReason = convert(failureReason, io.spine.users.signin.SignInFailureReason.class);
        validateSetOnce(fieldDescriptor, convertedFailureReason);
        validate(fieldDescriptor, convertedFailureReason, "failureReason");
        getMessageBuilder().setFailureReason(convertedFailureReason);
        return this;
    }

    public SignInFailureReason getFailureReason() {
        return getMessageBuilder().getFailureReason();
    }

    @CanIgnoreReturnValue
    public SignInVBuilder clearFailureReason() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.signin.SignIn.getDescriptor().getFields().get(3);
        validateSetOnce(fieldDescriptor, io.spine.users.signin.SignIn.getDefaultInstance().getFailureReason());
        getMessageBuilder().clearFailureReason();
        return this;
    }

    @Override
    @CanIgnoreReturnValue
    public SignInVBuilder mergeFrom(SignIn message) {
        Map<Descriptors.FieldDescriptor, Object> fieldsMap = message.getAllFields();
        for (Map.Entry<Descriptors.FieldDescriptor, Object> entry : fieldsMap.entrySet()) {
            validateSetOnce(entry.getKey(), entry.getValue());
        }
        super.mergeFrom(message);
        return this;
    }
}
