package io.spine.users.signin.event;

import com.google.errorprone.annotations.CanIgnoreReturnValue;
import com.google.protobuf.Descriptors;
import io.spine.base.ConversionException;
import io.spine.core.UserId;
import io.spine.users.signin.SignInFailureReason;
import io.spine.users.user.Identity;
import io.spine.validate.AbstractValidatingBuilder;
import io.spine.validate.ValidationException;
import java.util.Map;
import javax.annotation.Generated;

@Generated("by Spine Model Compiler")
public final class SignInFailedVBuilder extends AbstractValidatingBuilder<SignInFailed, SignInFailed.Builder> {
    private SignInFailedVBuilder() {
    }

    public static SignInFailedVBuilder newBuilder() {
        return new SignInFailedVBuilder();
    }

    @CanIgnoreReturnValue
    public SignInFailedVBuilder setId(UserId id) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.signin.event.SignInFailed.getDescriptor().getFields().get(0);
        validateSetOnce(fieldDescriptor, id);
        validate(fieldDescriptor, id, "id");
        getMessageBuilder().setId(id);
        return this;
    }

    @CanIgnoreReturnValue
    public SignInFailedVBuilder setRawId(String id) throws ValidationException,
            ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.signin.event.SignInFailed.getDescriptor().getFields().get(0);
        io.spine.core.UserId convertedId = convert(id, io.spine.core.UserId.class);
        validateSetOnce(fieldDescriptor, convertedId);
        validate(fieldDescriptor, convertedId, "id");
        getMessageBuilder().setId(convertedId);
        return this;
    }

    public UserId getId() {
        return getMessageBuilder().getId();
    }

    @CanIgnoreReturnValue
    public SignInFailedVBuilder clearId() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.signin.event.SignInFailed.getDescriptor().getFields().get(0);
        validateSetOnce(fieldDescriptor, io.spine.users.signin.event.SignInFailed.getDefaultInstance().getId());
        getMessageBuilder().clearId();
        return this;
    }

    @CanIgnoreReturnValue
    public SignInFailedVBuilder setIdentity(Identity identity) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.signin.event.SignInFailed.getDescriptor().getFields().get(1);
        validateSetOnce(fieldDescriptor, identity);
        validate(fieldDescriptor, identity, "identity");
        getMessageBuilder().setIdentity(identity);
        return this;
    }

    @CanIgnoreReturnValue
    public SignInFailedVBuilder setRawIdentity(String identity) throws ValidationException,
            ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.signin.event.SignInFailed.getDescriptor().getFields().get(1);
        io.spine.users.user.Identity convertedIdentity = convert(identity, io.spine.users.user.Identity.class);
        validateSetOnce(fieldDescriptor, convertedIdentity);
        validate(fieldDescriptor, convertedIdentity, "identity");
        getMessageBuilder().setIdentity(convertedIdentity);
        return this;
    }

    public Identity getIdentity() {
        return getMessageBuilder().getIdentity();
    }

    @CanIgnoreReturnValue
    public SignInFailedVBuilder clearIdentity() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.signin.event.SignInFailed.getDescriptor().getFields().get(1);
        validateSetOnce(fieldDescriptor, io.spine.users.signin.event.SignInFailed.getDefaultInstance().getIdentity());
        getMessageBuilder().clearIdentity();
        return this;
    }

    @CanIgnoreReturnValue
    public SignInFailedVBuilder setFailureReason(SignInFailureReason failureReason) throws
            ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.signin.event.SignInFailed.getDescriptor().getFields().get(2);
        validateSetOnce(fieldDescriptor, failureReason);
        validate(fieldDescriptor, failureReason, "failureReason");
        getMessageBuilder().setFailureReason(failureReason);
        return this;
    }

    @CanIgnoreReturnValue
    public SignInFailedVBuilder setRawFailureReason(String failureReason) throws
            ValidationException, ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.signin.event.SignInFailed.getDescriptor().getFields().get(2);
        io.spine.users.signin.SignInFailureReason convertedFailureReason = convert(failureReason, io.spine.users.signin.SignInFailureReason.class);
        validateSetOnce(fieldDescriptor, convertedFailureReason);
        validate(fieldDescriptor, convertedFailureReason, "failureReason");
        getMessageBuilder().setFailureReason(convertedFailureReason);
        return this;
    }

    public SignInFailureReason getFailureReason() {
        return getMessageBuilder().getFailureReason();
    }

    @CanIgnoreReturnValue
    public SignInFailedVBuilder clearFailureReason() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.signin.event.SignInFailed.getDescriptor().getFields().get(2);
        validateSetOnce(fieldDescriptor, io.spine.users.signin.event.SignInFailed.getDefaultInstance().getFailureReason());
        getMessageBuilder().clearFailureReason();
        return this;
    }

    @Override
    @CanIgnoreReturnValue
    public SignInFailedVBuilder mergeFrom(SignInFailed message) {
        Map<Descriptors.FieldDescriptor, Object> fieldsMap = message.getAllFields();
        for (Map.Entry<Descriptors.FieldDescriptor, Object> entry : fieldsMap.entrySet()) {
            validateSetOnce(entry.getKey(), entry.getValue());
        }
        super.mergeFrom(message);
        return this;
    }
}
