package io.spine.users.user;

import com.google.errorprone.annotations.CanIgnoreReturnValue;
import com.google.protobuf.Descriptors;
import com.google.protobuf.Timestamp;
import io.spine.base.ConversionException;
import io.spine.core.UserId;
import io.spine.net.EmailAddress;
import io.spine.net.InternetDomain;
import io.spine.users.OrganizationOrUnit;
import io.spine.users.PersonProfile;
import io.spine.users.RoleId;
import io.spine.validate.AbstractValidatingBuilder;
import io.spine.validate.ValidationException;
import java.util.List;
import java.util.Map;
import javax.annotation.Generated;

@Generated("by Spine Model Compiler")
public final class UserVBuilder extends AbstractValidatingBuilder<User, User.Builder> {
    private UserVBuilder() {
    }

    public static UserVBuilder newBuilder() {
        return new UserVBuilder();
    }

    @CanIgnoreReturnValue
    public UserVBuilder setId(UserId id) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.User.getDescriptor().getFields().get(0);
        validateSetOnce(fieldDescriptor, id);
        validate(fieldDescriptor, id, "id");
        getMessageBuilder().setId(id);
        return this;
    }

    @CanIgnoreReturnValue
    public UserVBuilder setRawId(String id) throws ValidationException, ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.User.getDescriptor().getFields().get(0);
        io.spine.core.UserId convertedId = convert(id, io.spine.core.UserId.class);
        validateSetOnce(fieldDescriptor, convertedId);
        validate(fieldDescriptor, convertedId, "id");
        getMessageBuilder().setId(convertedId);
        return this;
    }

    public UserId getId() {
        return getMessageBuilder().getId();
    }

    @CanIgnoreReturnValue
    public UserVBuilder clearId() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.User.getDescriptor().getFields().get(0);
        validateSetOnce(fieldDescriptor, io.spine.users.user.User.getDefaultInstance().getId());
        getMessageBuilder().clearId();
        return this;
    }

    @CanIgnoreReturnValue
    public UserVBuilder setNature(UserNature nature) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.User.getDescriptor().getFields().get(1);
        validateSetOnce(fieldDescriptor, nature);
        validate(fieldDescriptor, nature, "nature");
        getMessageBuilder().setNature(nature);
        return this;
    }

    @CanIgnoreReturnValue
    public UserVBuilder setRawNature(String nature) throws ValidationException,
            ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.User.getDescriptor().getFields().get(1);
        io.spine.users.user.UserNature convertedNature = convert(nature, io.spine.users.user.UserNature.class);
        validateSetOnce(fieldDescriptor, convertedNature);
        validate(fieldDescriptor, convertedNature, "nature");
        getMessageBuilder().setNature(convertedNature);
        return this;
    }

    public UserNature getNature() {
        return getMessageBuilder().getNature();
    }

    @CanIgnoreReturnValue
    public UserVBuilder clearNature() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.User.getDescriptor().getFields().get(1);
        validateSetOnce(fieldDescriptor, io.spine.users.user.User.getDefaultInstance().getNature());
        getMessageBuilder().clearNature();
        return this;
    }

    @CanIgnoreReturnValue
    public UserVBuilder setDisplayName(String displayName) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.User.getDescriptor().getFields().get(2);
        validateSetOnce(fieldDescriptor, displayName);
        validate(fieldDescriptor, displayName, "displayName");
        getMessageBuilder().setDisplayName(displayName);
        return this;
    }

    public String getDisplayName() {
        return getMessageBuilder().getDisplayName();
    }

    @CanIgnoreReturnValue
    public UserVBuilder clearDisplayName() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.User.getDescriptor().getFields().get(2);
        validateSetOnce(fieldDescriptor, io.spine.users.user.User.getDefaultInstance().getDisplayName());
        getMessageBuilder().clearDisplayName();
        return this;
    }

    public List<RoleId> getRole() {
        return getMessageBuilder().getRoleList();
    }

    @CanIgnoreReturnValue
    public UserVBuilder clearRole() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.User.getDescriptor().getFields().get(3);
        checkNotSetOnce(fieldDescriptor);
        getMessageBuilder().clearRole();
        return this;
    }

    @CanIgnoreReturnValue
    public UserVBuilder addRole(RoleId value) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.User.getDescriptor().getFields().get(3);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, value, "role");
        getMessageBuilder().addRole(value);
        return this;
    }

    @CanIgnoreReturnValue
    public UserVBuilder setRole(int index, RoleId value) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.User.getDescriptor().getFields().get(3);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, value, "role");
        getMessageBuilder().setRole(index, value);
        return this;
    }

    @CanIgnoreReturnValue
    public UserVBuilder addAllRole(List<RoleId> value) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.User.getDescriptor().getFields().get(3);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, value, "role");
        getMessageBuilder().addAllRole(value);
        return this;
    }

    @CanIgnoreReturnValue
    public UserVBuilder addRole(int index, RoleId value) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.User.getDescriptor().getFields().get(3);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, value, "role");
        getMessageBuilder().addRole(index, value);
        return this;
    }

    @CanIgnoreReturnValue
    public UserVBuilder removeRole(int index) {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.User.getDescriptor().getFields().get(3);
        checkNotSetOnce(fieldDescriptor);
        getMessageBuilder().removeRole(index);
        return this;
    }

    @CanIgnoreReturnValue
    public UserVBuilder addRawRole(String value) throws ValidationException, ConversionException {
        io.spine.users.RoleId convertedValue = convert(value, io.spine.users.RoleId.class);
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.User.getDescriptor().getFields().get(3);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, convertedValue, "role");
        getMessageBuilder().addRole(convertedValue);
        return this;
    }

    @CanIgnoreReturnValue
    public UserVBuilder setRawRole(int index, String value) throws ValidationException,
            ConversionException {
        io.spine.users.RoleId convertedValue = convert(value, io.spine.users.RoleId.class);
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.User.getDescriptor().getFields().get(3);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, convertedValue, "role");
        getMessageBuilder().setRole(index, convertedValue);
        return this;
    }

    @CanIgnoreReturnValue
    public UserVBuilder addAllRawRole(String value) throws ValidationException,
            ConversionException {
        final List<RoleId> convertedValue = convertToList(value, RoleId.class);
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.User.getDescriptor().getFields().get(3);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, convertedValue, "role");
        getMessageBuilder().addAllRole(convertedValue);
        return this;
    }

    @CanIgnoreReturnValue
    public UserVBuilder addRawRole(int index, String value) throws ValidationException,
            ConversionException {
        io.spine.users.RoleId convertedValue = convert(value, io.spine.users.RoleId.class);
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.User.getDescriptor().getFields().get(3);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, convertedValue, "role");
        getMessageBuilder().addRole(index, convertedValue);
        return this;
    }

    @CanIgnoreReturnValue
    public UserVBuilder setEmail(EmailAddress email) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.User.getDescriptor().getFields().get(4);
        validateSetOnce(fieldDescriptor, email);
        validate(fieldDescriptor, email, "email");
        getMessageBuilder().setEmail(email);
        return this;
    }

    @CanIgnoreReturnValue
    public UserVBuilder setRawEmail(String email) throws ValidationException, ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.User.getDescriptor().getFields().get(4);
        io.spine.net.EmailAddress convertedEmail = convert(email, io.spine.net.EmailAddress.class);
        validateSetOnce(fieldDescriptor, convertedEmail);
        validate(fieldDescriptor, convertedEmail, "email");
        getMessageBuilder().setEmail(convertedEmail);
        return this;
    }

    public EmailAddress getEmail() {
        return getMessageBuilder().getEmail();
    }

    @CanIgnoreReturnValue
    public UserVBuilder clearEmail() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.User.getDescriptor().getFields().get(4);
        validateSetOnce(fieldDescriptor, io.spine.users.user.User.getDefaultInstance().getEmail());
        getMessageBuilder().clearEmail();
        return this;
    }

    @CanIgnoreReturnValue
    public UserVBuilder setOrgEntity(OrganizationOrUnit orgEntity) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.User.getDescriptor().getFields().get(5);
        validateSetOnce(fieldDescriptor, orgEntity);
        validate(fieldDescriptor, orgEntity, "orgEntity");
        getMessageBuilder().setOrgEntity(orgEntity);
        return this;
    }

    @CanIgnoreReturnValue
    public UserVBuilder setRawOrgEntity(String orgEntity) throws ValidationException,
            ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.User.getDescriptor().getFields().get(5);
        io.spine.users.OrganizationOrUnit convertedOrgEntity = convert(orgEntity, io.spine.users.OrganizationOrUnit.class);
        validateSetOnce(fieldDescriptor, convertedOrgEntity);
        validate(fieldDescriptor, convertedOrgEntity, "orgEntity");
        getMessageBuilder().setOrgEntity(convertedOrgEntity);
        return this;
    }

    public OrganizationOrUnit getOrgEntity() {
        return getMessageBuilder().getOrgEntity();
    }

    @CanIgnoreReturnValue
    public UserVBuilder clearOrgEntity() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.User.getDescriptor().getFields().get(5);
        validateSetOnce(fieldDescriptor, io.spine.users.user.User.getDefaultInstance().getOrgEntity());
        getMessageBuilder().clearOrgEntity();
        return this;
    }

    @CanIgnoreReturnValue
    public UserVBuilder setExternalDomain(InternetDomain externalDomain) throws
            ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.User.getDescriptor().getFields().get(6);
        validateSetOnce(fieldDescriptor, externalDomain);
        validate(fieldDescriptor, externalDomain, "externalDomain");
        getMessageBuilder().setExternalDomain(externalDomain);
        return this;
    }

    @CanIgnoreReturnValue
    public UserVBuilder setRawExternalDomain(String externalDomain) throws ValidationException,
            ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.User.getDescriptor().getFields().get(6);
        io.spine.net.InternetDomain convertedExternalDomain = convert(externalDomain, io.spine.net.InternetDomain.class);
        validateSetOnce(fieldDescriptor, convertedExternalDomain);
        validate(fieldDescriptor, convertedExternalDomain, "externalDomain");
        getMessageBuilder().setExternalDomain(convertedExternalDomain);
        return this;
    }

    public InternetDomain getExternalDomain() {
        return getMessageBuilder().getExternalDomain();
    }

    @CanIgnoreReturnValue
    public UserVBuilder clearExternalDomain() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.User.getDescriptor().getFields().get(6);
        validateSetOnce(fieldDescriptor, io.spine.users.user.User.getDefaultInstance().getExternalDomain());
        getMessageBuilder().clearExternalDomain();
        return this;
    }

    @CanIgnoreReturnValue
    public UserVBuilder setProfile(PersonProfile profile) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.User.getDescriptor().getFields().get(7);
        validateSetOnce(fieldDescriptor, profile);
        validate(fieldDescriptor, profile, "profile");
        getMessageBuilder().setProfile(profile);
        return this;
    }

    @CanIgnoreReturnValue
    public UserVBuilder setRawProfile(String profile) throws ValidationException,
            ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.User.getDescriptor().getFields().get(7);
        io.spine.users.PersonProfile convertedProfile = convert(profile, io.spine.users.PersonProfile.class);
        validateSetOnce(fieldDescriptor, convertedProfile);
        validate(fieldDescriptor, convertedProfile, "profile");
        getMessageBuilder().setProfile(convertedProfile);
        return this;
    }

    public PersonProfile getProfile() {
        return getMessageBuilder().getProfile();
    }

    @CanIgnoreReturnValue
    public UserVBuilder clearProfile() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.User.getDescriptor().getFields().get(7);
        validateSetOnce(fieldDescriptor, io.spine.users.user.User.getDefaultInstance().getProfile());
        getMessageBuilder().clearProfile();
        return this;
    }

    @CanIgnoreReturnValue
    public UserVBuilder setStatus(User.Status status) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.User.getDescriptor().getFields().get(8);
        validateSetOnce(fieldDescriptor, status);
        validate(fieldDescriptor, status, "status");
        getMessageBuilder().setStatus(status);
        return this;
    }

    @CanIgnoreReturnValue
    public UserVBuilder setRawStatus(String status) throws ValidationException,
            ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.User.getDescriptor().getFields().get(8);
        io.spine.users.user.User.Status convertedStatus = convert(status, io.spine.users.user.User.Status.class);
        validateSetOnce(fieldDescriptor, convertedStatus);
        validate(fieldDescriptor, convertedStatus, "status");
        getMessageBuilder().setStatus(convertedStatus);
        return this;
    }

    public User.Status getStatus() {
        return getMessageBuilder().getStatus();
    }

    @CanIgnoreReturnValue
    public UserVBuilder clearStatus() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.User.getDescriptor().getFields().get(8);
        validateSetOnce(fieldDescriptor, io.spine.users.user.User.getDefaultInstance().getStatus());
        getMessageBuilder().clearStatus();
        return this;
    }

    @CanIgnoreReturnValue
    public UserVBuilder setPrimaryIdentity(Identity primaryIdentity) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.User.getDescriptor().getFields().get(9);
        validateSetOnce(fieldDescriptor, primaryIdentity);
        validate(fieldDescriptor, primaryIdentity, "primaryIdentity");
        getMessageBuilder().setPrimaryIdentity(primaryIdentity);
        return this;
    }

    @CanIgnoreReturnValue
    public UserVBuilder setRawPrimaryIdentity(String primaryIdentity) throws ValidationException,
            ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.User.getDescriptor().getFields().get(9);
        io.spine.users.user.Identity convertedPrimaryIdentity = convert(primaryIdentity, io.spine.users.user.Identity.class);
        validateSetOnce(fieldDescriptor, convertedPrimaryIdentity);
        validate(fieldDescriptor, convertedPrimaryIdentity, "primaryIdentity");
        getMessageBuilder().setPrimaryIdentity(convertedPrimaryIdentity);
        return this;
    }

    public Identity getPrimaryIdentity() {
        return getMessageBuilder().getPrimaryIdentity();
    }

    @CanIgnoreReturnValue
    public UserVBuilder clearPrimaryIdentity() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.User.getDescriptor().getFields().get(9);
        validateSetOnce(fieldDescriptor, io.spine.users.user.User.getDefaultInstance().getPrimaryIdentity());
        getMessageBuilder().clearPrimaryIdentity();
        return this;
    }

    public List<Identity> getSecondaryIdentity() {
        return getMessageBuilder().getSecondaryIdentityList();
    }

    @CanIgnoreReturnValue
    public UserVBuilder clearSecondaryIdentity() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.User.getDescriptor().getFields().get(10);
        checkNotSetOnce(fieldDescriptor);
        getMessageBuilder().clearSecondaryIdentity();
        return this;
    }

    @CanIgnoreReturnValue
    public UserVBuilder addSecondaryIdentity(Identity value) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.User.getDescriptor().getFields().get(10);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, value, "secondaryIdentity");
        getMessageBuilder().addSecondaryIdentity(value);
        return this;
    }

    @CanIgnoreReturnValue
    public UserVBuilder setSecondaryIdentity(int index, Identity value) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.User.getDescriptor().getFields().get(10);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, value, "secondaryIdentity");
        getMessageBuilder().setSecondaryIdentity(index, value);
        return this;
    }

    @CanIgnoreReturnValue
    public UserVBuilder addAllSecondaryIdentity(List<Identity> value) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.User.getDescriptor().getFields().get(10);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, value, "secondaryIdentity");
        getMessageBuilder().addAllSecondaryIdentity(value);
        return this;
    }

    @CanIgnoreReturnValue
    public UserVBuilder addSecondaryIdentity(int index, Identity value) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.User.getDescriptor().getFields().get(10);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, value, "secondaryIdentity");
        getMessageBuilder().addSecondaryIdentity(index, value);
        return this;
    }

    @CanIgnoreReturnValue
    public UserVBuilder removeSecondaryIdentity(int index) {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.User.getDescriptor().getFields().get(10);
        checkNotSetOnce(fieldDescriptor);
        getMessageBuilder().removeSecondaryIdentity(index);
        return this;
    }

    @CanIgnoreReturnValue
    public UserVBuilder addRawSecondaryIdentity(String value) throws ValidationException,
            ConversionException {
        io.spine.users.user.Identity convertedValue = convert(value, io.spine.users.user.Identity.class);
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.User.getDescriptor().getFields().get(10);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, convertedValue, "secondaryIdentity");
        getMessageBuilder().addSecondaryIdentity(convertedValue);
        return this;
    }

    @CanIgnoreReturnValue
    public UserVBuilder setRawSecondaryIdentity(int index, String value) throws ValidationException,
            ConversionException {
        io.spine.users.user.Identity convertedValue = convert(value, io.spine.users.user.Identity.class);
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.User.getDescriptor().getFields().get(10);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, convertedValue, "secondaryIdentity");
        getMessageBuilder().setSecondaryIdentity(index, convertedValue);
        return this;
    }

    @CanIgnoreReturnValue
    public UserVBuilder addAllRawSecondaryIdentity(String value) throws ValidationException,
            ConversionException {
        final List<Identity> convertedValue = convertToList(value, Identity.class);
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.User.getDescriptor().getFields().get(10);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, convertedValue, "secondaryIdentity");
        getMessageBuilder().addAllSecondaryIdentity(convertedValue);
        return this;
    }

    @CanIgnoreReturnValue
    public UserVBuilder addRawSecondaryIdentity(int index, String value) throws ValidationException,
            ConversionException {
        io.spine.users.user.Identity convertedValue = convert(value, io.spine.users.user.Identity.class);
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.User.getDescriptor().getFields().get(10);
        checkNotSetOnce(fieldDescriptor);
        validate(fieldDescriptor, convertedValue, "secondaryIdentity");
        getMessageBuilder().addSecondaryIdentity(index, convertedValue);
        return this;
    }

    @CanIgnoreReturnValue
    public UserVBuilder setWhenCreated(Timestamp whenCreated) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.User.getDescriptor().getFields().get(11);
        validateSetOnce(fieldDescriptor, whenCreated);
        validate(fieldDescriptor, whenCreated, "whenCreated");
        getMessageBuilder().setWhenCreated(whenCreated);
        return this;
    }

    @CanIgnoreReturnValue
    public UserVBuilder setRawWhenCreated(String whenCreated) throws ValidationException,
            ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.User.getDescriptor().getFields().get(11);
        com.google.protobuf.Timestamp convertedWhenCreated = convert(whenCreated, com.google.protobuf.Timestamp.class);
        validateSetOnce(fieldDescriptor, convertedWhenCreated);
        validate(fieldDescriptor, convertedWhenCreated, "whenCreated");
        getMessageBuilder().setWhenCreated(convertedWhenCreated);
        return this;
    }

    public Timestamp getWhenCreated() {
        return getMessageBuilder().getWhenCreated();
    }

    @CanIgnoreReturnValue
    public UserVBuilder clearWhenCreated() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.User.getDescriptor().getFields().get(11);
        validateSetOnce(fieldDescriptor, io.spine.users.user.User.getDefaultInstance().getWhenCreated());
        getMessageBuilder().clearWhenCreated();
        return this;
    }

    @Override
    @CanIgnoreReturnValue
    public UserVBuilder mergeFrom(User message) {
        Map<Descriptors.FieldDescriptor, Object> fieldsMap = message.getAllFields();
        for (Map.Entry<Descriptors.FieldDescriptor, Object> entry : fieldsMap.entrySet()) {
            validateSetOnce(entry.getKey(), entry.getValue());
        }
        super.mergeFrom(message);
        return this;
    }
}
