package io.spine.users.user.command;

import com.google.errorprone.annotations.CanIgnoreReturnValue;
import com.google.protobuf.Descriptors;
import io.spine.base.ConversionException;
import io.spine.core.UserId;
import io.spine.net.EmailAddress;
import io.spine.net.InternetDomain;
import io.spine.users.OrganizationOrUnit;
import io.spine.users.PersonProfile;
import io.spine.users.user.Identity;
import io.spine.users.user.User;
import io.spine.users.user.UserNature;
import io.spine.validate.AbstractValidatingBuilder;
import io.spine.validate.ValidationException;
import java.util.Map;
import javax.annotation.Generated;

@Generated("by Spine Model Compiler")
public final class CreateUserVBuilder extends AbstractValidatingBuilder<CreateUser, CreateUser.Builder> {
    private CreateUserVBuilder() {
    }

    public static CreateUserVBuilder newBuilder() {
        return new CreateUserVBuilder();
    }

    @CanIgnoreReturnValue
    public CreateUserVBuilder setId(UserId id) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.command.CreateUser.getDescriptor().getFields().get(0);
        validateSetOnce(fieldDescriptor, id);
        validate(fieldDescriptor, id, "id");
        getMessageBuilder().setId(id);
        return this;
    }

    @CanIgnoreReturnValue
    public CreateUserVBuilder setRawId(String id) throws ValidationException, ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.command.CreateUser.getDescriptor().getFields().get(0);
        io.spine.core.UserId convertedId = convert(id, io.spine.core.UserId.class);
        validateSetOnce(fieldDescriptor, convertedId);
        validate(fieldDescriptor, convertedId, "id");
        getMessageBuilder().setId(convertedId);
        return this;
    }

    public UserId getId() {
        return getMessageBuilder().getId();
    }

    @CanIgnoreReturnValue
    public CreateUserVBuilder clearId() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.command.CreateUser.getDescriptor().getFields().get(0);
        validateSetOnce(fieldDescriptor, io.spine.users.user.command.CreateUser.getDefaultInstance().getId());
        getMessageBuilder().clearId();
        return this;
    }

    @CanIgnoreReturnValue
    public CreateUserVBuilder setNature(UserNature nature) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.command.CreateUser.getDescriptor().getFields().get(1);
        validateSetOnce(fieldDescriptor, nature);
        validate(fieldDescriptor, nature, "nature");
        getMessageBuilder().setNature(nature);
        return this;
    }

    @CanIgnoreReturnValue
    public CreateUserVBuilder setRawNature(String nature) throws ValidationException,
            ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.command.CreateUser.getDescriptor().getFields().get(1);
        io.spine.users.user.UserNature convertedNature = convert(nature, io.spine.users.user.UserNature.class);
        validateSetOnce(fieldDescriptor, convertedNature);
        validate(fieldDescriptor, convertedNature, "nature");
        getMessageBuilder().setNature(convertedNature);
        return this;
    }

    public UserNature getNature() {
        return getMessageBuilder().getNature();
    }

    @CanIgnoreReturnValue
    public CreateUserVBuilder clearNature() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.command.CreateUser.getDescriptor().getFields().get(1);
        validateSetOnce(fieldDescriptor, io.spine.users.user.command.CreateUser.getDefaultInstance().getNature());
        getMessageBuilder().clearNature();
        return this;
    }

    @CanIgnoreReturnValue
    public CreateUserVBuilder setDisplayName(String displayName) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.command.CreateUser.getDescriptor().getFields().get(2);
        validateSetOnce(fieldDescriptor, displayName);
        validate(fieldDescriptor, displayName, "displayName");
        getMessageBuilder().setDisplayName(displayName);
        return this;
    }

    public String getDisplayName() {
        return getMessageBuilder().getDisplayName();
    }

    @CanIgnoreReturnValue
    public CreateUserVBuilder clearDisplayName() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.command.CreateUser.getDescriptor().getFields().get(2);
        validateSetOnce(fieldDescriptor, io.spine.users.user.command.CreateUser.getDefaultInstance().getDisplayName());
        getMessageBuilder().clearDisplayName();
        return this;
    }

    @CanIgnoreReturnValue
    public CreateUserVBuilder setEmail(EmailAddress email) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.command.CreateUser.getDescriptor().getFields().get(3);
        validateSetOnce(fieldDescriptor, email);
        validate(fieldDescriptor, email, "email");
        getMessageBuilder().setEmail(email);
        return this;
    }

    @CanIgnoreReturnValue
    public CreateUserVBuilder setRawEmail(String email) throws ValidationException,
            ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.command.CreateUser.getDescriptor().getFields().get(3);
        io.spine.net.EmailAddress convertedEmail = convert(email, io.spine.net.EmailAddress.class);
        validateSetOnce(fieldDescriptor, convertedEmail);
        validate(fieldDescriptor, convertedEmail, "email");
        getMessageBuilder().setEmail(convertedEmail);
        return this;
    }

    public EmailAddress getEmail() {
        return getMessageBuilder().getEmail();
    }

    @CanIgnoreReturnValue
    public CreateUserVBuilder clearEmail() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.command.CreateUser.getDescriptor().getFields().get(3);
        validateSetOnce(fieldDescriptor, io.spine.users.user.command.CreateUser.getDefaultInstance().getEmail());
        getMessageBuilder().clearEmail();
        return this;
    }

    @CanIgnoreReturnValue
    public CreateUserVBuilder setOrgEntity(OrganizationOrUnit orgEntity) throws
            ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.command.CreateUser.getDescriptor().getFields().get(4);
        validateSetOnce(fieldDescriptor, orgEntity);
        validate(fieldDescriptor, orgEntity, "orgEntity");
        getMessageBuilder().setOrgEntity(orgEntity);
        return this;
    }

    @CanIgnoreReturnValue
    public CreateUserVBuilder setRawOrgEntity(String orgEntity) throws ValidationException,
            ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.command.CreateUser.getDescriptor().getFields().get(4);
        io.spine.users.OrganizationOrUnit convertedOrgEntity = convert(orgEntity, io.spine.users.OrganizationOrUnit.class);
        validateSetOnce(fieldDescriptor, convertedOrgEntity);
        validate(fieldDescriptor, convertedOrgEntity, "orgEntity");
        getMessageBuilder().setOrgEntity(convertedOrgEntity);
        return this;
    }

    public OrganizationOrUnit getOrgEntity() {
        return getMessageBuilder().getOrgEntity();
    }

    @CanIgnoreReturnValue
    public CreateUserVBuilder clearOrgEntity() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.command.CreateUser.getDescriptor().getFields().get(4);
        validateSetOnce(fieldDescriptor, io.spine.users.user.command.CreateUser.getDefaultInstance().getOrgEntity());
        getMessageBuilder().clearOrgEntity();
        return this;
    }

    @CanIgnoreReturnValue
    public CreateUserVBuilder setExternalDomain(InternetDomain externalDomain) throws
            ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.command.CreateUser.getDescriptor().getFields().get(5);
        validateSetOnce(fieldDescriptor, externalDomain);
        validate(fieldDescriptor, externalDomain, "externalDomain");
        getMessageBuilder().setExternalDomain(externalDomain);
        return this;
    }

    @CanIgnoreReturnValue
    public CreateUserVBuilder setRawExternalDomain(String externalDomain) throws
            ValidationException, ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.command.CreateUser.getDescriptor().getFields().get(5);
        io.spine.net.InternetDomain convertedExternalDomain = convert(externalDomain, io.spine.net.InternetDomain.class);
        validateSetOnce(fieldDescriptor, convertedExternalDomain);
        validate(fieldDescriptor, convertedExternalDomain, "externalDomain");
        getMessageBuilder().setExternalDomain(convertedExternalDomain);
        return this;
    }

    public InternetDomain getExternalDomain() {
        return getMessageBuilder().getExternalDomain();
    }

    @CanIgnoreReturnValue
    public CreateUserVBuilder clearExternalDomain() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.command.CreateUser.getDescriptor().getFields().get(5);
        validateSetOnce(fieldDescriptor, io.spine.users.user.command.CreateUser.getDefaultInstance().getExternalDomain());
        getMessageBuilder().clearExternalDomain();
        return this;
    }

    @CanIgnoreReturnValue
    public CreateUserVBuilder setPrimaryIdentity(Identity primaryIdentity) throws
            ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.command.CreateUser.getDescriptor().getFields().get(6);
        validateSetOnce(fieldDescriptor, primaryIdentity);
        validate(fieldDescriptor, primaryIdentity, "primaryIdentity");
        getMessageBuilder().setPrimaryIdentity(primaryIdentity);
        return this;
    }

    @CanIgnoreReturnValue
    public CreateUserVBuilder setRawPrimaryIdentity(String primaryIdentity) throws
            ValidationException, ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.command.CreateUser.getDescriptor().getFields().get(6);
        io.spine.users.user.Identity convertedPrimaryIdentity = convert(primaryIdentity, io.spine.users.user.Identity.class);
        validateSetOnce(fieldDescriptor, convertedPrimaryIdentity);
        validate(fieldDescriptor, convertedPrimaryIdentity, "primaryIdentity");
        getMessageBuilder().setPrimaryIdentity(convertedPrimaryIdentity);
        return this;
    }

    public Identity getPrimaryIdentity() {
        return getMessageBuilder().getPrimaryIdentity();
    }

    @CanIgnoreReturnValue
    public CreateUserVBuilder clearPrimaryIdentity() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.command.CreateUser.getDescriptor().getFields().get(6);
        validateSetOnce(fieldDescriptor, io.spine.users.user.command.CreateUser.getDefaultInstance().getPrimaryIdentity());
        getMessageBuilder().clearPrimaryIdentity();
        return this;
    }

    @CanIgnoreReturnValue
    public CreateUserVBuilder setProfile(PersonProfile profile) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.command.CreateUser.getDescriptor().getFields().get(7);
        validateSetOnce(fieldDescriptor, profile);
        validate(fieldDescriptor, profile, "profile");
        getMessageBuilder().setProfile(profile);
        return this;
    }

    @CanIgnoreReturnValue
    public CreateUserVBuilder setRawProfile(String profile) throws ValidationException,
            ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.command.CreateUser.getDescriptor().getFields().get(7);
        io.spine.users.PersonProfile convertedProfile = convert(profile, io.spine.users.PersonProfile.class);
        validateSetOnce(fieldDescriptor, convertedProfile);
        validate(fieldDescriptor, convertedProfile, "profile");
        getMessageBuilder().setProfile(convertedProfile);
        return this;
    }

    public PersonProfile getProfile() {
        return getMessageBuilder().getProfile();
    }

    @CanIgnoreReturnValue
    public CreateUserVBuilder clearProfile() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.command.CreateUser.getDescriptor().getFields().get(7);
        validateSetOnce(fieldDescriptor, io.spine.users.user.command.CreateUser.getDefaultInstance().getProfile());
        getMessageBuilder().clearProfile();
        return this;
    }

    @CanIgnoreReturnValue
    public CreateUserVBuilder setStatus(User.Status status) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.command.CreateUser.getDescriptor().getFields().get(8);
        validateSetOnce(fieldDescriptor, status);
        validate(fieldDescriptor, status, "status");
        getMessageBuilder().setStatus(status);
        return this;
    }

    @CanIgnoreReturnValue
    public CreateUserVBuilder setRawStatus(String status) throws ValidationException,
            ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.command.CreateUser.getDescriptor().getFields().get(8);
        io.spine.users.user.User.Status convertedStatus = convert(status, io.spine.users.user.User.Status.class);
        validateSetOnce(fieldDescriptor, convertedStatus);
        validate(fieldDescriptor, convertedStatus, "status");
        getMessageBuilder().setStatus(convertedStatus);
        return this;
    }

    public User.Status getStatus() {
        return getMessageBuilder().getStatus();
    }

    @CanIgnoreReturnValue
    public CreateUserVBuilder clearStatus() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.command.CreateUser.getDescriptor().getFields().get(8);
        validateSetOnce(fieldDescriptor, io.spine.users.user.command.CreateUser.getDefaultInstance().getStatus());
        getMessageBuilder().clearStatus();
        return this;
    }

    @Override
    @CanIgnoreReturnValue
    public CreateUserVBuilder mergeFrom(CreateUser message) {
        Map<Descriptors.FieldDescriptor, Object> fieldsMap = message.getAllFields();
        for (Map.Entry<Descriptors.FieldDescriptor, Object> entry : fieldsMap.entrySet()) {
            validateSetOnce(entry.getKey(), entry.getValue());
        }
        super.mergeFrom(message);
        return this;
    }
}
