package io.spine.users.user.event;

import com.google.errorprone.annotations.CanIgnoreReturnValue;
import com.google.protobuf.Descriptors;
import io.spine.base.ConversionException;
import io.spine.core.UserId;
import io.spine.net.EmailAddress;
import io.spine.net.InternetDomain;
import io.spine.users.OrganizationOrUnit;
import io.spine.users.PersonProfile;
import io.spine.users.user.Identity;
import io.spine.users.user.User;
import io.spine.users.user.UserNature;
import io.spine.validate.AbstractValidatingBuilder;
import io.spine.validate.ValidationException;
import java.util.Map;
import javax.annotation.Generated;

@Generated("by Spine Model Compiler")
public final class UserCreatedVBuilder extends AbstractValidatingBuilder<UserCreated, UserCreated.Builder> {
    private UserCreatedVBuilder() {
    }

    public static UserCreatedVBuilder newBuilder() {
        return new UserCreatedVBuilder();
    }

    @CanIgnoreReturnValue
    public UserCreatedVBuilder setId(UserId id) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.event.UserCreated.getDescriptor().getFields().get(0);
        validateSetOnce(fieldDescriptor, id);
        validate(fieldDescriptor, id, "id");
        getMessageBuilder().setId(id);
        return this;
    }

    @CanIgnoreReturnValue
    public UserCreatedVBuilder setRawId(String id) throws ValidationException, ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.event.UserCreated.getDescriptor().getFields().get(0);
        io.spine.core.UserId convertedId = convert(id, io.spine.core.UserId.class);
        validateSetOnce(fieldDescriptor, convertedId);
        validate(fieldDescriptor, convertedId, "id");
        getMessageBuilder().setId(convertedId);
        return this;
    }

    public UserId getId() {
        return getMessageBuilder().getId();
    }

    @CanIgnoreReturnValue
    public UserCreatedVBuilder clearId() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.event.UserCreated.getDescriptor().getFields().get(0);
        validateSetOnce(fieldDescriptor, io.spine.users.user.event.UserCreated.getDefaultInstance().getId());
        getMessageBuilder().clearId();
        return this;
    }

    @CanIgnoreReturnValue
    public UserCreatedVBuilder setNature(UserNature nature) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.event.UserCreated.getDescriptor().getFields().get(1);
        validateSetOnce(fieldDescriptor, nature);
        validate(fieldDescriptor, nature, "nature");
        getMessageBuilder().setNature(nature);
        return this;
    }

    @CanIgnoreReturnValue
    public UserCreatedVBuilder setRawNature(String nature) throws ValidationException,
            ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.event.UserCreated.getDescriptor().getFields().get(1);
        io.spine.users.user.UserNature convertedNature = convert(nature, io.spine.users.user.UserNature.class);
        validateSetOnce(fieldDescriptor, convertedNature);
        validate(fieldDescriptor, convertedNature, "nature");
        getMessageBuilder().setNature(convertedNature);
        return this;
    }

    public UserNature getNature() {
        return getMessageBuilder().getNature();
    }

    @CanIgnoreReturnValue
    public UserCreatedVBuilder clearNature() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.event.UserCreated.getDescriptor().getFields().get(1);
        validateSetOnce(fieldDescriptor, io.spine.users.user.event.UserCreated.getDefaultInstance().getNature());
        getMessageBuilder().clearNature();
        return this;
    }

    @CanIgnoreReturnValue
    public UserCreatedVBuilder setDisplayName(String displayName) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.event.UserCreated.getDescriptor().getFields().get(2);
        validateSetOnce(fieldDescriptor, displayName);
        validate(fieldDescriptor, displayName, "displayName");
        getMessageBuilder().setDisplayName(displayName);
        return this;
    }

    public String getDisplayName() {
        return getMessageBuilder().getDisplayName();
    }

    @CanIgnoreReturnValue
    public UserCreatedVBuilder clearDisplayName() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.event.UserCreated.getDescriptor().getFields().get(2);
        validateSetOnce(fieldDescriptor, io.spine.users.user.event.UserCreated.getDefaultInstance().getDisplayName());
        getMessageBuilder().clearDisplayName();
        return this;
    }

    @CanIgnoreReturnValue
    public UserCreatedVBuilder setEmail(EmailAddress email) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.event.UserCreated.getDescriptor().getFields().get(3);
        validateSetOnce(fieldDescriptor, email);
        validate(fieldDescriptor, email, "email");
        getMessageBuilder().setEmail(email);
        return this;
    }

    @CanIgnoreReturnValue
    public UserCreatedVBuilder setRawEmail(String email) throws ValidationException,
            ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.event.UserCreated.getDescriptor().getFields().get(3);
        io.spine.net.EmailAddress convertedEmail = convert(email, io.spine.net.EmailAddress.class);
        validateSetOnce(fieldDescriptor, convertedEmail);
        validate(fieldDescriptor, convertedEmail, "email");
        getMessageBuilder().setEmail(convertedEmail);
        return this;
    }

    public EmailAddress getEmail() {
        return getMessageBuilder().getEmail();
    }

    @CanIgnoreReturnValue
    public UserCreatedVBuilder clearEmail() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.event.UserCreated.getDescriptor().getFields().get(3);
        validateSetOnce(fieldDescriptor, io.spine.users.user.event.UserCreated.getDefaultInstance().getEmail());
        getMessageBuilder().clearEmail();
        return this;
    }

    @CanIgnoreReturnValue
    public UserCreatedVBuilder setOrgEntity(OrganizationOrUnit orgEntity) throws
            ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.event.UserCreated.getDescriptor().getFields().get(4);
        validateSetOnce(fieldDescriptor, orgEntity);
        validate(fieldDescriptor, orgEntity, "orgEntity");
        getMessageBuilder().setOrgEntity(orgEntity);
        return this;
    }

    @CanIgnoreReturnValue
    public UserCreatedVBuilder setRawOrgEntity(String orgEntity) throws ValidationException,
            ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.event.UserCreated.getDescriptor().getFields().get(4);
        io.spine.users.OrganizationOrUnit convertedOrgEntity = convert(orgEntity, io.spine.users.OrganizationOrUnit.class);
        validateSetOnce(fieldDescriptor, convertedOrgEntity);
        validate(fieldDescriptor, convertedOrgEntity, "orgEntity");
        getMessageBuilder().setOrgEntity(convertedOrgEntity);
        return this;
    }

    public OrganizationOrUnit getOrgEntity() {
        return getMessageBuilder().getOrgEntity();
    }

    @CanIgnoreReturnValue
    public UserCreatedVBuilder clearOrgEntity() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.event.UserCreated.getDescriptor().getFields().get(4);
        validateSetOnce(fieldDescriptor, io.spine.users.user.event.UserCreated.getDefaultInstance().getOrgEntity());
        getMessageBuilder().clearOrgEntity();
        return this;
    }

    @CanIgnoreReturnValue
    public UserCreatedVBuilder setExternalDomain(InternetDomain externalDomain) throws
            ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.event.UserCreated.getDescriptor().getFields().get(5);
        validateSetOnce(fieldDescriptor, externalDomain);
        validate(fieldDescriptor, externalDomain, "externalDomain");
        getMessageBuilder().setExternalDomain(externalDomain);
        return this;
    }

    @CanIgnoreReturnValue
    public UserCreatedVBuilder setRawExternalDomain(String externalDomain) throws
            ValidationException, ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.event.UserCreated.getDescriptor().getFields().get(5);
        io.spine.net.InternetDomain convertedExternalDomain = convert(externalDomain, io.spine.net.InternetDomain.class);
        validateSetOnce(fieldDescriptor, convertedExternalDomain);
        validate(fieldDescriptor, convertedExternalDomain, "externalDomain");
        getMessageBuilder().setExternalDomain(convertedExternalDomain);
        return this;
    }

    public InternetDomain getExternalDomain() {
        return getMessageBuilder().getExternalDomain();
    }

    @CanIgnoreReturnValue
    public UserCreatedVBuilder clearExternalDomain() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.event.UserCreated.getDescriptor().getFields().get(5);
        validateSetOnce(fieldDescriptor, io.spine.users.user.event.UserCreated.getDefaultInstance().getExternalDomain());
        getMessageBuilder().clearExternalDomain();
        return this;
    }

    @CanIgnoreReturnValue
    public UserCreatedVBuilder setPrimaryIdentity(Identity primaryIdentity) throws
            ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.event.UserCreated.getDescriptor().getFields().get(6);
        validateSetOnce(fieldDescriptor, primaryIdentity);
        validate(fieldDescriptor, primaryIdentity, "primaryIdentity");
        getMessageBuilder().setPrimaryIdentity(primaryIdentity);
        return this;
    }

    @CanIgnoreReturnValue
    public UserCreatedVBuilder setRawPrimaryIdentity(String primaryIdentity) throws
            ValidationException, ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.event.UserCreated.getDescriptor().getFields().get(6);
        io.spine.users.user.Identity convertedPrimaryIdentity = convert(primaryIdentity, io.spine.users.user.Identity.class);
        validateSetOnce(fieldDescriptor, convertedPrimaryIdentity);
        validate(fieldDescriptor, convertedPrimaryIdentity, "primaryIdentity");
        getMessageBuilder().setPrimaryIdentity(convertedPrimaryIdentity);
        return this;
    }

    public Identity getPrimaryIdentity() {
        return getMessageBuilder().getPrimaryIdentity();
    }

    @CanIgnoreReturnValue
    public UserCreatedVBuilder clearPrimaryIdentity() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.event.UserCreated.getDescriptor().getFields().get(6);
        validateSetOnce(fieldDescriptor, io.spine.users.user.event.UserCreated.getDefaultInstance().getPrimaryIdentity());
        getMessageBuilder().clearPrimaryIdentity();
        return this;
    }

    @CanIgnoreReturnValue
    public UserCreatedVBuilder setProfile(PersonProfile profile) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.event.UserCreated.getDescriptor().getFields().get(7);
        validateSetOnce(fieldDescriptor, profile);
        validate(fieldDescriptor, profile, "profile");
        getMessageBuilder().setProfile(profile);
        return this;
    }

    @CanIgnoreReturnValue
    public UserCreatedVBuilder setRawProfile(String profile) throws ValidationException,
            ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.event.UserCreated.getDescriptor().getFields().get(7);
        io.spine.users.PersonProfile convertedProfile = convert(profile, io.spine.users.PersonProfile.class);
        validateSetOnce(fieldDescriptor, convertedProfile);
        validate(fieldDescriptor, convertedProfile, "profile");
        getMessageBuilder().setProfile(convertedProfile);
        return this;
    }

    public PersonProfile getProfile() {
        return getMessageBuilder().getProfile();
    }

    @CanIgnoreReturnValue
    public UserCreatedVBuilder clearProfile() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.event.UserCreated.getDescriptor().getFields().get(7);
        validateSetOnce(fieldDescriptor, io.spine.users.user.event.UserCreated.getDefaultInstance().getProfile());
        getMessageBuilder().clearProfile();
        return this;
    }

    @CanIgnoreReturnValue
    public UserCreatedVBuilder setStatus(User.Status status) throws ValidationException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.event.UserCreated.getDescriptor().getFields().get(8);
        validateSetOnce(fieldDescriptor, status);
        validate(fieldDescriptor, status, "status");
        getMessageBuilder().setStatus(status);
        return this;
    }

    @CanIgnoreReturnValue
    public UserCreatedVBuilder setRawStatus(String status) throws ValidationException,
            ConversionException {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.event.UserCreated.getDescriptor().getFields().get(8);
        io.spine.users.user.User.Status convertedStatus = convert(status, io.spine.users.user.User.Status.class);
        validateSetOnce(fieldDescriptor, convertedStatus);
        validate(fieldDescriptor, convertedStatus, "status");
        getMessageBuilder().setStatus(convertedStatus);
        return this;
    }

    public User.Status getStatus() {
        return getMessageBuilder().getStatus();
    }

    @CanIgnoreReturnValue
    public UserCreatedVBuilder clearStatus() {
        com.google.protobuf.Descriptors.FieldDescriptor fieldDescriptor = io.spine.users.user.event.UserCreated.getDescriptor().getFields().get(8);
        validateSetOnce(fieldDescriptor, io.spine.users.user.event.UserCreated.getDefaultInstance().getStatus());
        getMessageBuilder().clearStatus();
        return this;
    }

    @Override
    @CanIgnoreReturnValue
    public UserCreatedVBuilder mergeFrom(UserCreated message) {
        Map<Descriptors.FieldDescriptor, Object> fieldsMap = message.getAllFields();
        for (Map.Entry<Descriptors.FieldDescriptor, Object> entry : fieldsMap.entrySet()) {
            validateSetOnce(entry.getKey(), entry.getValue());
        }
        super.mergeFrom(message);
        return this;
    }
}
