package io.spine.users.user.rejection;

import io.spine.base.ThrowableMessage;
import io.spine.core.UserId;
import io.spine.net.InternetDomain;
import io.spine.validate.Validate;
import javax.annotation.Generated;

/**
 * <pre>
 *  The rejection to moving an external user.
 *
 * </pre>
 *
 * Rejection based on proto type {@code io.spine.users.user.rejection.CannotMoveExternalUser}
 */
@Generated("by Spine Model Compiler")
public class CannotMoveExternalUser extends ThrowableMessage {
    private static final long serialVersionUID = 0L;

    /**
     * Creates a new instance.
     *
     * @param builder the builder for the rejection
     */
    private CannotMoveExternalUser(Builder builder) {
        super(builder.rejectionMessage());
    }

    @Override
    public Rejections.CannotMoveExternalUser messageThrown() {
        return (Rejections.CannotMoveExternalUser) super.messageThrown();
    }

    /**
     * @return a new builder for the rejection
     */
    public static Builder newBuilder() {
        return new Builder();
    }

    /**
     * The builder for the {@code CannotMoveExternalUser} rejection.
     */
    public static class Builder {
        private final Rejections.CannotMoveExternalUser.Builder builder = Rejections.CannotMoveExternalUser.newBuilder();

        /**
         * Prevent direct instantiation of the builder.
         */
        private Builder() {
        }

        public Builder setId(UserId id) {
            builder.setId(id);
            return this;
        }

        /**
         * <pre>
         *  An external domain the user belongs to.
         * </pre>
         */
        public Builder setExternalDomain(InternetDomain externalDomain) {
            builder.setExternalDomain(externalDomain);
            return this;
        }

        /**
         * Obtains the rejection and validates it.
         */
        private Rejections.CannotMoveExternalUser rejectionMessage() {
            Rejections.CannotMoveExternalUser message = builder.build();
            Validate.checkValid(message);
            return message;
        }

        /**
         * Creates the rejection from the builder and validates it.
         */
        public CannotMoveExternalUser build() {
            return new CannotMoveExternalUser(this);
        }
    }
}
