package io.spine.users.user.rejection;

import io.spine.base.ThrowableMessage;
import io.spine.core.UserId;
import io.spine.users.DirectoryId;
import io.spine.validate.Validate;
import javax.annotation.Generated;

/**
 * <pre>
 *  The rejection to accessing an identity that doesn't exist.
 *
 * </pre>
 *
 * Rejection based on proto type {@code io.spine.users.user.rejection.IdentityDoesNotExist}
 */
@Generated("by Spine Model Compiler")
public class IdentityDoesNotExist extends ThrowableMessage {
    private static final long serialVersionUID = 0L;

    /**
     * Creates a new instance.
     *
     * @param builder the builder for the rejection
     */
    private IdentityDoesNotExist(Builder builder) {
        super(builder.rejectionMessage());
    }

    @Override
    public Rejections.IdentityDoesNotExist messageThrown() {
        return (Rejections.IdentityDoesNotExist) super.messageThrown();
    }

    /**
     * @return a new builder for the rejection
     */
    public static Builder newBuilder() {
        return new Builder();
    }

    /**
     * The builder for the {@code IdentityDoesNotExist} rejection.
     */
    public static class Builder {
        private final Rejections.IdentityDoesNotExist.Builder builder = Rejections.IdentityDoesNotExist.newBuilder();

        /**
         * Prevent direct instantiation of the builder.
         */
        private Builder() {
        }

        public Builder setId(UserId id) {
            builder.setId(id);
            return this;
        }

        /**
         * <pre>
         *  A unique identifier of the user directory.
         * </pre>
         */
        public Builder setDirectoryId(DirectoryId directoryId) {
            builder.setDirectoryId(directoryId);
            return this;
        }

        /**
         * <pre>
         *  A user identity that wasn't found.
         * </pre>
         */
        public Builder setUserId(String userId) {
            builder.setUserId(userId);
            return this;
        }

        /**
         * Obtains the rejection and validates it.
         */
        private Rejections.IdentityDoesNotExist rejectionMessage() {
            Rejections.IdentityDoesNotExist message = builder.build();
            Validate.checkValid(message);
            return message;
        }

        /**
         * Creates the rejection from the builder and validates it.
         */
        public IdentityDoesNotExist build() {
            return new IdentityDoesNotExist(this);
        }
    }
}
