package io.spine.users.user.rejection;

import io.spine.base.ThrowableMessage;
import io.spine.core.UserId;
import io.spine.users.RoleId;
import io.spine.validate.Validate;
import javax.annotation.Generated;

/**
 * <pre>
 *  The rejection to removing a role that isn't assigned to a user.
 *
 * </pre>
 *
 * Rejection based on proto type {@code io.spine.users.user.rejection.RoleIsNotAssignedToUser}
 */
@Generated("by Spine Model Compiler")
public class RoleIsNotAssignedToUser extends ThrowableMessage {
    private static final long serialVersionUID = 0L;

    /**
     * Creates a new instance.
     *
     * @param builder the builder for the rejection
     */
    private RoleIsNotAssignedToUser(Builder builder) {
        super(builder.rejectionMessage());
    }

    @Override
    public Rejections.RoleIsNotAssignedToUser messageThrown() {
        return (Rejections.RoleIsNotAssignedToUser) super.messageThrown();
    }

    /**
     * @return a new builder for the rejection
     */
    public static Builder newBuilder() {
        return new Builder();
    }

    /**
     * The builder for the {@code RoleIsNotAssignedToUser} rejection.
     */
    public static class Builder {
        private final Rejections.RoleIsNotAssignedToUser.Builder builder = Rejections.RoleIsNotAssignedToUser.newBuilder();

        /**
         * Prevent direct instantiation of the builder.
         */
        private Builder() {
        }

        public Builder setId(UserId id) {
            builder.setId(id);
            return this;
        }

        /**
         * <pre>
         *  An ID of a role.
         * </pre>
         */
        public Builder setRoleId(RoleId roleId) {
            builder.setRoleId(roleId);
            return this;
        }

        /**
         * Obtains the rejection and validates it.
         */
        private Rejections.RoleIsNotAssignedToUser rejectionMessage() {
            Rejections.RoleIsNotAssignedToUser message = builder.build();
            Validate.checkValid(message);
            return message;
        }

        /**
         * Creates the rejection from the builder and validates it.
         */
        public RoleIsNotAssignedToUser build() {
            return new RoleIsNotAssignedToUser(this);
        }
    }
}
